--
-- Host: localhost    Database: pmb410
-- ------------------------------------------------------
-- Server version	5.5.25-MariaDB

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

SET SQL_SAFE_UPDATES=0;

--
-- Traducción de tabla `abts_periodicites`
--

DROP TABLE IF EXISTS abts_periodicites_bak;
CREATE TABLE IF NOT EXISTS abts_periodicites_bak (
  periodicite_id int(10),
  libelle varchar(255), 
  PRIMARY KEY (periodicite_id))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO abts_periodicites_bak (periodicite_id,libelle) VALUES
(1,'Diario'),
(2,'Semanal'),
(3,'Quinzenal'),
(4,'Mensual'),
(5,'Bimestral'),
(6,'Trimestral'),
(7,'Quatrimestral'),
(8,'Semestral'),
(9,'Anual');

UPDATE abts_periodicites INNER JOIN abts_periodicites_bak 

ON abts_periodicites_bak.periodicite_id=abts_periodicites.periodicite_id 

SET abts_periodicites.libelle=abts_periodicites_bak.libelle;


DROP TABLE IF EXISTS abts_periodicites_bak;

--
-- Traducción de tabla `arch_emplacement`
--

DROP TABLE IF EXISTS arch_emplacement_bak;
CREATE TABLE IF NOT EXISTS arch_emplacement_bak (
  archempla_id	int(8),
  archempla_libelle varchar(255) , 
  PRIMARY KEY (archempla_id))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO arch_emplacement_bak(archempla_id,archempla_libelle) VALUES
(1,'Expositor');


UPDATE arch_emplacement INNER JOIN arch_emplacement_bak 

ON arch_emplacement_bak.archempla_id=arch_emplacement.archempla_id 

SET arch_emplacement.archempla_libelle=arch_emplacement_bak.archempla_libelle;

DROP TABLE IF EXISTS arch_emplacement_bak;

--
-- Traducción de tabla `arch_statut`
--

DROP TABLE IF EXISTS arch_statut_bak;
CREATE TABLE IF NOT EXISTS arch_statut_bak (
  archstatut_id	int(8),
  archstatut_gestion_libelle varchar(255),
  archstatut_opac_libelle varchar(255),  
  PRIMARY KEY (archstatut_id))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO arch_statut_bak(archstatut_id,archstatut_gestion_libelle,archstatut_opac_libelle) VALUES
(1,'Disponible en el sitio','Disponible en el sitio');


UPDATE arch_statut INNER JOIN arch_statut_bak 

ON arch_statut_bak.archstatut_id =arch_statut.archstatut_id  

SET arch_statut.archstatut_gestion_libelle=arch_statut_bak.archstatut_gestion_libelle,
    arch_statut.archstatut_opac_libelle=arch_statut_bak.archstatut_opac_libelle;

DROP TABLE IF EXISTS arch_statut_bak;

--
-- Traducción de tabla `arch_type`
--

DROP TABLE IF EXISTS arch_type_bak;
CREATE TABLE IF NOT EXISTS arch_type_bak (
  archtype_id	int(8),
  archtype_libelle varchar(255),
  PRIMARY KEY (archtype_id))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO arch_type_bak(archtype_id, archtype_libelle) VALUES
(1,'Revista' );


UPDATE arch_type INNER JOIN arch_type_bak 

ON arch_type_bak.archtype_id =arch_type.archtype_id  

SET arch_type.archtype_libelle=arch_type_bak.archtype_libelle;
   

DROP TABLE IF EXISTS arch_type_bak;

--
-- Traducción de tabla `caddie`
--

DROP TABLE IF EXISTS caddie_bak;
CREATE TABLE IF NOT EXISTS caddie_bak (
  idcaddie int(8),
  name	varchar(255),
  comment varchar(255), 
  PRIMARY KEY (idcaddie))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO caddie_bak(idcaddie, name, comment) VALUES
(1,'Reseñas para exposición','Incluir en esta cesta los Reseñas de la exposición virtual'),
(2,'Reseñas a devolver a BDP','Llenar esta cesta como control de los Reseñas que se han de devolver'),
(3,'Ejemplares a devolver a BDP','Llenar esta cesta con los ejemplares de los documentos a devolver a la BDP'),
(4,'Reseñas con el título duplicado','Duplicados del primer título'),
(5,'Loire - Reseñas para el tema del mes',''),
(6,'Loire - Números que contienen los artículos para la exposición del mes',''),
(7,'Cochon - Reseñas para la exposición del mes próximo','');

UPDATE caddie INNER JOIN caddie_bak 

ON caddie_bak.idcaddie =caddie.idcaddie  

SET caddie.name=caddie_bak.name,
    caddie.comment=caddie_bak.comment;
    
DROP TABLE IF EXISTS caddie_bak;

--
-- Traducción de tabla `caddie_procs`
--

DROP TABLE IF EXISTS caddie_procs_bak;
CREATE TABLE IF NOT EXISTS caddie_procs_bak (
  idproc smallint(5),
  name	varchar(255),
  comment tinytext,
  parameters	text, 
  PRIMARY KEY (idproc))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO caddie_procs_bak(idproc, name, comment,parameters) VALUES
(1,'Reseñas por autor','Selección de registro donde el nombre del autor contiene ciertas letras',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="critere" MANDATORY="yes">
  <ALIAS><![CDATA[Caracteres incluidos en el apellido]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>25</SIZE>
 <MAXSIZE>25</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(2,'Reseñas duplicados','Selección de las reseñas duplicadas por el título principal',''),
(3,'EXPL por sección/propietario','Selección de ejemplares por sección y por propietario',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="section" MANDATORY="yes">
  <ALIAS><![CDATA[Sección]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idsection, section_libelle from docs_section order by section_libelle]]></QUERY>
 <MULTIPLE>yes</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
 <FIELD NAME="proprio" MANDATORY="yes">
  <ALIAS><![CDATA[Proprietario]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY>select idlender, lender_libelle from lenders order by lender_libelle</QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(4,'EXPL que la signatura comienza por','Selección de ejemplares a partir del inicio de su signatura',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="comme_cote" MANDATORY="no">
  <ALIAS><![CDATA[Inicio de la signatura]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>20</SIZE>
 <MAXSIZE>20</MAXSIZE>
</OPTIONS> 
 </FIELD>
</FIELDS>'),
(6,'Nunca prestados','Añade a una cesta los ejemplares que nunca se han prestado',''),
(7,'Selección de ejemplares por estado','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="statut" MANDATORY="yes">
  <ALIAS><![CDATA[estado]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idstatut, statut_libelle from docs_statut]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(8,'Selección de ejemplares por localización, sección, estado, propietario','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="section" MANDATORY="yes">
  <ALIAS><![CDATA[Sección]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>
 <MULTIPLE>yes</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
 <FIELD NAME="location" MANDATORY="yes">
  <ALIAS><![CDATA[Localización]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>
 <MULTIPLE>yes</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
 <FIELD NAME="statut" MANDATORY="yes">
  <ALIAS><![CDATA[Estat/Estado]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idstatut, statut_libelle from docs_statut order by 2]]></QUERY>
 <MULTIPLE>yes</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
 <FIELD NAME="proprio" MANDATORY="yes">
  <ALIAS><![CDATA[Proprietario]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(10,'Mover boletines de una cesta a otra publicación periódica','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_perio" MANDATORY="yes">
  <ALIAS><![CDATA[Nuevo periodo]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select notice_id, tit1 from notices where niveau_biblio=''s'' and niveau_hierar=''1'' order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(11,'Selección/Marcado de boletines sin artículos','',''),
(13,'Selección/Marcado de boletines por fecha','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="dated" MANDATORY="yes">
  <ALIAS><![CDATA[fecha de inicio:]]></ALIAS>
  <TYPE>date_box</TYPE>
<OPTIONS FOR="date_box"></OPTIONS>
 </FIELD>
 <FIELD NAME="datef" MANDATORY="yes">
  <ALIAS><![CDATA[fecha de finalización:]]></ALIAS>
  <TYPE>date_box</TYPE>
<OPTIONS FOR="date_box"></OPTIONS>
 </FIELD>
</FIELDS>'),
(14,'Cambio de código estadístico de los ejemplares de una cesta','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_codestat" MANDATORY="yes">
  <ALIAS><![CDATA[Nuevo código estadístico]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(16,'Cambio de fecha de depósito de los ejemplares de una cesta','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_date_depot" MANDATORY="yes">
  <ALIAS><![CDATA[Nueva fecha de depósito]]></ALIAS>
  <TYPE>date_box</TYPE>
<OPTIONS FOR="date_box"></OPTIONS> 
 </FIELD>
</FIELDS>'),
(18,'Cambio de fecha de retorno de los ejemplares de una cesta','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_date_retour" MANDATORY="yes">
  <ALIAS><![CDATA[Nueva fecha de devolución]]></ALIAS>
  <TYPE>date_box</TYPE>
<OPTIONS FOR="date_box"></OPTIONS> 
 </FIELD>
</FIELDS>'),
(19,'Cambio de localización de los ejemplares de una cesta','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_location" MANDATORY="yes">
  <ALIAS><![CDATA[Nova localització >
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(20,'Cambio de mensaje de los ejemplares de una cesta','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_note" MANDATORY="no">
  <ALIAS><![CDATA[Nuevo mensaje]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>25</SIZE>
 <MAXSIZE>255</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(21,'Cambio de una parte de la valoración de los ejemplares de una cesta','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="motif_1" MANDATORY="no">
  <ALIAS><![CDATA[Reemplazar]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>10</SIZE>
 <MAXSIZE>10</MAXSIZE>
</OPTIONS> 
 </FIELD>
 <FIELD NAME="motif_2" MANDATORY="no">
  <ALIAS><![CDATA[Por]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>10</SIZE>
 <MAXSIZE>10</MAXSIZE>
</OPTIONS> 
 </FIELD>
</FIELDS>'),
(22,'Cambio del precio de los ejemplares de una cesta','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_prix" MANDATORY="no">
  <ALIAS><![CDATA[Nuevo precio]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>10</SIZE>
 <MAXSIZE>255</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(23,'Cambio de sección de los ejemplares de una cesta','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_section" MANDATORY="yes">
  <ALIAS><![CDATA[Nueva sección]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(24,'Cambio de estado de los ejemplares de una cesta','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_statut" MANDATORY="yes">
  <ALIAS><![CDATA[Nuevo estado]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idstatut, statut_libelle from docs_statut order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(25,'Cambio de soporte de los ejemplares de una cesta','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_typdoc" MANDATORY="yes">
  <ALIAS><![CDATA[Nuevo soporte]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(26,'Selección/Marcado de ejemplares con préstamo en curso','',''),
(27,'Selección de ejemplares desde un archivo de código de barras','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="fichier" MANDATORY="yes">
  <ALIAS><![CDATA[fichero]]></ALIAS>
  <TYPE>file_box</TYPE>
<OPTIONS FOR="file_box">
 <METHOD>1</METHOD>
 <TEMP_TABLE_NAME></TEMP_TABLE_NAME>
 <DATA_TYPE>1</DATA_TYPE>
</OPTIONS> 
 </FIELD>
</FIELDS>'),
(30,'Cambio de la indexación decimal de reseñas de una cesta','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="nouvelle_indexation" MANDATORY="yes">
  <ALIAS><![CDATA[Nueva indexación]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select indexint_id, concat(indexint_name,' ', indexint_comment) from indexint order by indexint_name]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(31,'Cambio de estado de reseñas de una cesta','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_statut" MANDATORY="yes">
  <ALIAS><![CDATA[Nuevo estado]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select id_notice_statut, gestion_libelle from notice_statut order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(32,'Cambio de tipo de documento de reseñas de una cesta','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_typdoc" MANDATORY="yes">
  <ALIAS><![CDATA[Nuevo tipo de documento]]></ALIAS>
  <TYPE>list</TYPE>
<OPTIONS FOR="list">
 <MULTIPLE>no</MULTIPLE>
 <ITEMS>
  <ITEM VALUE="b"><![CDATA[texto manuscrito]]></ITEM>
  <ITEM VALUE="c"><![CDATA[partitura musical impresa]]></ITEM>
  <ITEM VALUE="d"><![CDATA[partitura musical manuscrita]]></ITEM>
  <ITEM VALUE="e"><![CDATA[documento manuscrito impreso]]></ITEM>
  <ITEM VALUE="f"><![CDATA[documento manuscrito impreso]]></ITEM>
  <ITEM VALUE="g"><![CDATA[document projectado o video]]></ITEM>
  <ITEM VALUE="i"><![CDATA[registro sonono no musical]]></ITEM>
  <ITEM VALUE="j"><![CDATA[registro sonoro musical]]></ITEM>
  <ITEM VALUE="k"><![CDATA[registro gráfico bidimensional]]></ITEM>
  <ITEM VALUE="l"><![CDATA[documento electrónico]]></ITEM>
  <ITEM VALUE="m"><![CDATA[documento multimedia]]></ITEM>
  <ITEM VALUE="r"><![CDATA[objeto de 3 dimensiones, artefactos, ...]]></ITEM>
 </ITEMS>
 <UNSELECT_ITEM VALUE="a"><![CDATA[texto impreso]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(33,'Copia los autores de reseñas madre de una cesta a sus reseñas hijas','Sólo agrega autores a aquellas reseñas hijas que todavía no tienen autor establecido',''),
(34,'Selección/Marcado de reseñas con reseñas hijas','',''),
(35,'Selección/Marcado de reseñas con reseña madre','',''),
(36,'Selección/Marcado de reseñas por tipo de documento y estado','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="type_doc" MANDATORY="yes">
  <ALIAS><![CDATA[Tipo de documento]]></ALIAS>
  <TYPE>list</TYPE>
<OPTIONS FOR="list">
 <MULTIPLE>no</MULTIPLE>
 <ITEMS>
  <ITEM VALUE="a"><![CDATA[texto impreso]]></ITEM>
  <ITEM VALUE="b"><![CDATA[texto manuscrito]]></ITEM>
  <ITEM VALUE="c"><![CDATA[partitura musical impresa]]></ITEM>
  <ITEM VALUE="d"><![CDATA[partitura musical manuscrita]]></ITEM>
  <ITEM VALUE="e"><![CDATA[documento manuscrito impreso]]></ITEM>
  <ITEM VALUE="f"><![CDATA[documento manuscrito impreso]]></ITEM>
  <ITEM VALUE="g"><![CDATA[documento projectado o video]]></ITEM>
  <ITEM VALUE="i"><![CDATA[registro sonono no musical]]></ITEM>
  <ITEM VALUE="j"><![CDATA[registro sonoro musical]]></ITEM>
  <ITEM VALUE="k"><![CDATA[registro gráfico bidimensional]]></ITEM>
  <ITEM VALUE="l"><![CDATA[documento electrónico]]></ITEM>
  <ITEM VALUE="m"><![CDATA[documento multimedia]]></ITEM>
  <ITEM VALUE="r"><![CDATA[objeto de 3 dimensiones, artefactos, ...]]></ITEM>
 </ITEMS>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
 <FIELD NAME="statut" MANDATORY="yes">
  <ALIAS><![CDATA[Statut notice]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY>select id_notice_statut, gestion_libelle from notice_statut order by 2</QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(37,'Selección/Marcado de reseñas sin reseña hija ni reseña madre','',''),
(39,'Selección de ejemplares no prestados después de una determinada fecha','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="dat" MANDATORY="yes">
  <ALIAS><![CDATA[Fecha último préstamo <]]></ALIAS>
  <TYPE>date_box</TYPE>
<OPTIONS FOR="date_box"></OPTIONS>
 </FIELD>
</FIELDS>'),
(5,'Cambio de estado de los ejemplares','Permite cambiar el estado de los ejemplares de una cesta',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="nouveau_statut" MANDATORY="yes">
  <ALIAS><![CDATA[Nuevo estado]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY>SELECT idstatut, statut_libelle FROM docs_statut</QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(9,'Cambiar la sección de los ejemplares','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="nouvelle_section" MANDATORY="yes">
  <ALIAS><![CDATA[Nueva sección]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select * from docs_section order by section_libelle]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[Escoge una sección]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>');

UPDATE caddie_procs INNER JOIN caddie_procs_bak 

ON caddie_procs_bak.idproc =caddie_procs.idproc  

SET caddie_procs.name=caddie_procs_bak.name,
    caddie_procs.comment=caddie_procs_bak.comment,
    caddie_procs.parameters=caddie_procs_bak.parameters;
    
    
DROP TABLE IF EXISTS caddie_procs_bak;

--
-- Traducción de tabla `docs_codestat`
--

DROP TABLE IF EXISTS docs_codestat_bak;
CREATE TABLE IF NOT EXISTS docs_codestat_bak (
  idcode smallint(5),
  codestat_libelle varchar(255), 
  PRIMARY KEY (idcode))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO docs_codestat_bak(idcode,codestat_libelle) VALUES
(10,'Indeterminado'),
(11,'Jóvenes'),
(12,'Adultos');

UPDATE docs_codestat INNER JOIN docs_codestat_bak 

ON docs_codestat_bak.idcode =docs_codestat.idcode  

SET docs_codestat.codestat_libelle=docs_codestat_bak.codestat_libelle;

DROP TABLE IF EXISTS docs_codestat_bak;

--
-- Traducción de tabla `docs_section'
--

DROP TABLE IF EXISTS docs_section_bak;
CREATE TABLE IF NOT EXISTS docs_section_bak (
  idsection smallint(5), 
  section_libelle varchar(255), 
  PRIMARY KEY (idsection))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO docs_section_bak(idsection,section_libelle) VALUES
(10,'Documentales'),
(11,'Documentales Infantiles'),
(12,'Novelas Infantiles'),
(13,'Novelas Juveniles'),
(16,'Cómics Adultos'),
(17,'Cómics Infantiles'),
(18,'H (Historia local)'),
(19,'FR (Fondo regional)'),
(20,'Cómics Juveniles'),
(21,'Novelas policíacas'),
(23,'Novelas letra grande'),
(24,'Novelas & Novelas extranjeras'),
(25,'Documentales Juveniles'),
(26,'Cuentos Infantiles');


UPDATE docs_section INNER JOIN docs_section_bak 

ON docs_section_bak.idsection =docs_section.idsection  

SET docs_section.section_libelle=docs_section_bak.section_libelle;

DROP TABLE IF EXISTS docs_section_bak;

--
-- Traducción de tabla `docs_statut`
--

DROP TABLE IF EXISTS docs_statut_bak;
CREATE TABLE IF NOT EXISTS docs_statut_bak (
  idstatut smallint(5),
  statut_libelle varchar(255), 
  PRIMARY KEY (idstatut))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO docs_statut_bak(idstatut,statut_libelle) VALUES
(1,'Documento en buen estado'),
(2,'En curso de importación/adquisición'),
(11,'Deteriorado'),
(12,'Perdido'),
(13,'Consulta en sala'),
(14,'En deposito');


UPDATE docs_statut INNER JOIN docs_statut_bak 

ON docs_statut_bak.idstatut =docs_statut.idstatut  

SET docs_statut.statut_libelle=docs_statut_bak.statut_libelle;

DROP TABLE IF EXISTS docs_statut_bak;

--
-- Traducción de tabla `docs_type`
--

DROP TABLE IF EXISTS docs_type_bak;
CREATE TABLE IF NOT EXISTS docs_type_bak (
  idtyp_doc int(5), 
  tdoc_libelle varchar(255), 
  PRIMARY KEY (idtyp_doc))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO docs_type_bak(idtyp_doc,tdoc_libelle) VALUES
(1,'Libro'),
(12,'Cinta de vídeo'),
(13,'CD audio'),
(14,'DVD'),
(15,'Obra de arte'),
(16,'Tarjetas y planos'),
(17,'Cederrones'),
(18,'Publicaciones periódicas');

UPDATE docs_type INNER JOIN docs_type_bak 

ON docs_type_bak.idtyp_doc =docs_type.idtyp_doc 

SET docs_type.tdoc_libelle=docs_type_bak.tdoc_libelle;

DROP TABLE IF EXISTS docs_type_bak;

--
-- Traducción de tabla `empr_caddie`
--

DROP TABLE IF EXISTS empr_caddie_bak;
CREATE TABLE IF NOT EXISTS empr_caddie_bak (
  idemprcaddie	int(8), 
  name varchar(100), 
  PRIMARY KEY (idemprcaddie))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO empr_caddie_bak(idemprcaddie,name) VALUES
(1,'Panel de lectors');

UPDATE empr_caddie INNER JOIN empr_caddie_bak 

ON empr_caddie_bak.idemprcaddie =empr_caddie.idemprcaddie 

SET empr_caddie.name=empr_caddie_bak.name;

DROP TABLE IF EXISTS empr_caddie_bak;


--
-- Traducción de tabla `empr_caddie`
--

DROP TABLE IF EXISTS empr_caddie_procs_bak;
CREATE TABLE IF NOT EXISTS empr_caddie_procs_bak (
  idproc smallint(5),
  name	varchar(255),
  parameters	text  ,  
  PRIMARY KEY (idproc))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO  empr_caddie_procs_bak(idproc,name,parameters) VALUES
(1,'Cambio de ubicación de lectores de una cesta',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_location" MANDATORY="yes">
  <ALIAS><![CDATA[Nueva ubicación]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(2,'Cambio de categoría de lectores de una cesta',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_categ" MANDATORY="yes">
  <ALIAS><![CDATA[Nueva categoría]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select id_categ_empr, libelle from empr_categ order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(3,'Cambio de ciudad de lectores de una cesta',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_ville" MANDATORY="no">
  <ALIAS><![CDATA[Nueva ciudad]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>25</SIZE>
 <MAXSIZE>255</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(4,'Cambio de código postal de lectores de una cesta',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_cp" MANDATORY="no">
  <ALIAS><![CDATA[Nuevo código postal]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>10</SIZE>
 <MAXSIZE>10</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(5,'Cambio de país de lectores de una cesta',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_pays" MANDATORY="no">
  <ALIAS><![CDATA[Nou país/Nuevo país]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>25</SIZE>
 <MAXSIZE>255</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(6,'Cambio de estado de lectores de una cesta',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="nouveau_statut" MANDATORY="yes">
  <ALIAS><![CDATA[Nuevo estado]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idstatut, statut_libelle from empr_statut order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(7,'Cambio de código estadístico de lectores de una cesta',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_codestat" MANDATORY="yes">
  <ALIAS><![CDATA[Nuevo código estadístico]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idcode, libelle from empr_codestat order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(8,'Cambio de contraseñana de lectores de una cesta',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_password" MANDATORY="no">
  <ALIAS><![CDATA[Nueva contraseña]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>10</SIZE>
 <MAXSIZE>10</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(9,'Cambio de fecha de inicio de afiliación de lectores de una cesta',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_date_adhesion" MANDATORY="yes">
  <ALIAS><![CDATA[Nueva fecha de inicio de afiliación]]></ALIAS>
  <TYPE>date_box</TYPE>
<OPTIONS FOR="date_box"></OPTIONS> 
 </FIELD>
</FIELDS>'),
(10,'Cambio de fecha de fin de afiliación de lectores de una cesta',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_date_expiration" MANDATORY="yes">
  <ALIAS><![CDATA[Nueva fecha de fin de afiliación]]></ALIAS>
  <TYPE>date_box</TYPE>
<OPTIONS FOR="date_box"></OPTIONS> 
 </FIELD>
</FIELDS>'),
(11,'Cambio de sexo de lectores de una cesta',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_sexe" MANDATORY="yes">
  <ALIAS><![CDATA[Nuevo sexo]]></ALIAS>
  <TYPE>list</TYPE>
<OPTIONS FOR="list">
 <MULTIPLE>no</MULTIPLE>
 <ITEMS>
  <ITEM VALUE="1"><![CDATA[Masculino]]></ITEM>
  <ITEM VALUE="2"><![CDATA[Femenino]]></ITEM>
  <ITEM VALUE="0"><![CDATA[Indeterminado]]></ITEM>
 </ITEMS>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(14,'Cambio de mensaje de lectores de una cesta',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_msg" MANDATORY="no">
  <ALIAS><![CDATA[Nuevo mensaje]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>25</SIZE>
 <MAXSIZE>255</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(16,'Selección/Marcado de lectores sin correo electrónico',
''),
(18,'Incorporación de lectores de una cesta a una lista de distribución pública (DSI)',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="bannette" MANDATORY="yes">
  <ALIAS><![CDATA[lista de distribución]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select id_bannette, nom_bannette from bannettes where proprio_bannette=0 order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(19,'Desincorporación de lectores de una cesta a una lista de distribución pública (DSI)',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="bannette" MANDATORY="yes">
  <ALIAS><![CDATA[llista de distribució / lista de distribución]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select id_bannette, nom_bannette from bannettes where proprio_bannette=0 order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(21,'Cambio de profesión de lectores de una cesta',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_prof" MANDATORY="no">
  <ALIAS><![CDATA[Nueva profesión]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>25</SIZE>
 <MAXSIZE>255</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(22,'Cambio de tipo de abono de lectores de una cesta',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_type_abt" MANDATORY="no">
  <ALIAS><![CDATA[Nuevo tipo de abono]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select id_type_abt, type_abt_libelle from type_abts order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE="0"><![CDATA[No definido]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>');


UPDATE empr_caddie_procs INNER JOIN empr_caddie_procs_bak 

ON empr_caddie_procs_bak.idproc=empr_caddie_procs.idproc

SET empr_caddie_procs.name=empr_caddie_procs_bak.name,
     empr_caddie_procs.parameters=empr_caddie_procs_bak.parameters;

DROP TABLE IF EXISTS empr_caddie_procs_bak;


--
-- Traducción de tabla `empr_categ`
--

DROP TABLE IF EXISTS empr_categ_bak;
CREATE TABLE IF NOT EXISTS empr_categ_bak (
  id_categ_empr	smallint(5), 
  libelle varchar(255), 
  PRIMARY KEY (id_categ_empr))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO empr_categ_bak(id_categ_empr,libelle) VALUES
(1,'Niños'),
(2,'Jubilados'),
(3,'Empleados'),
(4,'Sin empleo'),
(5,'Alumnos de secundaria/Estudiantes'),
(6,'Colegiales'),
(7,'Adultos');


UPDATE empr_categ INNER JOIN empr_categ_bak 

ON empr_categ_bak.id_categ_empr =empr_categ.id_categ_empr

SET empr_categ.libelle=empr_categ_bak.libelle;

DROP TABLE IF EXISTS empr_categ_bak;


--
-- Traducción de tabla `empr_codestat`
--

DROP TABLE IF EXISTS empr_codestat_bak;
CREATE TABLE IF NOT EXISTS empr_codestat_bak (
  idcode smallint(5), 
  libelle varchar(255), 
  PRIMARY KEY (idcode))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO empr_codestat_bak(idcode,libelle) VALUES
(2,'Comunitad de Municipios'),
(3,'Municipio'),
(4,'Departamento'),
(5,'Europa'),
(6,'Fuera de Europa'),
(7,'Francia');


UPDATE empr_codestat INNER JOIN empr_codestat_bak 

ON empr_codestat_bak.idcode =empr_codestat.idcode

SET empr_codestat.libelle=empr_codestat_bak.libelle;

DROP TABLE IF EXISTS empr_codestat_bak;


--
-- Traducción de tabla `empr_statut`
--

DROP TABLE IF EXISTS empr_statut_bak;
CREATE TABLE IF NOT EXISTS empr_statut_bak (
  idstatut smallint(5), 
  statut_libelle varchar(255), 
  PRIMARY KEY (idstatut))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO empr_statut_bak(idstatut,statut_libelle) VALUES
(1,'Activo'),
(2,'Prohibido');


UPDATE empr_statut INNER JOIN empr_statut_bak 

ON empr_statut_bak.idstatut =empr_statut.idstatut

SET empr_statut.statut_libelle=empr_statut_bak.statut_libelle;

DROP TABLE IF EXISTS empr_statut_bak;


--
-- Traducción de tabla `expl_custom`
--

DROP TABLE IF EXISTS expl_custom_bak;
CREATE TABLE IF NOT EXISTS expl_custom_bak (
  idchamp int(10), 
  titre	varchar(255),  
  PRIMARY KEY (idchamp))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO expl_custom_bak(idchamp,titre) VALUES
(2,'Origen'),
(3,'Data d`adquisició / Fecha de adquisición'),
(4,'Data de destrucció / Fecha de destrucción');



UPDATE expl_custom INNER JOIN expl_custom_bak 

ON expl_custom_bak.idchamp =expl_custom.idchamp

SET expl_custom.titre=expl_custom_bak.titre;

DROP TABLE IF EXISTS expl_custom_bak;


--
-- Traducción de tabla `expl_custom_lists`
--

DROP TABLE IF EXISTS expl_custom_lists_bak;
CREATE TABLE IF NOT EXISTS expl_custom_lists_bak (
  expl_custom_list_value varchar(255) , 
  expl_custom_list_lib	varchar(255))

ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO expl_custom_lists_bak(expl_custom_list_value,expl_custom_list_lib) VALUES
('DEP','Depósito'),
('DON','Donación'),
('ACH','Compra');


UPDATE expl_custom_lists INNER JOIN expl_custom_lists_bak 

ON expl_custom_lists_bak.expl_custom_list_value =expl_custom_lists.expl_custom_list_value

SET expl_custom_lists.expl_custom_list_lib=expl_custom_lists_bak.expl_custom_list_lib;

DROP TABLE IF EXISTS expl_custom_lists_bak;

--
-- Traducción de tabla `facettes`
--

DROP TABLE IF EXISTS facettes_bak;
CREATE TABLE IF NOT EXISTS facettes_bak (
  id_facette int(10),
  facette_name	varchar(255),
  PRIMARY KEY(id_facette))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO facettes_bak(id_facette,facette_name) VALUES
(1,'Categorías'),
(2,'Ubicación'),
(3,'Palabra clave'),
(4,'Sección'),
(5,'Tipo de documento'),
(6,'Tipo de registro');

UPDATE facettes INNER JOIN facettes_bak 

ON facettes_bak.id_facette =facettes.id_facette

SET facettes.facette_name=facettes_bak.facette_name;

DROP TABLE IF EXISTS facettes_bak;


--
-- Traducción de tabla `infopages`
--

DROP TABLE IF EXISTS infopages_bak;
CREATE TABLE IF NOT EXISTS infopages_bak (
  id_infopage	int(10),
  title_infopage varchar(255) ,
  PRIMARY KEY(id_infopage))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO infopages_bak(id_infopage,title_infopage) VALUES
(1,'Noticias encontradas'),
(2,'PMB Versión 4.1'),
(6,'Nos encontramos'),
(7,'Mención legal'),
(3,'Ayuda en línea'),
(4,'Consultar Calendario'),
(5,'Ayuda en la búsquea sencilla');



UPDATE infopages INNER JOIN infopages_bak 

ON infopages_bak.id_infopage =infopages.id_infopage

SET infopages.title_infopage=infopages_bak.title_infopage;

DROP TABLE IF EXISTS infopages_bak;


--
-- Traducción de tabla `lenders`
--


DROP TABLE IF EXISTS lenders_bak;
CREATE TABLE IF NOT EXISTS lenders_bak (
  idlender smallint(5),
  lender_libelle varchar(255),
  PRIMARY KEY(idlender))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO lenders_bak(idlender,lender_libelle) VALUES
(1,'BDP'),
(2,'Fondo propio');


UPDATE lenders INNER JOIN lenders_bak 

ON lenders_bak.idlender =lenders.idlender

SET lenders.lender_libelle=lenders_bak.lender_libelle;

DROP TABLE IF EXISTS lenders_bak;


--
-- Traducción de tabla `noeuds`
--

DROP TABLE IF EXISTS noeuds_bak;
CREATE TABLE IF NOT EXISTS noeuds_bak (
  id_noeud int(9),
  autorite varchar(255),
  PRIMARY KEY(id_noeud))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO noeuds_bak(id_noeud,autorite) VALUES
(1,'SUPERIOR'),
(2,'SIN CLASIFICAR'),
(3,'HUERFÁNOS');


UPDATE noeuds INNER JOIN noeuds_bak 

ON noeuds_bak.id_noeud =noeuds.id_noeud

SET noeuds.autorite=noeuds_bak.autorite;

DROP TABLE IF EXISTS noeuds_bak;

--
-- Traducción de tabla `notice_statut`
--


DROP TABLE IF EXISTS origine_notice_bak;
CREATE TABLE IF NOT EXISTS origine_notice_bak (
  orinot_id	int(8),
  orinot_nom	varchar(255),
  PRIMARY KEY(orinot_id))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO origine_notice_bak(orinot_id, orinot_nom) VALUES
(3,'Catálogo interno'),
(2,'BnF'),
(1,'Catálogo interno'),
(4,'FR-751131015');


UPDATE origine_notice INNER JOIN origine_notice_bak 

ON origine_notice_bak.orinot_id =origine_notice.orinot_id

SET origine_notice.orinot_nom=origine_notice_bak.orinot_nom;

DROP TABLE IF EXISTS origine_notice_bak;


--
-- Traducción de tabla `notice_statut`
--

DROP TABLE IF EXISTS notice_statut_bak;
CREATE TABLE IF NOT EXISTS notice_statut_bak (
  id_notice_statut smallint(5),
  gestion_libelle varchar(255),
  opac_libelle	varchar(255),
  PRIMARY KEY(id_notice_statut))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO notice_statut_bak(id_notice_statut,gestion_libelle,opac_libelle) VALUES
(1,'Sin Estado',''),
(2,'Préstamo rápido',''),
(3,'Ordenado','Ordenado'),
(4,'En proceso de importación/recuperación','');


UPDATE notice_statut INNER JOIN notice_statut_bak 

ON notice_statut_bak.id_notice_statut =notice_statut.id_notice_statut

SET notice_statut.gestion_libelle=notice_statut_bak.gestion_libelle,
     notice_statut.opac_libelle=notice_statut_bak.opac_libelle;

DROP TABLE IF EXISTS notice_statut_bak;


--
-- Traducción de tabla `origin_authorities`
--

DROP TABLE IF EXISTS origin_authorities_bak;
CREATE TABLE IF NOT EXISTS origin_authorities_bak (
  id_origin_authorities	int(10),
  origin_authorities_name varchar(255),
  PRIMARY KEY(id_origin_authorities))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO origin_authorities_bak(id_origin_authorities, origin_authorities_name) VALUES
(1,'Catáleg intern/Catálogo interno'),
(2,'BnF');


UPDATE origin_authorities INNER JOIN origin_authorities_bak 

ON origin_authorities_bak.id_origin_authorities =origin_authorities.id_origin_authorities

SET origin_authorities.origin_authorities_name=origin_authorities_bak.origin_authorities_name;

DROP TABLE IF EXISTS origin_authorities_bak;


--
-- Traducción de tabla `procs`
--

DROP TABLE IF EXISTS procs_bak;
CREATE TABLE IF NOT EXISTS procs_bak(
idproc smallint(5),
name varchar(255),
comment tinytext,
parameters text,
PRIMARY KEY (idproc))

ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO procs_bak(idproc,name,comment,parameters) VALUES
(169,'Permiso para utilizar todos los procedimientos a todos los usuarios','Permite a todos los usuarios utilizar todos los procedimientos',''),
(170,'Permiso para utilizar todos los procedimientos de las cestas del catálogo','Permite a todos los usuarios utilizar todos los procedimientos de las cestas del catálogo',''),
(171,'Permiso para utilizar todos los procedimientos de las cestas de lectores','Permite a todos los usuarios utilizar todos los procedimientos de las cestas de lectores',''),
(184,'Número de lectores por categoría','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categ_lecteur\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoria de lectores]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(185,'Número de lectores por código estadístico','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"codestat_lecteur\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Código estadístico]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode,libelle from empr_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(186,'Número de lectores por estado','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"statut_lecteur\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estado del lector]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idstatut, statut_libelle from empr_statut order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(192,'Catálogo:número de registros monografías(total, establecido durante el año y lo importado durante el año','A ejecutar en Administración>Acciones Personalizadas','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(193,'Préstamos: Cuenta de préstamos/categoría de lectores/tipo de documento','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"anneee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(194,'Gastos de adquisiciones documentales','Suma del campo precio por ejemplar','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es):]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(195,'Colecciones: Documentos audiovisuales y otros Otros Documentos: Adquisiciones','A ejecutar en Administración>Acciones Personalizadas','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(196,'Colecciones: Adquisiones impresas: número de títulos y unidades por propietario y código estadístico','A ejecturar en Administración>Acciones Personalizadas','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(197,'Colecciones: Documentos audiovisuales y Otros Documentos: Eliminaciones','A ejecutar en Administración>Acciones Personalizadas','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixstatutpilon\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[¿ Cúal es el estado de los ejemplares a eliminar ? :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idstatut,statut_libelle from docs_statut order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(198,'Colecciones: Documentos audiovisuales y Otros Documentos: Unidades del fondo propio','Manuscritos, Documentos cartográficos, Música impresa, Documentos gráficos, Documentos audiovisuales, Otros documentos. A ejecutar en Administración>Acciones Personalizadas','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[choixloca]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS></OPTIONS>\n </FIELD>\n</FIELDS>'),
(199,'Colecciones: Eliminaciones impresos:número de títulos y unidades por propietario y código estadístico','A ejecutar en Administración: Acciones Personalizadas','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixstatutpilon\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Cúal es el estado de los ejemplares a eliminar ? :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idstatut, statut_libelle from docs_statut order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(200,'Colecciones: Impresos: Número de títulos y unidades por propietario y código estadístico','A ejecutar en Administracción: Acciones Personalizadas','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(201,'Colecciones: Publicaciones seriadas actuales por código estadístico','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario : ]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(202,'Lectores: Cuentas de usuarios activos por categoría y código estadístico (A ejecutar imperativamente a final de año)','Un usuario esta activo si tiene un carnet válido y pidió prestado un libro en el año indicado','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localisation(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoría(s):]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(203,'Lectores: Cuentas de usuarios activos por categoría, edad y sexo (a ejecutar imperativamente a final de año)','Un usuario esta activo si tiene un carnet válido y pidió prestado un libro en el año indicado','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoría(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(204,'Lectores: Cuentas de usuarios activos (carnet válido dentro del año indicado)','Por categoría, edad y sexo','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoría(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(205,'Lectores: Cuentas de usuarios activos por código estadístico (carnet válido dentro del año indicado)','Por categoría y código estadístico','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoría(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(206,'Lectores: Cuentas de nuevos inscritos','Lectores inscritos dentro del año indicado por categoría, edad y sexo','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Année :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoría(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(207,'Lectores: Cuentas de nuevos inscritos por código estadístico','Lectores inscritos dentro del año indicado por categoría y código estadístico','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoría (s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(208,'Número de ejemplares comprados/donados en un año /soporte / Localización / Código Estadístico / Sección','Utilize esta estadística si el campo \"fecha de compra"\ esta informado','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idlocation, location_libelle FROM docs_location ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(209, 'Número de ejemplares comprados/donados en un año /soporte / Sección','Utilize esta estadística si el campo \"fecha de compra"\ esta informado','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"section\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idsection, section_libelle FROM docs_section ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"suppoort\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idtyp_doc, tdoc_libelle FROM docs_type ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(210,'Número de ejemplares comprados por sección y localización por año en función de la fecha de compra','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>Select idlocation, location_libelle FROM docs_location ORDER BY location_libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"anneeencours\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año en curso]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS></OPTIONS>\n </FIELD>\n</FIELDS>'),
(211,'Número de ejemplares creados por sección y localización por año en curso','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>Select idlocation, location_libelle FROM docs_location ORDER BY location_libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"anneeencours\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año en curso]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS></OPTIONS>\n </FIELD>\n</FIELDS>'),
(212,'Número de documentos comprados y donados','durante un año y por soporte / Localización / Código Estadístico','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>Select idlocation, location_libelle FROM docs_location ORDER BY location_libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"anneeencours\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año en curso]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS></OPTIONS>\n </FIELD>\n</FIELDS>'),
(213,'Número de documentos comprados, donados o tomados por Estado, Soporte y Sección','','xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"anneeacq\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"supoort\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idtyp_doc, tdoc_libelle FROM docs_type ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idsection, section_libelle FROM docs_section ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(214,'Número de ejemplares por sección','',''),
(215,'Número de ejemplares por código estadístico','',''),
(216,'Número de ejemplares por nota','Teniendo en cuenta la nota en su totalidad',''),
(217,'Número de ejemplares por inicio de nota 1','3 primeros caracteres de la nota / clasificación en nota',''),
(218,'Número de ejemplares por inicio de nota 2','3 primeros caracteres de la notas / clasificación en frecuencia de utilización',''),
(219,'Número de ejemplares por inicio de nota y por localización','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[localización]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idlocation, location_libelle FROM docs_location ORDER BY 2]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(220,'Número de ejemplares por inicio de nota, localización y sección','3 primeros caracteres de la notas / clasificación en frecuencia de utilización','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idsection, section_libelle FROM docs_section ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(221,'Número de ejemplares por localización','',''),
(222,'Número de ejemplares por localización/código estadístico','',''),
(223,'Número de ejemplares por localización/sección','',''),
(224,'Número de ejemplares por localización/estado','',''),
(225,'Número de ejemplares por localización/soporte','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(226,'Número de ejemplares por orígen de ejemplar','','xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(227,'Número de ejemplares por propietario','',''),
(228,'Número de ejemplares eliminados','Por localización, soporte y código estadístico','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(229,'Número de ejemplares por propietario/código estadístico','',''),
(231,'Número de ejemplares por propietario/localización','',''),
(232,'Número de ejemplares por propietario/localización/código estadístico','',''),
(233,'Número de ejemplares por propietario/localización/sección','',''),
(234,'Número de ejemplares por propietario/localización/sección/soporte/ código estadístico','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idsection, section_libelle FROM docs_section ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"codestatt\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Código Estadístico]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idcode, codestat_libelle FROM docs_codestat ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"typdocc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idtyp_doc, tdoc_libelle FROM docs_type ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"proprioo\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idlender, lender_libelle FROM lenders ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(235,'Número de ejemplares por propietario/localización/estado','',''),
(236,'Número de ejemplares por propietario/localización/soporte','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(238,'Número de ejemplares por propietario/sección','',''),
(240,'Número de ejemplares por propietario/estado/localización/sección/soporte/código estadístico','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idsection, section_libelle FROM docs_section ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"codestatt\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Código Estadístico]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idcode, codestat_libelle FROM docs_codestat ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"typdocc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idtyp_doc, tdoc_libelle FROM docs_type ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"proprioo\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlender, lender_libelle FROM lenders ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"statutt\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estado]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idstatut, statut_libelle FROM docs_statut ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(241,'Número de ejemplares por propietario/soporte','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(242,'Número de ejemplares por propietario/soporte/código estadístico','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idsection, section_libelle FROM docs_section ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"codestatt\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Código Estadístico]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idcode, codestat_libelle FROM docs_codestat ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"typdocc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soportet]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idtyp_doc, tdoc_libelle FROM docs_type ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"proprioo\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idlender, lender_libelle FROM lenders ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(243,'Número de ejemplares por estado','',''),
(244,'Número de ejemplares por soporte','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(245,'Número de ejemplares por soporte/localización/sección','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(246,' Número de ejemplares por tipo de documento','',''),
(248,'Número de lectores','',''),
(249,'Número de lectores por tipo de abono','',''),
(250,'Número de lectores por tipo de abono donde la fecha de inscripción esta dentro del periodo indicado','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(251,'Número de lectores por tipo de abono donde la fecha de caducidad esta dentro del periodo indicado','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(252,'Número de lectores activos por tipo de abono','',''),
(253,'Número de lectores activos por categoría para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[categoría]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT id_categ_empr, libelle FROM empr_categ ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(254,'Número de lectores activos por código estadístico/sexo/tramo de edad para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año de cálculo :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(255,'Número de lectores activos por código estadístico/tramo de edad para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año de cálculo :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(256,'Número de lectores activos por sexo y tramo de edad para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año de cálculo :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoría]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by libelle</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(257,'Número de lectores activos por sexo, tramo de edad y ciudad para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año de cálculo :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(258,'Número de lectores activos por tramo de edad para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año de cálculo :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(259,'Número de lectores activos por municipio de residencia para una o varias categorías','Atención: sólo tiene en cuenta a los lectores cuya fecha de inicio o final de inscripción esta dentro del año indicado','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoría :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año de cálculo :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(261,'Número de lectores por categoría donde la fecha de inscripción esta dentro del periodo indicado','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[categoría]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT id_categ_empr, libelle FROM empr_categ ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(262,'Número de lectores por categoría donde la fecha de caducidad esta dentro del periodo indicado','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[categoría]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT id_categ_empr, libelle FROM empr_categ ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(263,'Número de lectores por categoría y localización','',''),
(265,'Número de lectores por código estadístico y sexo','',''),
(267,'Número de lectores por código estadístico/sexo/tramo de edad donde la fecha de caducidad esta dentro del periodo indicado','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[categoría]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT id_categ_empr, libelle FROM empr_categ ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(268,'Número de lectores por código estadístico/sexo/tramo de edad donde la fecha de inscripción esta dentro del periodo indicado','','xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año de cálculo :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(270,'Número de lectores por fecha de fin de inscripción','Número de lectores donde la fecha de caducidad del abono=año indicado','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"anneee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año de finalización del abono]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(271,'Número de lectore con deuda','',''),
(272,'Número de lectores con deuda/montante','',''),
(273,'Número de lectores que pidieron préstamos por tipo de abono para un día','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fecha :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(274,'Número de lectores que pidieron préstamos por tipo de abono para un periodo y una localización','se basa en el histórico de préstamos (duración 120 días)','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Desde :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Hasta :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"localisation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[localización :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idlocation, location_libelle FROM docs_location ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(275,'Número de lectores que pidieron préstamos por sección y por localización para un periodo','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Desde :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Hasta :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(276,'Número de lectores por localización','A condición de que se pueda localizar a los lectores','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(277,'Número de lectores por sexo','',''),
(281,'Número de lectores por municipio de residencia donde la fecha de inscripción esta dentro del periodo indicado','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(282,'Número de lectores por municipio de residencia donde la fecha de caducidad esta dentro del periodo indicado','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(283,'Número de préstamos en curso por localización','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"localisation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[elegir una localización :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(284,'Número de préstamos /a principio de marca/semana/mes/año/sección/localización/soporte entre 2 fechas','Estadísticas semanales a principio de marca','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date_debut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fecha de inicio]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date_fin\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fecha de fin]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"cote\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Seleccione un principio de marca (par ex. \"R \" para Romanos)...]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS></OPTIONS>\n </FIELD>\n <FIELD NAME=\"localisationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idsection, section_libelle FROM docs_section ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(285,'Número de prestamos por soporte y sexo','','xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idtyp_doc, tdoc_libelle from docs_type order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Código(s) Estadístico(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, libelle from empr_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Desde]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Hasta]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n</FIELDS>'),
(286,'Número de préstamos de un ejemplar entre 2 fechas','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha de iniciot]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fecha de fin]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"cb\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[código de barras]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>15</SIZE>\r\n <MAXSIZE>15</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(287,'Número de préstamos por marca, propietario, localización, sección, soporte, código estadístico, por fechas de adquisición entre 2 fechas','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Préstamos efecutados entre:]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Y :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"dateacq1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fecha de adquisicón entre :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"dateacq2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Y :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elegir uno o varios propietarios :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elegir una o varias localizaciones :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elegir una o varias secciones :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elegir uno o varios soportes :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elegir uno o varios códigos estadísticos :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(288,'Número de préstamos por tipo de abono para un periodo dado','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Desde :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Hasta :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(289,'Número de préstamos por categoría(autoridad) para un año','','xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoría :]]></ALIAS>\n  <TYPE>selector</TYPE>\n<OPTIONS FOR=\"selector\">\r\n <METHOD>1</METHOD>\r\n <DATA_TYPE>2</DATA_TYPE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(290,'Número de préstamos por categoría de lectores para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS></OPTIONS>\n </FIELD>\n</FIELDS>'),
(291,'Número de préstamos por código estadístico de ejemplar y por localización','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Código(s) Estadístico(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Desde]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Hasta]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(292,'Número de préstamos por código estadístico del lector','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idtyp_doc, tdoc_libelle from docs_type order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Código(s) Estadístico(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, libelle from empr_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Desde]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Hasta]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n</FIELDS>'),
(293,'Número de préstamos por marca, propietario, localización, sección, soporte, código estadístico entre 2 fechas','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Entre :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Y :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija uno o varios propietarios :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija una o varias localizaciones :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija una o varias secciones :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija uno o varios soportes :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija uno o varios códigos estadísticos :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(294,'Número de préstamos por indexación decimal para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(295,'Número de préstamos por dia y tramo horario','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"debut_periode\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[inicio del periodo :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"fin_periode\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fin del periodo :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n</FIELDS>'),
(296,'Número de préstamos por dia, tramo horario y localización','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"debut_periode\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[inicio del periodo :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"fin_periode\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fin del periodo :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"localisation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[localisation :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlocation, location_libelle from docs_location order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(297,'Número de préstamos por localización para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(298,'Número de préstamos por localización y código estadístico para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixCS\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Código(s) Estadístico(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(299,'Número de préstamos por localización y sección','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Inicio :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fin :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(300,'Número de préstamos por localización, sección y soporte','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Desde :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Hasta :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(301,'Número de préstamos por localización, sección y soporte','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Desde :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Hasta :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(302,'Número de préstamos por propietario, localización, sección, soporte y código estadístico','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija uno o varios propietarios :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija una o varias localizaciones :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija una o varias secciones :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija uno o varios soportes :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija uno o varios códigos estadísticos :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Entre :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Y :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(303,'Número de préstamos por localización y soporte para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation,location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(304,'Número de préstamos por localización, soporte y código estadístico','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Código(s) Estadístico(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Inicio :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fin :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(305,'Número de préstamos por mes y por año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Añoñ de cálculo :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(306,'Número de préstamos de un periodo según su ISSN entre 2 fechas','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Inicio :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fin :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"cb\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[ISSN :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>50</SIZE>\r\n <MAXSIZE>50</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(307,'Número de préstamos por propietario','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"Du\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Desde]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"Au\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Hasta]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(308,'Número de préstamos por propietario y código estadístico','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Código(s) estadístico(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Desde :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fin :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(309,'Número de préstamos por propietario, localización y sección','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlender\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender,lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(310,'Número de préstamos por propietario, localización y soporte','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlender\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(311,'Número de préstamos por propietario y soporte','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Inicio :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fin :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(312,'Número de préstamos por propietario, soporte y código estadístico','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender,lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Código(s) estadístico(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Inicio :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fin :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(313,'Número de préstamos por sección para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>20</SIZE>\r\n <MAXSIZE>255</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(314,'Número de préstamos por sección y localización para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlocation, location_libelle from docs_location order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(315,'Número de préstamos por sexo para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(316,'Número de préstamos por sexo y tramo de edad para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(318,'Número de préstamos por soporte','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idtyp_doc, tdoc_libelle from docs_type order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Código(s) Estadístico(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, libelle from empr_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Desde]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Hasta]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n</FIELDS>'),
(319,'Número de préstamos por soporte y por categoría de lectores','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoría(s) de lectores :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select id_categ_empr, libelle from empr_categ order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Inicio :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fin :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(320,'Número de préstamos por soporte y código estadístico de ejemplares','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Código(s) Estadístico(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idcode, codestat_libelle from docs_codestat order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Desde]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Hasta]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n</FIELDS>'),
(321,'Número de préstamos por soporte y código estadístico de lectores','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idtyp_doc, tdoc_libelle from docs_type order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Código(s) Estadístico(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, libelle from empr_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Desde]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Hasta]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n</FIELDS>'),
(322,'Número de préstamos por soporte y marca','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Inicio :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fin :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(323,'Número de préstamos por soporte y tramo de edad para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idtyp_doc, tdoc_libelle from docs_type order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(324,'Número de préstamos por tramo de edad para un año','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(325,'Número de préstamos por tramo de edad para un periodo','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Desde :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Hasta :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(326,'Número de préstamos por trimeste de un ejemplar en los últimos 3 años','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"codebarreexpl\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Introduzca o copie el código de barras del ejemplar...]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\n <SIZE>20</SIZE>\n <MAXSIZE>255</MAXSIZE>\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(327,'Número de préstamos por municipio del lector para un año (sin elegir el municipio)','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixville\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Municipio(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select distinct(arc_empr_ville), arc_empr_ville from pret_archive order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(328,'Listado de obras compradas/donadas en un año /soporte/localización/código estadístico/sección/propietario','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija una o varias localizaciones :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlocation, location_libelle from docs_location order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija uno o varios propietarios :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(329,'Lista de marcas por localización','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[localización]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idlocation, location_libelle FROM docs_location ORDER BY 2]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(330,'Lista de marcas por localización 2','Especificar el número de caracteres para el inicio de la marca','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"nomb\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[número de caracteres :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>3</SIZE>\r\n <MAXSIZE>2</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[localización]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(331,'Lista de marcas por localización y sección','','<xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idsection, section_libelle FROM docs_section ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idlocation, location_libelle FROM docs_location ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(332,'Lista de ejemplares nunca prestados para un periodo dado','clasificados por fecha de adquisición','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"datedebut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fecha de Inicio :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"datefin\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fecha de fin :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(333,'Lista de ejemplares destruidos dentro de un año','se basa en el campo Fecha de Destrucción','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(334,'Lista de ejemplares prestados entre 2 fechas por propietario, localización, sección, soporte, código estadístico eligiendo la fecha de adquisición','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Préstamos entre :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Y :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"dateacq1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fecha de adquisición entre :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2acq\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Y :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija uno o varios propietarios :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija una o varias localizaciones :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija una o varias secciones :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija uno o varios soportes :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija uno o varios códigos estadísticos :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(335,'Lista de ejemplares por propietario','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"proprietaire\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by idlender</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\">Elija un prestador</UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(336,'Lista de ejemplares por propietario, localización, sección, soporte, código estadístico entre 2 fechas de adquisición','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fecha de adquisición entre :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Y :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija una o varias localizaciones :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija uno o varios propietarios :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija una o varias secciones :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija uno o varios soportes :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija uno o varios códigos estadísticos :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(337,'Lista de ejemplares de un propietario por estado','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"statut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estado :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idstatut, statut_libelle from docs_statut</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"Proprietaire\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(338,'Lista de ejemplares por propietario/estado/localización/sección/soporte/código estadístico/marca/título/precio/autor principal/editor/año de edición','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idsection, section_libelle FROM docs_section ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"codestatt\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Código Estadístico]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idcode, codestat_libelle FROM docs_codestat ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"typdocc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Soporte]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idtyp_doc, tdoc_libelle FROM docs_type ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"proprioo\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlender, lender_libelle FROM lenders ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"statutt\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estado]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idstatut, statut_libelle FROM docs_statut ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(339,'Lista de ejemplares de un propietario por estado/localización/sección','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario (s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixstatut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estado (s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idstatut, statut_libelle from docs_statut order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(340,'Lista de ejemplares de una o varias secciones por propietario','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"sections\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idsection, section_libelle from docs_section</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"preteur\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by idlender</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\">Elija un propietario</UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(341,'Lista de ejemplares por estado','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estado :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idstatut,statut_libelle from docs_statut</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\">Elija un estado</UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(342,'Número de ejemplares por propietario, sección','',''),
(343,'Lista de prestatarios por nombre, apellidos y municipio','',''),
(344,'Lista de lectores por tipo de abono','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"type_abonnement\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[tipo de abono :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT id_type_abt, type_abt_libelle FROM type_abts ORDER BY 2]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(345,'Lista de lectores por categorías','',''),
(347,'Lista de lectores con información múltiple','',''),
(348,'Lista de lectores por sexo','',''),
(349,'Lista de lectores por tramo de edad','los años indicados están incluidos en la búsqueda','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"naiss1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[año de inicio :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"naiss2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[año de fin :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(350,'Lista de lectores por municipio','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"villle\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Municipio]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>20</SIZE>\r\n <MAXSIZE>20</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(351,'Lista de transacciones por prestatario','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"typcom\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Tipo de cuenta]]></ALIAS>\n  <TYPE>list</TYPE>\n<OPTIONS FOR=\"list\">\r\n <MULTIPLE>no</MULTIPLE>\r\n <ITEMS>\r\n  <ITEM VALUE=\"1\"><![CDATA[Abono]]></ITEM>\r\n  <ITEM VALUE=\"2\"><![CDATA[Multa]]></ITEM>\r\n  <ITEM VALUE=\"3\"><![CDATA[Préstamo]]></ITEM>\r\n </ITEMS>\r\n <UNSELECT_ITEM VALUE=\"0\"><![CDATA[Todos]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"empr\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Prestatario]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_empr, concat(empr_nom,\' \',empr_prenom) from empr order by empr_nom</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"0\">Tous</UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date_debut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fecha de inicio]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date_fin\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fecha de fin]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n</FIELDS>'),
(352,'Lista de documentos nunca prestados','',''),
(353,'Lista de documentos menos prestados','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param_annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[año de cálculo :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(354,'Lista de documentos más prestados','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param_annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[año de cálculo :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(355,'Lista de préstamos en curso por localización','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"localisation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[localización]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\n <MULTIPLE>yes</MULTIPLE>\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(356,'Lista de préstamos en curso por localización y sección','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localización(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(357,'Asignar a un usuario los mismos permisos sobre las cestas del catálogo que otro usuario','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"userarattacher\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Asignar permisos al usuario (Destino) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"usermodele\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Seleccionar el usuario cuyos permisos se van a duplicar (Origen) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(358,'Asignar a un usuario los mismos permisos sobre las cestas de circulación que otro usuario','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"userarattacher\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Asignar permisos al usuario (Destino) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"usermodele\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Seleccionar el usuario cuyos permisos se van a duplicar (Fuente) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(359,'Asignar a un usuario los mismos permisos sobre los procedimientos de las cestas del catálogo que otro usuario','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"userarattacher\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Asignar los permisos al usuario (Destino) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"usermodele\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Seleccionar el usuario cuyos permisos se van a duplicar (Fuente) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(360,'Asignar a un usuario los mismos permisos sobre los procedimientos de las cestas de circulación que otro usuario','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"userarattacher\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Asignar los permisos al usuario (Destino) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"usermodele\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Seleccionar el usuario cuyos permisos se van a duplicar (Fuente) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(361,'Asignar a un usuario los mismos permisos sobre las estadísticas que otro usuario','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"userarattacher\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Asigar los permisos al usuario (Destino) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"usermodele\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Seleccionar el usuario cuyos permisos se van a duplicar (Fuente) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(1,'Lista de ejemplares/estado','Lista parametrizada de ejemplares por estado','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estado]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idstatut,statut_libelle from docs_statut]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[Selecciona un estado]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(2,'Recuento ejemplares / estado','Número de ejemplares por estado de ejemplar',''),
(3,'Recuento ejemplares / propietario / estado','Número de ejemplares por propietario y por estado de ejemplar',''),
(4,'Lista de ejemplare de un propietario / estado','Lista de ejemplares de un propietari por estado, signatura, código de barras, título  (práctico para hacer listas de documentos no marcados antes de una importación)','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"statut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estado]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idstatut, statut_libelle from docs_statut</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"Proprietaire\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Propietario]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(5,'Recuento ejemplares / sección','Número de ejemplares por sección',''),
(6,'Lista de ejemplares para una o más secciones por propietario','Lista de ejemplares de una o más secciones para un propietario','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"sections\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Sección(es)]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"preteur\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Propietario]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by idlender]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[Escoge un propietario]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(7,'Estado : Recuento ejemplares / proprietario','Núm de ejemmplares por propietario de ejemplar',''),
(8,'Lista ejemplares para un propietario','Lista de los ejemplares para un propietario ordenados por signatura y código de barras','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"proprietaire\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Propiétario]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by idlender</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\">Escoge un propietario</UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(9,'Recuento usuarios / categoría','Número de usuarios por categoría',''),
(10,'Lista usuarios / categorías','Lista de usuarios por categorías de usuario, usuario',''),
(11,'Estadísticas : Recuento de préstamos / categorías de usuarios en un año','Número de préstamos por categoría de usuarios en un año','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[año]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS></OPTIONS>\n </FIELD>\n <FIELD NAME=\"mois\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[mes]]></ALIAS>\n  <TYPE>list</TYPE>\n<OPTIONS FOR=\"list\">\r\n <MULTIPLE>yes</MULTIPLE>\r\n <ITEMS>\r\n  <ITEM VALUE=\"1\"><![CDATA[Enero]]></ITEM>\r\n  <ITEM VALUE=\"2\"><![CDATA[Febrero]]></ITEM>\r\n  <ITEM VALUE=\"3\"><![CDATA[Marzo]]></ITEM>\r\n  <ITEM VALUE=\"4\"><![CDATA[Abril]]></ITEM>\r\n  <ITEM VALUE=\"5\"><![CDATA[Mayo]]></ITEM>\r\n  <ITEM VALUE=\"6\"><![CDATA[Junio]]></ITEM>\r\n  <ITEM VALUE=\"7\"><![CDATA[Julio]]></ITEM>\r\n  <ITEM VALUE=\"8\"><![CDATA[Agosto]]></ITEM>\r\n  <ITEM VALUE=\"9\"><![CDATA[Septiembre]]></ITEM>\r\n  <ITEM VALUE=\"10\"><![CDATA[Octubre]]></ITEM>\r\n  <ITEM VALUE=\"11\"><![CDATA[Noviembre]]></ITEM>\r\n  <ITEM VALUE=\"12\"><![CDATA[Diciembre]]></ITEM>\r\n </ITEMS>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(12,'Estadísticas : Recuento de usuarios / edad','Núm. de usuarios por franjas de edad en un año','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año de cálculo]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoría]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(13,'Estadísticas : Recuento de usuarios / sexo / edad','Núm. de usuarios por sexo y por franja de edad para un año','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año de cálculo]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoría]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by libelle</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(14,'Estadísticas : Recuento de usuarios / población / categoría','Número de usuarios por población de residencia para una o más categorías','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoria]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año de cálculo]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(15,'Estadísticas : Recuento de préstamos por mes','Número total de préstamos para un año','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año de cálculo]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(16,'Estadísticas : Recuento de préstamos / sección para un año','Número de préstamos por sección para un año','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[año]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>20</SIZE>\r\n <MAXSIZE>255</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"mois\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[mes]]></ALIAS>\n  <TYPE>list</TYPE>\n<OPTIONS FOR=\"list\">\r\n <MULTIPLE>yes</MULTIPLE>\r\n <ITEMS>\r\n  <ITEM VALUE=\"1\"><![CDATA[Enero]]></ITEM>\r\n  <ITEM VALUE=\"2\"><![CDATA[Febrero]]></ITEM>\r\n  <ITEM VALUE=\"3\"><![CDATA[Marzo]]></ITEM>\r\n  <ITEM VALUE=\"4\"><![CDATA[Abril]]></ITEM>\r\n  <ITEM VALUE=\"5\"><![CDATA[Mayo]]></ITEM>\r\n  <ITEM VALUE=\"6\"><![CDATA[Junio]]></ITEM>\r\n  <ITEM VALUE=\"7\"><![CDATA[Julio]]></ITEM>\r\n  <ITEM VALUE=\"8\"><![CDATA[Août]]></ITEM>\r\n  <ITEM VALUE=\"9\"><![CDATA[Septiembre]]></ITEM>\r\n  <ITEM VALUE=\"10\"><![CDATA[Octubre]]></ITEM>\r\n  <ITEM VALUE=\"11\"><![CDATA[Noviembre]]></ITEM>\r\n  <ITEM VALUE=\"12\"><![CDATA[Diciembre]]></ITEM>\r\n </ITEMS>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>');

UPDATE procs INNER JOIN procs_bak 

ON procs_bak.idproc =procs.idproc

SET procs.name=procs_bak.name,
    procs.comment=procs_bak.comment,
    procs.parameters=procs_bak.parameters;

DROP TABLE IF EXISTS procs_bak;


--
-- Traducción de tabla `procs_classements`
--


DROP TABLE IF EXISTS procs_classements_bak;
CREATE TABLE IF NOT EXISTS procs_classements_bak (
  idproc_classement	smallint(5),
  libproc_classement	varchar(255),
  PRIMARY KEY(idproc_classement))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO procs_classements_bak(idproc_classement, libproc_classement) VALUES
(2,'Autorizaciones'),
(5,'Estadísticas-DLL'),
(9,'Estadísticas-Lectores'),
(14,'Estadísticas-Ejemplares'),
(15,'Estadísticas-Préstamos'),
(16,'Listados-Ejemplares'),
(17,'Listados-Lectores'),
(18,'Acciones-Neteja'),
(19,'Listados-Préstamos'),
(20,'Migración');


UPDATE procs_classements INNER JOIN procs_classements_bak 

ON procs_classements_bak.idproc_classement =procs_classements.idproc_classement

SET procs_classements.libproc_classement=procs_classements_bak.libproc_classement;

DROP TABLE IF EXISTS procs_classements_bak;


--
-- Traducción de tabla`sauv_sauvegardes`
--

DROP TABLE IF EXISTS sauv_sauvegardes_bak;
CREATE TABLE IF NOT EXISTS sauv_sauvegardes_bak (
  sauv_sauvegarde_id	int(15),
  sauv_sauvegarde_nom	varchar(50),
  PRIMARY KEY(sauv_sauvegarde_id))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO sauv_sauvegardes_bak(sauv_sauvegarde_id,sauv_sauvegarde_nom) VALUES
(1,'tot');

UPDATE sauv_sauvegardes INNER JOIN sauv_sauvegardes_bak 

ON sauv_sauvegardes_bak.sauv_sauvegarde_id=sauv_sauvegardes.sauv_sauvegarde_id

SET sauv_sauvegardes.sauv_sauvegarde_nom=sauv_sauvegardes_bak.sauv_sauvegarde_nom;

DROP TABLE IF EXISTS sauv_sauvegardes_bak;


--
-- Traducción de tabla`sauv_tables`
--

DROP TABLE IF EXISTS sauv_tables_bak;
CREATE TABLE IF NOT EXISTS sauv_tables_bak (
  sauv_table_id	int(15),
  sauv_table_nom varchar(50),
  PRIMARY KEY(sauv_table_id))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO sauv_tables_bak(sauv_table_id,sauv_table_nom) VALUES
(1,'Biblio'),
(2,'Autoritats'),
(3,'Ninguna utilidad'),
(4,'Z3950'),
(5,'Usuarios'),
(6,'Aplicació'),
(7,'TODO'),
(9,'Cestas'),
(10,'DSI'),
(11,'Finanzas');


UPDATE sauv_tables INNER JOIN sauv_tables_bak 

ON sauv_tables_bak.sauv_table_id=sauv_tables.sauv_table_id

SET sauv_tables.sauv_table_nom=sauv_tables_bak.sauv_table_nom;
     
DROP TABLE IF EXISTS sauv_tables_bak;


--
-- Traducción de tabla `search_perso`
--

DROP TABLE IF EXISTS search_perso_bak;
CREATE TABLE IF NOT EXISTS search_perso_bak (
  search_id	int(8),
  search_name	varchar(255),
  search_human	text,
  PRIMARY KEY(search_id))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO search_perso_bak(search_id, search_name,search_human) VALUES
(1,'Control importación y marcado BPD','<i><strong>Fecha creación</strong> = ()</i> <strong>Y</strong> <i><strong>Localización</strong> = ()</i> <strong>Y</strong> <i><strong>Estado</strong> = ()</i> ');


UPDATE search_perso INNER JOIN search_perso_bak 

ON search_perso_bak.search_id=search_perso.search_id

SET search_perso.search_name=search_perso_bak.search_name,
     search_perso.search_human=search_perso_bak.search_human;

DROP TABLE IF EXISTS search_perso_bak;


--
-- Traducción de tabla `statopac_request`
--

DROP TABLE IF EXISTS statopac_request_bak;
CREATE TABLE IF NOT EXISTS statopac_request_bak (
  idproc	int(8),
  name	varchar(255),
  comment tinytext,
  PRIMARY KEY(idproc))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO statopac_request_bak(idproc,name,comment) VALUES
(1,'Número de visitas por fecha','Distingue las sesiones'),
(2,'Número de visitas por fecha (direcciones IP)','Distingue las direcciones IP'),
(3,'Palabras introducidas','Muestra las diferentes palabras introducidas en las búsquedas'),
(4,'Exportaciones','Número de exportaciones lanzadas desde OPAC'),
(5,'Impresiones de cestas','Impresiones de cestas lanzadas desde OPAC'),
(6,'Primera página mostrada','Primera página mostrada (cuando un lector llega a OPAC) ordenado por frecuencia'),
(7,'DSI','Número de lectores utilizando la DSI dentro del OPAC'),
(8,'Palabras más buscadas','Muestra las palabras más buscadas en el OPAC'),
(9,'Búsqueda avanzada','Búsquedas avanzadas ordenadas por frecuencia'),
(10,'Búsquedas existosas o no','Muestra las búsquedas y si se van registrar resultados o no'),
(11,'Tipo de búsqueda','Muestra los tipos de búsqueda realizadas en el OPAC ordenados por frecuencia'),
(12,'Consultas de infopage',''),
(13,'Secciones de asistencia',''); 



UPDATE statopac_request INNER JOIN statopac_request_bak 

ON statopac_request_bak.idproc=statopac_request.idproc

SET statopac_request.name=statopac_request_bak.name,
     statopac_request.comment=statopac_request_bak.comment;

DROP TABLE IF EXISTS statopac_request_bak;


--
-- Traducción de tabla `statopac_vues`
--

DROP TABLE IF EXISTS statopac_vues_bak;
CREATE TABLE IF NOT EXISTS statopac_vues_bak (
  id_vue  int(8),
  nom_vue varchar(255),
  PRIMARY KEY(id_vue))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO statopac_vues_bak(id_vue, nom_vue) VALUES

(1,'Estadísticas de visitas'),
(2,'Búsquedas'),
(3,'Navegación'),
(4,'Lectores'),
(5,'Infopages');

UPDATE statopac_vues INNER JOIN statopac_vues_bak

ON statopac_vues_bak.id_vue=statopac_vues.id_vue

SET statopac_vues.nom_vue=statopac_vues_bak.nom_vue;

DROP TABLE IF EXISTS statopac_vues_bak;


--
-- Traducción de tabla `suggestions_categ`
--

DROP TABLES IF EXISTS suggestions_categ_bak;
CREATE TABLE IF NOT EXISTS suggestions_categ_bak(
id_categ int(12),
libelle_categ varchar(255),
PRIMARY KEY(id_categ))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO suggestions_categ_bak(id_categ, libelle_categ) VALUES

(1,'categoría per defecto');

UPDATE suggestions_categ INNER JOIN suggestions_categ_bak

ON suggestions_categ_bak.id_categ=suggestions_categ.id_categ

SET suggestions_categ.libelle_categ=suggestions_categ_bak.libelle_categ;

DROP TABLE IF EXISTS suggestions_categ_bak;


--
-- Traducción de tabla `cms_editorial_types`
--

DROP TABLES IF EXISTS cms_editorial_types_bak;
CREATE TABLE IF NOT EXISTS cms_editorial_types_bak(
id_editorial_type int(10),
editorial_type_label	varchar(255) ,  
PRIMARY KEY (id_editorial_type))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO cms_editorial_types_bak(id_editorial_type , editorial_type_label) VALUES

(1,'CP por Artículo'),
(2,'CP por Rúbrica');

UPDATE cms_editorial_types INNER JOIN cms_editorial_types_bak

ON cms_editorial_types_bak.id_editorial_type=cms_editorial_types.id_editorial_type

SET cms_editorial_types.editorial_type_label=cms_editorial_types_bak.editorial_type_label;

DROP TABLE IF EXISTS cms_editorial_types_bak;

--
-- Traducción de tabla `lignes_actes_statuts`
--

DROP TABLES IF EXISTS lignes_actes_statuts_bak;
CREATE TABLE IF NOT EXISTS lignes_actes_statuts_bak(
id_statut int(3),
libelle	text ,  
PRIMARY KEY (id_statut))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO lignes_actes_statuts_bak(id_statut , libelle) VALUES

(1,'Tratamiento normal');


UPDATE lignes_actes_statuts INNER JOIN lignes_actes_statuts_bak

ON lignes_actes_statuts_bak.id_statut=lignes_actes_statuts.id_statut

SET lignes_actes_statuts.libelle=lignes_actes_statuts_bak.libelle;

DROP TABLE IF EXISTS lignes_actes_statuts_bak;

--
-- Traducción de tabla `notice_tpl'
--

DROP TABLES IF EXISTS notice_tpl_bak;
CREATE TABLE IF NOT EXISTS notice_tpl_bak(
notpl_id int(10),
notpl_name varchar(256),
notpl_comment varchar(256),
  
PRIMARY KEY (notpl_id))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO notice_tpl_bak(notpl_id ,notpl_name,notpl_comment) VALUES

(5,'Plantilla de visualización personalizada sin miniatura','Plantilla de visualización personalizada sin miniatura'),
(4,'Plantilla de visualización personalizada',''),
(6,'Bibliografía','Servicios PMB');


UPDATE notice_tpl INNER JOIN notice_tpl_bak

ON notice_tpl_bak.notpl_id=notice_tpl.notpl_id

SET notice_tpl.notpl_name=notice_tpl_bak.notpl_name,
    notice_tpl.notpl_comment=notice_tpl_bak.notpl_comment;		

DROP TABLE IF EXISTS notice_tpl_bak;


--
-- Traducción de tabla 'z_attr'
--

DROP TABLE IF EXISTS z_attr_bak;
CREATE TABLE IF NOT EXISTS z_attr_bak(
attr_bib_id int (6),
attr_libelle varchar(250),
attr_attr varchar(250))

ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO z_attr_bak(attr_bib_id,attr_libelle,attr_attr) VALUES

(2,'tema','21'),
(2,'título','4'),
(2,'autor','1003'),
(2,'isbn','7'),
(3,'tema','21'),
(3,'título','4'),
(3,'autor','1003'),
(3,'isbn','7'),
(5,'tema','21'),
(5,'título','1004'),
(5,'autor','1003'),
(5,'isbn','7'),
(7,'tema','21'),
(7,'título','4'),
(7,'autor','1003'),
(7,'isbn','7'),
(8,'tema','21'),
(8,'título','4'),
(8,'autor','1'),
(8,'isbn','7'),
(8,'palabras','1016'),
(10,'tema','21'),
(10,'título','4'),
(10,'autor','1003'),
(10,'isbn','7'),
(12,'tema','21'),
(12,'título','4'),
(12,'autor','1003'),
(12,'isbn','7'),
(11,'tema','21'),
(11,'título','4'),
(11,'autor','1003'),
(11,'isbn','7'),
(15,'tema','21'),
(15,'título','4'),
(15,'autor','1003'),
(15,'isbn','7'),
(17,'tema','21'),
(17,'título','4'),
(17,'autor','1003'),
(17,'isbn','7'),
(21,'tema','21'),
(21,'título','4'),
(21,'autor','1003'),
(21,'isbn','7');

UPDATE z_attr INNER JOIN z_attr_bak

ON z_attr_bak.attr_bib_id=z_attr.attr_bib_id AND z_attr_bak.attr_attr=z_attr.attr_attr

SET z_attr.attr_libelle=z_attr_bak.attr_libelle;
    

DROP TABLE IF EXISTS z_attr_bak;

--
-- Traducción tabla 'parameters
--

DROP TABLES IF EXISTS parametres_bak;
CREATE TABLE IF NOT EXISTS parametres_bak(
id_param int(6),
type_param varchar(20) COLLATE utf8_unicode_ci DEFAULT NULL,
sstype_param varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
valeur_param text,
comment_param longtext,
  
PRIMARY KEY (id_param))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO parametres_bak(id_param,type_param,sstype_param,valeur_param,comment_param) VALUES
(837,'opac','show_categ_browser','','Mostrar categorías en la página principal del OPAC:\n0: No\n1: Si\n1 3,1: Si, junto con el id 3 más 1 del thesaurus (precisar el thesaurus a mostrar y el orden)'),
(81,'thesaurus','categories_show_empty_categ','','Mostrar las categorías que no contienen ningún registro:\r\n0=No, 1=Si'),
(82,'thesaurus','categories_term_search_n_per_page','','Número de términos mostrados por página en una búsqueda por términos dentro de las categorías'),
(899,'opac','notices_format','','Formato de visualización de los reseñas en los resultados de búsqueda \n 0 : Utilizar el parámetro notices_format_onglets \n 1 : sólo ISBD  \n 2 : sólo Público \n 4 : ISBD y Públicoc \n 5 : ISBD y Público con ISBD primero \n 8 : Reducido sólo (título+autores)'),
(900,'opac','notices_depliable','','Mostrar desplegable de reseñas en los resultados de búsqueda:\n0: Sin desplegable\n1: Desplgar al hacer clic en el icono\n2: Desplegar haciendo clic en toda la línea del título'),
(164,'thesaurus','categories_show_only_last','','En la ficha de un registro: \n 0 Mostrar todo \n 1 : mostrar únicamente la última rama del árbolde la categoría'),
(952,'pmb','utiliser_calendrier','','¿Utilizar el calendario de días de apertura?\n 0 : No\n 1 : Si, para el cálculo de las fechas de vencimiento y los retrasos\n 2 : Si, únicamente para el cálculo de las fechas de retorno'),
(1037,'pmb','blocage_delai','','Periodo a partir del cúal el retardo será tenido en cuenta para el bloqueo'),
(1060,'pmb','recouvrement_auto','','Por defecto nivel de recuperación propuesto en la gestión de recuperación si nivel=3 y debe estar en 4: \r\n 1: Si, recuperación propuesta por defecto \r\n 0: No hacer nada por defecto'),
(569,'pmb','latest_order','','¿Clasificación de los últimos registros? \n notice_id desc : por id de registro decreciente: ideal pero puede ser problemático después de una migración o una importación \n create_date desc: por la columna fecha de creación.'),
(1116,'acquisition','pdfliv_pos_adr_liv','','Posición Dirección de entrega: Distancia con relación al borde izquierdo de la página,Distancia con relación a la parte de arriba de la página,Ancho, Alto,Tamaño de la fuente'),
(1117,'acquisition','pdfliv_pos_adr_fou','','Posición elementos del proveedor: Distancia con relación al borde izquierdo de la página,Distancia con relación a la parte de arriba de la página,Ancho, Alto,Tamaño de la fuente'),
(380,'pmb','show_rtl','','Visualización posible de derecha a izquierda \r\n 0 No \r\n 1 Si'),
(381,'opac','avis_show_writer','','Mostrar el redactor del aviso: \n 0 : No \n 1 : Nombre y Apellidos \n 2 : únicamente login OPAC'),
(382,'pmb','form_editables','','Casillas de registros editables \r\n 0 No \r\n 1 Si'),
(383,'acquisition','sugg_to_cde','','Transferéncias de sugerencias de pedido.\n 0 : No.\n 1 : Si.'),
(384,'thesaurus','categories_categ_in_line','','Mostrar categorías en línea \n 0 : No.\n 1 : Si.'),
(386,'pmb','label_construct_script','','Script de construcción de etiqueta de signatura'),
(387,'dsi','func_after_diff','','Script a ejecutar después de la difusión de una bannette'),
(388,'opac','notice_groupe_fonction','','Que fichero/función incluir en la presentación de los resultados si todos los registros de una búsqueda se encuentran entre los tipo mencionados \n ejemplo : a,b texto;c,d música;k fotográfia incluirá (text.inc.php) y llamará a la función text()'),
(389,'opac','photo_mean_size_x','','Dimensión X de la fotografía formato \'moyen\', si está vacía, no redimensionar'),
(390,'opac','photo_mean_size_y','','Dimensión Y de la fotografía formato \'moyen\', si está vacía, no redimensionar'),
(391,'opac','photo_watermark','','Marca de agua a añadir a las fotografías, si está vacía, no añadir'),
(392,'opac','photo_show_form','','¿Añadir el formulario de pedido de fotografía? \n 0: No \n 1:Si'),
(393,'opac','photo_email_form','','Separar por espacios si hay múltiples emails de destinatarios de pedidos de fotografía'),
(394,'opac','photo_watermark_transparency','','Transparencia de la marca de agua de 0 a 100 en %'),
(395,'opac','show_onglet_empr','','¿Mostrar la pestaña de cuenta de prestatario junto con el resto de pestañas de búsqueda? \n 0: No \n 1: Si \n 2: mostrar la pestaña de prestatario cuando el usuario esta autenticado (y en este caso haga clic sobre la pestaña que lleva a empr.php)'),
(396,'pmb','url_base','','URL de la base de gestion: típicamente pone la url http://miservidor/pmb/ no se olvide de la / final'),
(397,'opac','show_empr','','¿Añadir el prestatario actual dentro de la lista de los ejemplares?\n 0 : No\n 1 : para los abonados\n 2 : para todo el mundo'),
(398,'opac','show_login_form_next','','Después de la conexión del prestatario ¿a que módulo se dirigirá? \n Vacio = Cuenta del prestatario \n index.php = Menú de inicio'),
(399,'opac','allow_term_troncat_search','','Truncado automático a la derecha \n 1 = Si \n 0 = No'),
(400,'opac','show_results_first_page','','Mostrar los resultados en la primera página en una búsqueda por todos los campos \r\n 0=No \r\n 1=Si'),
(401,'opac','nb_results_first_page','','Número de registros a mostrar en una búsqueda por el criterio Todos los campos'),
(402,'opac','show_infobulles_categ','','Mostrar tooltips en las etiquetas de las categorías. \n 0=No \n 1=Si'),
(403,'acquisition','sugg_display','','Nombre de la función personalizada de las sugerencias de visualización'),
(404,'acquisition','sugg_categ','','Asignación de sugerencias a una categoría de sugerencias.\n 0 : No\n 1 : Si'),
(405,'acquisition','sugg_categ_default','','Identificación de la categoría de sugerencia por defecto'),
(406,'opac','sugg_categ','','Asignación de sugerencias a una categoría de sugerencias.\n 0 : No.\n 1 : Si.'),
(407,'opac','sugg_categ_default','','Identificación de la categoría de sugerencias por defecto.'),
(408,'acquisition','pdfsug_print','','¿Que script utilizar para personalizar la impresión de las listas de sugerencias?'),
(409,'acquisition','pdfdev_print','','¿Que script utilizar para personalizar la impresión de presupuestos?'),
(410,'acquisition','pdfcde_print','','¿Que script utilizar para personalizar la impresión de pedidos?'),
(411,'acquisition','pdfliv_print','','¿Que script utilizar para personalizar la impresión de los albaranes de entrega?'),
(412,'acquisition','pdffac_print','','¿Que script utilizar para personalizar la impresión de facturas?'),
(413,'pmb','notice_reduit_format','','Formato de visualización de los resumenes de registros:\n 0 = título+autor principal\n 1 = título+autor principal+fecha de edición \n 2 = título+autor principal+fecha de edición+ISBN\n 3 = sólo título\n P 1,2,3 = título+autor+campos personalizados id 1 2 3\n E 1,2,3 = título+autor+editor+campos personalizados id 1 2 3\n T = títulot1+títulot4\n 4 = título+título paralelo+autor principal\n H 1 = id de una plantilla de registro'),
(414,'pmb','resa_planning','','¿Utilizar un plan de reserva? \n 0: No \n 1: Si'),
(415,'pmb','antivol','','Control remoto del Sistema magnético antirobo ? \n 1 Si \n 0 No'),
(416,'acquisition','custom_calc_numero','','Función personalizada de numeración de las acciones de compra.'),
(417,'pmb','numero_exemplaire_auto','','¿Autorizar la numeración automática del ejemplar? \n 0 : No\n 1 : Si, para monografías y boletínes \n 2 : Si, sólo para monografías\n 3 : Si, sólo para boletínes'),
(418,'pmb','numero_exemplaire_auto_script','','Nombre del fichero del scrip php para la generación automática de los códigos de los ejemplares'),
(419,'empr','lecteur_controle_doublons','','Control sobre la duplicidad de lectores:\r\n0 : sin control de duplicidad en la entrada de la ficha del lector. \r\n1,empr_nom,empr_prenom,... : búsqueda de duplicados en los campos \'empr\', \r\n2,empr_nom,empr_prenom,... : búsqueda de duplicados en los campos \'empr\', y campos personalizables.\r\n3,empr_nom, empr_prenom ,... : idem, en adición al test en el grupo.'),
(420,'pmb','pret_nombre_prolongation','','Número de prolongaciones autorizadas'),
(421,'pmb','pret_restriction_prolongation','','0 : sin restricción\r\n1 : prolongación limitada al parámetro pret_nombre_prolongation \r\n2 : prolongación gestionado por cuotas'),
(422,'opac','pret_prolongation','','0 : sin prolongación\r\n1 : prolongación autorizada'),
(423,'mailretard','1after_list_group','','Texto que aparece después de la lista de obras con retraso dentro del email'),
(424,'mailretard','1before_list_group','','Texto que aparece antes de la lista de obras con retraso en el correo de recordatorio de retraso'),
(425,'mailretard','1fdp_group','','Firmante del correo de recordatorio de retraso'),
(426,'mailretard','1madame_monsieur_group','','Encabezado del correo'),
(427,'mailretard','1objet_group','','Objeto del email de recordatorio de retraso'),
(428,'pmb','first_week_day_format','','Formato de la semana: \n 0, la semana comienza en lunes \n 1 la semana comienza en domingo'),
(429,'opac','export_allow_expl','','Exportar los ejemplares junto con los registros : \n 0 : No \n 1 : Si'),
(430,'opac','nb_max_tri','','Número máximo de registros para los que la selección está autorizada.'),
(431,'pmb','nb_max_tri','','Número máximo de registros para los que la selección está autorizada.'),
(432,'opac','pret_duree_prolongation','','Número de días de prolongación autorizada'),
(433,'opac','surlignage','','Resaltar de los términos buscados:\r\n0 : sin resaltado\r\n1 : resaltado obligatorio\r\n2 : resaltado activado\r\n3 : resaltado desactivado'),
(434,'opac','nb_max_criteres_tri','','Número máximo de criterios de selección a mostrar'),
(435,'empr','show_caddie','','Mostrar el módulo de cestas de lectores: \r\n 0: No \r\n 1: Si'),
(436,'empr','pics_url','','La URL de las fotografías de los prestatarios a la ruta prevista,  !!num_carte!! será reemplazada por el número de carnet del prestatario.\n ejemplo: http://wwww.miweb/fotos/lectores/!!num_carte!!.jpg'),
(437,'empr','pics_max_size','','Tamaño máximo de las fotografías de los prestatarios, en anchura o altura'),
(438,'thesaurus','classement_mode_pmb','','Nivel de utilización de los planes de clasificación de indexación.\n 0 : Un sólo plan de clasificación. \n 1 : Elegir un plan de clasificación posible.'),
(439,'thesaurus','classement_defaut','','Identificación del plan de clasificación por defecto'),
(440,'empr','electronic_loan_ticket','','¿Enviar un ticket de préstamo electrónico? \n 0: No, \n 1: Si'),
(441,'empr','electronic_loan_ticket_obj','','Objeto del email del ticket del preśtamo electrónico'),
(442,'empr','electronic_loan_ticket_msg','','Cuerpo del email del ticket de préstamo electrónico'),
(443,'pmb','droits_explr_localises','','¿Los derechos de gestión de los ejemplares están localizados? \n 0: No \n 1: Si'),
(444,'empr','fiche_depliee','','La ficha del prestatario será automáticamente: \n 0 : plegada \n 1 : doblada'),
(445,'empr','statut_adhes_depassee','','Id del estado para el cúal los prestatarios cuya fecha de adhesión este sobrepsada no aparezcan en la zona de alerta'),
(446,'opac','authorized_styles','','Estilos del OPAC autorizados, separados por comas'),
(447,'empr','relance_adhesion','','Los recordatorios de adhesión son enviados: \n 0 : exclusivamente por carta \n 1 : email, carta por defecto'),
(448,'empr','show_rows','','Columnas mostradas en la lista de lectores, añadir columnas separadas por comas. Las columnas disponibles para mostrar en la lista de lectores son: \n n: apellidos+nombre \n a: dirección \n b: código de barras \n c: categorías \n g: grupos \n l: localización \n s: estado \n cp: código postal \n v: municipio \n y: fecha de nacimiento \n ab: tipo de abono \n #n : id de los campos personalizados\n 1: icono cesta'),
(449,'empr','sort_rows','','Columnas que estarán disponibles para la selección de prestatarios. Las columnas posibles son : \n n: apellidos+nombre \n b: código de barras \n c: categorías \n g: grupos \n l: localización \n s: estado \n cp: código postal \n v: municipio \n y: fecha de nacimiento \n ab: tipo de abono \n #n : id de los campos personalizados'),
(450,'empr','filter_rows','','Columnas disponibles para filtrar la lista de prestatarios : \n v: municipio\n l: localización\n c: categoría\n s: estado\n g: grupo\n y: fecha de nacimiento\n cp: código postal\n cs : código estadístico\n ab : tipo de abono\n #n : id de los campos personalizado'),
(451,'empr','header_format','','Campos personalizados que serán mostrados en la cabecera de la ficha del prestatario. Añadir los id separados por comas'),
(452,'empr','archivage_prets','','¿Archivar los préstamos de los prestatarios? \n 0: No \n 1: Si\nATENCIÓN para Francia:le recordamos la obligación de declarar su tratamiento a la CNIL (www.cnil.fr) si activa esta funcionalidad'),
(453,'empr','archivage_prets_purge','','Número máximo de dias a conservar los archivos nominativos de préstamos: \n0: ilimitado \nN: Nº de días'),
(454,'opac','autres_lectures','','¿Mostrar los préstamos de otros lectors del documento actual? \n 0: No \n 1: Si'),
(455,'opac','autres_lectures_tri','','Seleccionar otras lecturas propuestas : \n rand(): aleatorio \n tit: por Título'),
(456,'opac','autres_lectures_nb_mini_emprunts','','Número mínimo de préstamos para ser contabilizados\n 1: un sólo préstamo será suficiente para proponer el registro como lectura asociada \n N: N mínimo de préstamos necesarios'),
(457,'opac','autres_lectures_nb_maxi','','Número máximo de lecturas asociadas propuestas'),
(458,'opac','autres_lectures_nb_jours_maxi','','Retraso en días a partir del cúal los préstamos no será contabilizados, 0 para ilimitado'),
(459,'opac','empr_hist_nb_max','','Número máximo de préstamos precedentes a mostrar, 0 para ilimitado'),
(460,'opac','empr_hist_nb_jour_max','','Retraso en días a partir del cúal los préstamos precedentes no serán mostrados, 0 para ilimitado'),
(461,'opac','allow_tags_search_min_occ','','Número mínimo de ocurrencias de un tag para ser mostrado, 1 para todos'),
(462,'pmb','etat_collections_localise','','¿El estado de las colecciones está localizado? \n 0 : No \n 1 : Si'),
(463,'pmb','clean_nb_elements','','Número de elementos a procesar por pasada de limpieza básica'),
(464,'pmb','rfid_activate','','¿Registros de préstamos por pletina RFID? \n 0: No \n 1: Si'),
(465,'opac','bull_results_per_page','','Número de boletínes mostrados por página en la visualización de de un período'),
(466,'pmb','rfid_serveur_url','','URL del servidor del webservice RFID'),
(467,'opac','authorized_information_pages','','Páginas \"incluibles\" dentro de la página del OPAC ./index.php?lvl=information&askedpage= : \n Introducir los nombres de los ficheros separados por comas'),
(468,'pmb','notice_controle_doublons','','Control de duplicados en la entrada de registros \n 0: Sin control de duplicados, \n 1,tit1,tit2, ... : Búscar por méthode _exacte_ de duplicados dentro de los camposs, definido en el fichero notice.xml  \n 2,tit1,tit2, ... : Buscar por _similitude_ '),
(469,'opac','title_ponderation','','Aumento de la ponderación de las palabras del título \n   introducir 0 (zero) para evitar el aumento \n ATENCIÓN utilizar el punto decimal'),
(470,'pmb','title_ponderation','','Aumento de la ponderación de las palabras del título \n   introducir 0 (zero) para evitar el aumento \n ATENCIÓN utilizar el punto decimal'),
(471,'pmb','param_etiq_codes_barres','','Configuración del back-up de los parámetros de edición de las etiquetas de códigos de barra'),
(472,'pmb','javascript_office_editor','','Código HTML a insertar para reemplazar las textarea por un editor Office javascript'),
(473,'opac','biblio_post_adress','','Bloque de información después del bloque dirección, dentro de la hoja de estilo, ver id post_adress'),
(474,'opac','allow_external_search','','Autorizar o no la búsqueda por conectores externos dentro del OPAC \r\n 0 : No \r\n 1 : Si'),
(475,'pmb','nb_noti_calc_empty_words','','Una palabra se considerará como vacía si aparece en un número mínimo de registros. Introduzca el porcentaje en relación al número total de registros.'),
(476,'opac','fonction_affichage_liste_bull','','Función de visualización de las listas de boletínes'),
(517,'transferts','statut_validation','','id del estado en el que se colocarán los documentos cuyas transferencias han sido validadas'),
(516,'pmb','transferts_actif','','Activar el sistema de transferencia de ejemplares entre sitios \n 0: No \n 1: Si'),
(479,'dsi','bannette_notices_order','','Orden de los registros en la bannette: \n index_serie, tnvol, index_sew : por título \n create_date desc : por fecha de entrada decreciente \n rand() : aleatorio'),
(480,'opac','websubscribe_show','','¿Mostrar la posibilidad de inscripción en línea? \n 0: No \n 1: Si'),
(481,'opac','websubscribe_empr_status','','Id del estado de los inscritos separados por comas: a la espera de validación, validado'),
(482,'opac','websubscribe_empr_categ','','Id de la categoría de los inscritos por la web con la inscripción no completada'),
(483,'opac','websubscribe_empr_stat','','Id del código estadístico de los inscritos por la web con la inscripción no completada'),
(484,'opac','websubscribe_valid_limit','','Duración máxima de las inscripción en espera de validación'),
(485,'pmb','mail_html_format','','Formato de envío de emails desde el OPAC: \n 0: Texto bruto\n 1: HTML \n 2: HTML, imagenes incluidas\n¡Atención, esta función sólo funciona en modo de envío smtp!'),
(486,'opac','mail_html_format','','Formato de envío de emails desde el OPAC: \n 0: Texto bruto\n 1: HTML \n 2: HTML, imagenes incluidas\n¡Atención, esta función sólo funciona en modo de envío smtp!'),
(487,'opac','websubscribe_empr_location','','Id de la localización de los inscritos por la web con la inscripción no completada'),
(488,'opac','allow_bannette_export','','¿Posibilitar a los lectores a recibir las notificaciones de sus bannettes privadas adjuntas al email?\n 0: No \n 1: Si'),
(490,'opac','expl_order','','Columnas de los ejemplares, en el orden indicado, separadas por comas: expl_cb,expl_cote,tdoc_libelle,location_libelle,section_libelle'),
(491,'opac','curl_available','','¿Esta la biblioteca cURL disponible para las consultas RSS particulares? \n 0: No \n 1: Si'),
(492,'pmb','curl_available','','¿Esta la biblioteca cURL disponible para las consultas RSS particulares? \n 0: No \n 1: Si'),
(493,'opac','thesaurus_defaut','','Identificación del thesaurus por defecto.'),
(494,'opac','recherches_pliables','','¿Las casillas de verificación de la búsqueda simple marcadas? \r\n 0: No \r\n 1: Si marcadas por defecto \r\n 2: Si desmarcadas por defecto \r\n 3: Invisibles'),
(495,'pmb','rfid_ip_port','','Asociación de IP de la estación de prestámos y Número de puesto utilizado por el servidor RFID. Ej: 192.168.0.10,SerialPort=10; IpPosteClient,SerialPort=NumPortPlatine; separado por punto y coma para designar todas las estaciones'),
(496,'pmb','pret_timeout_temp','','Tiempo en mínutos después del cúal un préstamo temporal es borrado'),
(497,'opac','permalink','','¿Ver el id del registro con un enlace permanente? \n 0: No \n 1: Si'),
(498,'pdflettreretard','3after_recouvrement','','Texto que aparece después de las litas de obras en recuperación si no hay otras otras obras de nivel 1 y 2'),
(499,'pdflettreretard','impression_tri','','¿Seleccionar para la impresión de las cartas de recuperación? Los campos son los de la tabla empr separados por comas. Ejemplo: empr_nom, empr_prenom'),
(500,'pmb','pret_date_retour_adhesion_depassee','','¿Puede la fecha de retorno superar la fecha de fin de la inscripción? \n 0: No: la fecha de retorno será calculada para no sobrepasar la fecha de fin de la inscripción. \n 1: Si, la fecha de retorno será independiente de la fecha de fin de la inscripción.'),
(501,'opac','extended_search_auto','','¿En búsquedas multicritérios, seleccionando un caampo se añade automáticamente sin necesidad de hacer clic sobre el botón Añadir?\n 0: No \n 1: Si'),
(502,'pmb','extended_search_auto','','¿En búsquedas multicritérios, seleccionando un caampo se añade automáticamente sin necesidad de hacer clic sobre el botón Añadir?\n 0: No \n 1: Si'),
(503,'thesaurus','categories_affichage_ordre','','Configuración del orden de visualización de las categorías de un registro. \nPor orden alfabético: 0(por defecto)\nPor orden de entrada: 1'),
(504,'opac','categories_affichage_ordre','','Configuración del orden de visualización de las categorías de un registro. \nPor orden alfabético: 0(por defecto)\nPor orden de entrada: 1'),
(505,'pmb','rfid_driver','','Driver RFID : nombre del directorio que contiene los javascripts adecuados para el hardware.'),
(506,'pmb','allow_external_search','','Autorizar o no la búsqueda por conectores externos (también se oculta el menú de Administración-Conectores) \r\n 0 : No \r\n 1 : Si'),
(507,'pmb','scan_pmbws_client_url','','URL del interfaz de escaneo (cliente de webservice)'),
(508,'pmb','scan_pmbws_url','','URL del webservice de manejo del escáner'),
(509,'opac','biblio_main_header','','Texto que puede aparecer dentro del bloque principal, por encima del resto, necesario para ciertas actualizaciones en páginas especiales.'),
(510,'opac','sugg_localises','','¿Activar la sugerencia de localización de los lectores? \n 0: Sin localización posible.\n 1: Localización para elegir un lector \n 2: Localización restringida a la localización del lector.'),
(511,'acquisition','sugg_localises','','¿Activar la sugerencia de localización? \n 0: Sin localización posible. \n 1: Localización activada.'),
(512,'opac','categories_nav_max_display','','Limitar la visualización de categorías en la navegación dentro de las sub-categorías. 0: Sin limitación. >0: Número máximo de categorías a mostrar'),
(513,'pmb','pret_aff_limitation','','¿Activar la limitación de visualización de la lista de préstamos en la ficha del lector? \n 0: Inactivo. \n 1: Limitación activada'),
(514,'pmb','pret_aff_nombre','','Número de préstamos a mostrar si el parámetro pret_aff_limitation esta activo. \n 0: Ver todo. \n ## Número de préstamos a mostrar en la primera página'),
(515,'pmb','printer_ticket_url','','Permite la utilización de una impresora de ticket, conectada en local a la estación de préstamo cliente. Vacio : sin impresora. Url (http://localhost/printer/bixolon_srp350.php ) : impresora activa.'),
(518,'transferts','statut_transferts','','Id del estado en el que se colocarán los documentos en tránsito'),
(519,'transferts','validation_actif','','Activar la validación de transferencias\n 0: No \n 1: Si'),
(520,'transferts','nb_jours_pret_defaut','','Número días de préstamo por defecto'),
(521,'transferts','nb_jours_alerte','','Número de días antes de la finalización del préstamo para mostrar la alerta'),
(522,'transferts','transfert_transfere_actif','','Autorizar la transferencia del ejemplar ya transferido'),
(523,'transferts','tableau_nb_lignes','','Número de transferencias a mostrar dentro de la tabla'),
(524,'transferts','envoi_lot','','Procesamiento por lotes posible en envío'),
(525,'transferts','reception_lot','','Procesamiento por lotes posible en recepción'),
(526,'transferts','retour_lot','','Procesamiento por lotes posible en devolución'),
(527,'transferts','retour_origine','','Obligar a la devolución del ejemplar a su lugar de origen\n 0: No \n 1: Si'),
(528,'transferts','retour_origine_force','','Permitir la obligación de devolver el ejemplar\n 0: No \n 1: Si'),
(529,'transferts','retour_action_defaut','','Acción por defecto cuando se devuelva un préstamo\n 0: cambiar localización \n 1: generar transferencia'),
(530,'transferts','retour_action_autorise_autre','','Autoriza otra acción en la devolución del ejemplar\n 0: No\n 1: Si'),
(531,'transferts','retour_change_localisation','','Backup de la localización al cambiar\n 0: No \n 1: Si'),
(532,'transferts','retour_etat_transfert','','Estado de la transferencia en la generación automática auto\n 0: crear \n 1: enviar'),
(533,'transferts','retour_motif_transfert','','Motivo de la transferencia en la generación automática'),
(534,'transferts','choix_lieu_opac','','0 para ninguna elección ni necesidad de localización o usuarios registrados, 1 para cualquier elección de ubicación, 2 para una ubicación fija especificada, 3 para la ubicación del ejemplar'),
(535,'transferts','site_fixe','','id del sitio para la eliminación de libros, si choix_lieu_opac=2'),
(536,'transferts','resa_motif_transfert','','Motivo de la transferencia en la generación automática para una reserva'),
(537,'transferts','resa_etat_transfert','','Estado de la transferencia en la generación automática\n 0: crear \n 1: enviar'),
(538,'pmb','recherche_ajax_mode','','Visualización acelerada de los resultados de la búsqueda: \"pequeña\" unicamente, cargar después de hacer clic en \"+\". \n 0: Inactivo \n 1: Activo'),
(539,'pmb','expl_title_display_format','','Formato de visualización del título del ejemplar en las búsquedas multicriterios de ejemplares. Las etiquetas de los campos corresponden a los campos de la tabla exemplaires, o a los id de los campos personalizados. Separados por comas. Los campos que dispongan de una etiqueta serán reemplazados por la etiqueta correspondiente. Ejemplo: expl_location,expl_section,expl_cote,expl_cb'),
(540,'opac','empr_code_info','','Código HTML mostrado encima de los botones de la ficha del prestatario.'),
(541,'opac','term_search_height_bottom','','Altura de la parte superior del marco de búsqueda por palabras (en px)'),
(542,'pmb','rfid_library_code','','Código numérico de identificación de la biblioteca propietaria de los ejemplares (10 caracteres)'),
(543,'opac','show_infopages_id','','Id de las infopages a mostrar en la búsqueda simple, separados por comas.'),
(544,'thesaurus','auto_postage_montant','','¿Activar la búsqueda de registros de categorías padre? \n  0 No, \n 1 Si'),
(545,'thesaurus','auto_postage_descendant','','¿Activar la búsqueda de registros de categorías hija? \n 0 No, \n 1 Si'),
(546,'thesaurus','auto_postage_nb_descendant','','Número de niveles de búsqueda de registros en las categorías hijas. \n *: ilimitado, \n n: número de niveles'),
(547,'thesaurus','auto_postage_nb_montant','','Número de niveles de búsqueda de registros en las categorías padre. \n *: ilimitado, \n n: número de niveles'),
(548,'thesaurus','auto_postage_etendre_recherche','','Ofrecer la posibilidad de ampliar la búsqueda en las categorías padre e hijas. \n 0: No, \n 1: Exclusivamente en las categorías hijas, \n 2: Ampliar en las categorías padres e hijas, \n 3: Exclusivamente en las categorías padre.'),
(549,'opac','auto_postage_montant','','Activar la búsqueda de registros en categorías padre. \n 0 No, \n 1 Si'),
(550,'opac','auto_postage_descendant','','Activar la búsqueda de registros en categorías hija. \n 0 No, \n 1 Si'),
(551,'opac','auto_postage_nb_descendant','','Número de niveles de búsqueda de registros en las categorías hijas. \n *: ilimitado, \n n: número de niveles'),
(552,'opac','auto_postage_nb_montant','','Número de niveles de búsqueda de registros en las categorías padre. \n *: ilimitado, \n n: número de niveles'),
(553,'opac','auto_postage_etendre_recherche','','Ofrecer la posibilidad de ampliar la búsqueda en las categorías padre e hijas. \n 0: No, \n 1: Exclusivamente en las categorías hijas, \n 2: Ampliar en las categorías padres e hijas, \n 3: Exclusivamente en las categorías padre.'),
(554,'gestion_acces','active','','¿Módulo de gestión de derechos de acceso activado?\n 0 : No.\n 1 : Si.'),
(555,'gestion_acces','user_notice','','Gestionar los derechos de acceso de los usuarios a los registros \n 0 : No.\n 1 : Si.'),
(556,'pmb','abt_end_delay','','Plazo de alerta para la advertencia de los abonos que están llegando a su finalización (en días)'),
(557,'pmb','set_time_limit','','max_execution_time de ciertas operaciones (exportación de acciones personalizadas, envíos DSI, exportaciones, etc.) \n Atención,  puede no tener efecto si el alojamiento no lo permite (free.fr por ejemplo)\n 0 : ilimitado (desaconsejado) \n ###: ### segundos'),
(558,'pmb','expl_list_display_comments','','Mostrar los comentarios de los ejemplares en la lista de ejemplares : \r\n 0 : No \r\n 1 : comentario de bloqueo \r\n 2 : comentario sin bloqueo \r\n 3 : ambos comentarios'),
(559,'pmb','confirm_delete_from_caddie','','Acción a realizar en la eliminación de un registro situado en un panel. \r\n0 : Prohibir \r\n1 : Eliminar sin confirmación \r\n2 : Solicitar la confirmación de eliminación'),
(560,'opac','flux_rss_notices_order','','Orden de visualización de las reseñas en los flujos de salida del OPAC \n  index_serie, tnvol, index_sew : seleccionar por título de série y título \n rand()  : aleatorio \n notice_id desc por orden decreciente de creación del registro'),
(561,'opac','modules_search_titre_uniforme','','Búsqueda simple dentro de títulos uniformes :\n 0 : prohibida\n 1 : autorizada\n 2 : autorizada y validada por defecto\n -1 : prohibida también en búsqueda multicriterio'),
(562,'opac','congres_affichage_mode','','Modo visualización congreso: \n 0 : En cuanto a los autores, \n 1 : añadir un navegador de congreso'),
(563,'opac','show_suggest_notice','','Mostrar el enlace a la propuesta de sugerencia en un registro existente.\n 0 : No.\n 1 : Si, con autenticación.\n 2 : Si, sin autenticación.'),
(564,'pmb','explnum_statut','','Utilizar un estado para los documentos digitales \n 0: No \n 1: Si'),
(565,'opac','show_empty_items_block','','Mostrar el bloque ejemplares incluso si no hay ejemplares para el registro? : \n 0 : No, \n 1 : Si'),
(566,'pmb','printer_ticket_script','','Script para personalizar la impresión del ticket de préstamo. El directorio del script se fija a partir de la raiz de PMB.\nSi esta vacío PMB utilizar ./circ/ticket-pret.inc.php'),
(567,'opac','curl_proxy','','Configuración de proxy de cURL, si no hay proxy. De lo contrario \nhost,port,user,password;2nd_host, etc'),
(568,'pmb','curl_proxy','','Configuración de proxy de cURL, si no hay proxy. De lo contrario \nhost,port,user,password;2nd_host, etc'),
(570,'opac','password_forgotten_show','','Mostrar el enlace \"¿Olvidó su contraseña?\" \n 0: No \n 1: Si'),
(571,'opac','aff_expl_localises','','Activar la visualización de los ejemplares localizados por pestañas.\n 0 : Desactivado \n 1: En la primera pestaña mostrar los ejemplares de la localización del lector, en la segunda mostrar todos los ejemplares'),
(572,'gestion_acces','empr_notice','','Gestión de los derechos de acceso de los prestatarios a las reseñas \n 0 : No.\n 1 : Si.'),
(573,'opac','show_infopages_id_top','','Id de las infopages a mostrar EN la búsqueda simple, separados por coma.'),
(574,'opac','show_search_title','','Mostrar el título del bloque de búsqueda : \n 0 : No, \n 1 : Si'),
(575,'opac','allow_personal_search','','Activar la visualización de la pestaña de búsquedas personalizadas \n 0 : No.\n 1 : Si.'),
(576,'ldap','opac_only','','No utilizar la autenticación LDAP en gestión: \n 0: No \n 1 : Si, sólo en OPAC'),
(577,'pmb','multi_search_operator','','Tipo de operador de búsqueda para las listas con varios valores: \n or : para O \n and : para Y'),
(578,'opac','multi_search_operator','','Tipo de operador de búsqueda para las listas con varios valores: \n or : para O \n and : para Y'),
(579,'transferts','pret_statut_transfert','','Autorizar el préstamo cuando el ejemplar se transfiere'),
(580,'exportparam','generer_liens','','Generar los vínculos entre reseñas para la exportación'),
(581,'exportparam','export_mere','','Exportar las reseñas madre relacionadas'),
(582,'exportparam','export_fille','','Exportar los reseñas hijas relacionados'),
(583,'exportparam','export_bull_link','','Exportar los vínculos a los boletines para las reseñas de artículo'),
(584,'exportparam','export_perio_link','','Exportar los vínculos a los periódicos para las reseñas de artículo'),
(585,'exportparam','export_art_link','','Exportar los vínculos a los artículos para las reseñas de periódicos'),
(586,'exportparam','export_bulletinage','','Generar el boletinage para las reseñas de periódicos'),
(587,'exportparam','export_notice_perio_link','','Exportar las reseñas relacionadas con el periódico'),
(588,'exportparam','export_notice_art_link','','Exportar las reseñas relacionadas con el artículo'),
(589,'exportparam','export_notice_mere_link','','Exportar las reseñas madres relacionadas'),
(590,'exportparam','export_notice_fille_link','','Exportar las reseñas hija relacionadas'),
(591,'opac','exp_generer_liens','','Generar los vínculos entre las reseñas para la exportación'),
(592,'opac','exp_export_mere','','Exportar las reseñas madre relacionados'),
(593,'opac','exp_export_fille','','Exportar los reseñas hijas relacionados'),
(594,'opac','exp_export_bull_link','','Exportar los vínculos a los boletines para las reseñas de artículo'),
(595,'opac','exp_export_perio_link','','Exportar los vínculos a los periódicos para las reseñas de artículo'),
(596,'opac','exp_export_art_link','','Exportar los vínculos a los artículos para las reseñas de periódicos'),
(597,'opac','exp_export_bulletinage','','Generar el boletinage para las reseñas de periódicos'),
(598,'opac','exp_export_notice_perio_link','','Exportar las reseñas relacionadas con el periódico'),
(599,'opac','exp_export_notice_art_link','','Exportar las reseñas relacionadas con el artículo'),
(600,'opac','exp_export_notice_mere_link','','Exportar las reseñas madre relacionados'),
(601,'opac','exp_export_notice_fille_link','','Exportar los reseñas hijas relacionados'),
(602,'pmb','perio_vidage_log','','Frecuencia de transferencia de datos entre la tabla temporal de logs a la tabla de almacenamiento (en días).'),
(603,'pmb','perio_vidage_stat','','Frecuencia de vaciado de la tabla de almacenamiento (modo,día) : \r\n0 : no hacer nada\r\n1,x : vaciar todo los x días\r\n2,x : vaciar todo además de x días'),
(604,'pmb','logs_activate','','Activar las estadísticas para el OPAC: \n 0 : No activado \n 1 : Activado'),
(605,'opac','shared_lists','','Activar las listas de lectura compartida \n 0 : No activado \n 1 : Activado'),
(606,'pmb','indexation_docnum','','Activar la indexación de documentos digitals \n 0 : No activado \n 1 : Activado'),
(607,'pmb','indexation_docnum_allfields','','Activar por defecto la búsqueda dentros de documentos digitales para las búsqueda \"Todos los campos\" \n 0 : No activado \n 1 : Activado'),
(608,'opac','indexation_docnum_allfields','','Activar por defecto la búsqueda dentro de documentos digitales para las búsquedas \"Todos los campos\" \n 0 : No activado \n 1 : Activado'),
(609,'opac','modules_search_docnum','','Búsqueda simple dentro de documentos digitales \n 0 : prohibido \n 1 : Autorizado \n 2 : Autorizado y validado por defecto'),
(610,'pmb','location_reservation','','Utilizar la gestión de la reserva localizada?\n 0: No\n 1: Si'),
(611,'pmb','extension_tab','','¿Mostrar la pestaña Extensión? \n 0 : No \n 1 : Si'),
(612,'pmb','indexation_docnum_default','','¿Indexar por defecto el documento digital? \n 0 : No \n 1 : Si'),
(613,'opac','shared_lists_readonly','','Listas de lectura compartida en sólo lectura \n 0 : No activado \n 1 : Activado'),
(614,'opac','connexion_phrase','','Frase para la codificación de la conexión automática desde un email'),
(615,'pmb','afficher_numero_lecteur_lettres','','Mostrar el número y email del lector bajo su dirección en las diferentes cartas'),
(616,'pmb','lettres_bloc_adresse_position_absolue','','Coloque el bloque dirección de acuerdo a las coordenadas absolutas.\nActivado x y\nActivado : activar esta función (valores: 0/1)\nx : Posición horizontal\ny : Posición vertical'),
(617,'pmb','external_service_search_cache','','Duración de las búsquedas en la caché, para los servicios externos, en segundos.'),
(618,'pmb','external_service_session_duration','','Duración de las sesiones, para los servicios externos, en segundos.'),
(619,'opac','allow_multiple_sugg','','Autorizar las sugerencias múltiples.\r\n0: No\r\n1: Si'),
(620,'dsi','bannette_notices_template','','Id de la plantilla de reseña utilizada por defecto en la difusión de bannettes. Si esta vacio o a 0, será utilizada la plantilla clásica.'),
(621,'demandes','active','','Módulo de peticiones activo.\n 0 : No.\n 1 : Si.'),
(622,'demandes','statut_notice','','Id de estado de reseña para la reseña pedida.'),
(623,'opac','demandes_active','','Activar las peticiones para el OPAC.\n 0 : No.\n 1 : Si.'),
(624,'pmb','use_uniform_title','','¿Utilizar los títulos uniformes? \r\n 0 : No.\r\n 1 : Si.'),
(625,'opac','print_expl_default','','En la impresión de las cestas, imprimir los ejemplares marcados por defecto \n 0 : No \n 1 : Si'),
(626,'demandes','include_note','','Incluir automáticamente las notas en el informe documental.'),
(627,'opac','ie_reload_on_resize','','¿Recargar la página si el usuario redimensiona su navegador (pb de CSS en IE) ? \n 0: No \n 1: Si'),
(628,'pmb','expl_show_dates','','¿Mostrar las fechas de ejemplares? \n 0 : Ninguna fecha.\n 1 : Fecha de creación y modificación.\n 2 : Fecha de depósito y retorno (BDP).\n 3 : Fecha de creación, modificación, depósito y retorno.'),
(629,'gestion_acces','user_notice_def','','Valor por defecto en modificación de reseña por los derechos de acceso usuarios-reseñas \n 0 : Recalcular.\n 1 : Elegir.'),
(630,'gestion_acces','empr_notice_def','','Valor por defecto en modificación de reseña por los derechos de acceso prestatarios-reseñas \n 0 : Recalcular.\n 1 : Elegir.'),
(631,'opac','show_exemplaires_analysis','','Mostrar los ejemplares del boletín para el artículo mostrado? \n 0: No \n 1: Si'),
(632,'pmb','show_notice_id','','¿Mostrar el identificador de la reseña en la descripción? \n 0 : No.\n 1 : Si. \n 1,X : Si con el prefijo X'),
(633,'opac','section_notices_order','','Orden de visualización de las reseñas en las secciones en el OPAC \n  index_serie, tnvol, index_sew : seleccionar por título de série y por título'),
(634,'opac','show_onglet_help','','Mostrar la pestaña AYUDA junto con las pestañas de búsqueda que muestra la infopage y con un enlace a la infopage en la barra de navegación \n 0 : No.\n ## : id de la infopage. \n'),
(635,'opac','navig_empr','','¿Mostrar la pestaña \"Su cuenta\" en la barra de navegación del OPAC? \n 0 : No \n 1 : Si'),
(637,'pmb','prefill_cote_ajax','','Script personalizado de construcción de la signatura del ejemplar en ajax'),
(638,'pmb','hide_biblioinfo_letter','','Ocultar la información de localización en la cabecera de las cartas (para las bibliotecas con papel con membrete)'),
(639,'pmb','lettres_code_mail_position_absolue','','Situar el código del lector y el email de acuerdo a las coordenadas absolutas.\n Activar x y \n Activado: activar esta función (valores: 0/1) \n x : Posición horizontal \n y : Posisión vertical'),
(640,'opac','adhesion_expired_status','','Id del estado para restringir los derechos de los prestatarios cuyo abono este caducado. \n\rPMB hacer un AND lógico con los derechos originales.'),
(641,'pmb','resa_retour_action_defaut','','Definir la acción por defecto a realizar en la devolución si el documento está reservado.\r\n0, Tratar más tarde.\r\n1, Validar la reserva.'),
(642,'pmb','notice_fille_format','','Mostrar las reseñas hijas \n 0: con sus detalles (reseña desplada con un más) \n 1: Sólo el título'),
(643,'pmb','hide_retdoc_loc_error','','Gestion de la devolución del préstamo de un documento desde otra localización:\n 0 : Devolver, sin mensaje de error\n 1 : No devolver, con mensaje de error\n 2 : Devolver, con mensaje de error'),
(644,'pmb','selfservice_allow','','¿Activar la gestión del terminal de préstamo?\n0 : No. \n1 : Si.'),
(645,'selfservice','loc_autre_todo','','Acción a realizar si el documento es de otra localización'),
(646,'selfservice','loc_autre_todo_msg','','Mensaje si el documento está reservado en otra localización'),
(647,'selfservice','resa_ici_todo','','Acción a realizar si el documento está reservado en su localización'),
(648,'selfservice','resa_ici_todo_msg','','Mensaje si el documento está reservado en su localización'),
(649,'selfservice','resa_loc_todo','','Acción a realizar si el documento está reservado en otra localización'),
(650,'selfservice','resa_loc_todo_msg','','Mensaje si el documento está reservado en otra localización'),
(651,'selfservice','retour_retard_msg','','Mensaje si el documento es devuelto con retraso'),
(652,'selfservice','retour_blocage_msg','','Mensaje si el documento es devuelto con retraso y bloqueo'),
(653,'selfservice','retour_amende_msg','','Mensaje si el documento es devuelto con retraso y multa'),
(654,'selfservice','pret_carte_invalide_msg','','Mensaje del terminal de préstamo: ¡Su tarjeta no es válida!'),
(655,'selfservice','pret_pret_interdit_msg','','Mensaje del terminal de préstamo: ¡No está autorizado a pedir un préstamo!'),
(656,'selfservice','pret_deja_prete_msg','','Mensaje del terminal de préstamo: ¡Documento ya prestado!'),
(657,'selfservice','pret_deja_reserve_msg','','Mensaje del terminal de préstamo: Usted no puede pedir prestado este documento'),
(658,'selfservice','pret_quota_bloc_msg','','Mensaje del terminal de préstamo: Usted no puede pedir prestado este documento'),
(659,'selfservice','pret_non_pretable_msg','','Mensaje del terminal de préstamo: Este documento no puede ser prestado'),
(660,'selfservice','pret_expl_inconnu_msg','','Mensaje del terminal de préstamo: Documento desconocido'),
(661,'selfservice','pret_prolonge_non_msg','','Mensaje del terminal de préstamo: El préstamo no puede ser prorrogado'),
(675,'opac','visionneuse_params','','tabla de correspondencia mimetype=>clases'),
(676,'opac','allow_self_checkout','','Proponer hacer préstamo autónomo en el OPAC.\n 0 : No.\n 1 : Autoriza el préstamo de documento.\n 2 : Autoriza el retorno de documento.\n 3 : Autorizar el préstamo y retorno de documento.\n'),
(663,'opac','photo_filtre_mimetype','','Lista de mimetypes utilizados para mostrar los resultados en modo imagen separados por comas y entre signaturas (ejemplo:\'application/pdf\',\'image/png\')'),
(664,'empr','sms_activation','','Activación del envío de sms. : envío 1, envío 2, envío 3, envío\n\n 0: Inactivo\n 1: Activo'),
(665,'empr','sms_config','','Configuración del envío de sms. \nUsar:\n class_name=nom_de_la_classe;param_connection;\nEjemplo:\n class_name=smstrend;login=xxxx@sigb.net;password=xxxx;tpoa=xxxx;'),
(666,'empr','sms_msg_resa_dispo','','Texto del sms enviado durante la validación de una reserva'),
(667,'empr','sms_msg_resa_suppr','','Texto del sms enviado durante la eliminación de una reserva'),
(668,'empr','sms_msg_retard','','Texto del sms enviado durante un retraso'),
(669,'pmb','procedure_server_address','','Dirección del servidor de procedimientos remotos.'),
(670,'pmb','procedure_server_credentials','','Autenticación en el servidor de procedimientos remotos.\n1ª linea: email\n2ª línea: contraseña.'),
(671,'pmb','rfid_pret_mode','','Modo de funcionamiento del préstamo:\n 0: Un documento retirado de la pletina se retira del préstamo.\n 1: Un documento retirado de la pletina es conservado para facilitar el préstamo de más documentos.'),
(672,'internal','emptylogstatopac','','Configuración interna, no modificar\r\n =1 si volcado de los logs está en curso'),
(673,'fiches','active','','Módulo \'fichas\' activado.\n 0 : No.\n 1 : Si.'),
(674,'opac','visionneuse_allow','','Visionadora activada.\n 0 : No.\n 1 : Si.'),
(677,'opac','self_checkout_url_connector','','URL de conexión en gestión para permitir realizar el préstamo de forma autónoma.'),
(678,'finance','recouvrement_lecteur_statut','','Guardar el estado que toman los lectores durante el proceso de cobro'),
(679,'thesaurus','auto_postage_search','','Activar la indexación de categorías madres e hijas para la búsqueda de reseñas. \n 0 No, \n 1 Si'),
(680,'thesaurus','auto_postage_search_nb_descendant','','Número de niveles de búsqueda de reseñas dentro de categorías hijas. \n *: ilimitado, \n n: número de niveles'),
(681,'thesaurus','auto_postage_search_nb_montant','','Número de niveles de búsqueda de reseñas dentro de categorías madre. \n *: ilimitado, \n n: número de niveles'),
(682,'opac','show_bulletin_nav','','Visualizado de un navegador en los boletínes de un periódico.\r\n 0 No \r\n 1 Si'),
(683,'pmb','play_pret_sound','','¿Reproducir alerta sonora si el préstamo y la devolución se realizan sin error? \n 0 : No.\n 1 : Si.'),
(684,'pmb','catalog_verif_js','','Script de verificación de entrada de reseñas'),
(685,'opac','default_style_addon','','¿Añadir estilos CSS a las horas ya existentes?\r\n No ponga el código CSS, ejemplo:  body {background-color: #FF0000;}'),
(686,'pmb','rfid_gates_server_url','','URL del servidor de pórticos RFID'),
(687,'pmb','perso_sep','','Separador de valores de campo personalizado, espacio o ; o , o ...'),
(688,'pmb','search_full_text','','Utilizar un índice MySQL FULLTEXT para la búsqueda en los documentos digitales \n 0: No \n 1: Si'),
(689,'opac','parse_html','','Activar el parseo HTML de páginas OPAC \n 0: No \n 1: Si'),
(690,'opac','notice_enrichment','','Activar el enriquecimiento de reseñas \n 0: No \r\n 1: Si'),
(691,'opac','show_social_network','','Activar la compartición con las redes sociales \r\n 0: No \r\n 1: Si'),
(692,'pmb','opac_view_activate','','Activar las vistas OPAC :\n 0 : No activado \n 1 : Activado con la gestión clásica \n 2 : Activado con la gestión avanzada'),
(693,'opac','opac_view_activate','','Activar las vistas OPAC :\n 0 : No activado \n 1: Activado'),
(694,'pmb','sur_location_activate','','Activar en localizaciones:\n 0 : No activado \n 1 : Activado'),
(695,'opac','sur_location_activate','','Activar en localizaciones:\n 0 : No activado \n 1 : Activado'),
(696,'pmb','opac_view_class','','Nombre de la clase que sustituye a la clase opac_view para la personalización de la gestión de las vistas OPAC'),
(697,'opac','faviconurl','','URL del fabicon, si esta vacio favicon=celui de PMB'),
(698,'opac','allow_affiliate_search','','Activar las búsquedas anidadas en OPAC:\n 0 : No \n 1 : Si'),
(699,'acquisition','pdfrel_format_page','','Ancho x Alto de la página en mm'),
(700,'acquisition','pdfrel_orient_page','','Orientación de la página P=Horizontal, L=Vertical'),
(701,'acquisition','pdfrel_marges_page','','Márgenes de la página en mm : Arriba, Abajo, Derecha, Izquierda'),
(702,'acquisition','pdfrel_pos_logo','','Posición del logo: Distancia desde el borde izquierdo de la página, Distancia desde el borde superior de la página, Ancho, Alto'),
(703,'acquisition','pdfrel_pos_raison','','Posición de la Razón Social: Distancia desde el borde izquierdo de la página, Distancia desde el borde superior de la página, Ancho, Alto, Tamaño de la fuente'),
(704,'acquisition','pdfrel_pos_date','','Posición de la Fecha: Distancia desde el borde izquierdo de la página, Distancia desde el borde superior de la página, Ancho, Alto, Tamaño de la fuente'),
(705,'acquisition','pdfrel_pos_adr_rel','','Posición de la Dirección de contacto: Distancia desde el borde izquierdo de la página, Distancia desde el borde superior de la página, Ancho, Alto, Tamaño de la fuente'),
(706,'acquisition','pdfrel_pos_adr_fou','','Posición de la Dirección del proveedor: Distancia desde el borde izquierdo de la página, Distancia desde el borde superior de la página, Ancho, Alto, Tamaño de la fuente'),
(707,'acquisition','pdfrel_pos_num_cli','','Posición del número de cliente: Distancia desde el borde izquierdo de la página, Distancia desde el borde superior de la página, Ancho, Alto, Tamaño de la fuente'),
(708,'acquisition','pdfrel_pos_num','','Posición del número de pedido/presupuesto: Distancia desde el borde izquierdo de la página, Ancho, Alto, Tamaño de la fuente'),
(709,'acquisition','pdfrel_text_size','','Tamaño de la fuente del texto'),
(710,'acquisition','pdfrel_pos_titre','','Posición del título: Distancia desde el borde izquierdo de la página, Distancia desde el borde superior de la página, Ancho, Alto, Tamaño de la fuente'),
(711,'acquisition','pdfrel_text_before','','Texto antes de la tabla de recordatorios'),
(712,'acquisition','pdfrel_text_after','','Texto despues de la tabla de recordatorios'),
(713,'acquisition','pdfrel_tab_rel','','Tabla de recordatorios: Altura de linea, Tamaño de fuente'),
(714,'acquisition','pdfrel_pos_footer','','Posición píe de página: Distancia desde el borde inferior de la página, Tamaño de la fuente'),
(715,'acquisition','pdfrel_pos_sign','','Posición de la firma: Distancia desde el borde izquierdo de la página, Ancho, Alto de linea, Tamaño de fuente'),
(716,'acquisition','pdfrel_text_sign','','Texto de la firma'),
(717,'acquisition','pdfrel_by_mail','','Efectuar recordatorios por email :\n 0 : No \n 1 : Si'),
(718,'acquisition','pdfrel_text_mail','','Texto del email'),
(719,'opac','show_perio_browser','','Mostrar el navegador de periódicos en la página de inicio del OPAC.\n 0 : No.\n 1 : Si.'),
(720,'acquisition','pdfrel_pdfrtf','','Envío de recordatorios en :\n 0 : pdf\n 1 : rtf'),
(721,'opac','show_onglet_perio_a2z','','Activar la pestaña del navegador de periódicos en OPAC.\n 0 : No.\n 1 : Si.'),
(722,'opac','avis_note_display_mode','','Modo de visualización de la nota para los avisos de reseñas.\n 0 : Nota no visible.\n 1 : Mostrar la nota bajo la forma de asterísco.\n 2 : Mostrar la nota baja la forma de texto.\n 3 : Mostrar la nota bajo la forma de texto y asteríscos.'),
(723,'opac','avis_display_mode','','Modo de visualización de avisos de reseñas.\n 0 : Visible en línea al lado de la pestaña Público/ISBD de la reseña.\n 1 : Visible en la reseña.'),
(724,'pmb','planificateur_allow','','Planificador activado.\n 0 : No.\n 1 : Si.'),
(725,'acquisition','pdfrel_obj_mail','','Objeto del email'),
(726,'acquisition','pdfcde_by_mail','','Efectuar los envíos de pedidos por email :\n 0 : No \n 1 : Si'),
(727,'acquisition','pdfcde_obj_mail','','Objeto del email'),
(728,'acquisition','pdfcde_text_mail','','Texto del email'),
(729,'acquisition','pdfdev_by_mail','','Efectuar los envíos de solicitudes de presupuesto por email :\n 0 : No \n 1 : Si'),
(730,'acquisition','pdfdev_obj_mail','','Objeto del email'),
(731,'acquisition','pdfdev_text_mail','','Texto del email'),
(732,'pmb','docnum_in_database_allow','','¿Autorizar el almacenamiento de documentos digitales en base de datos? \n 0 : No.\n 1 : Si.'),
(733,'opac','recherche_ajax_mode','','Visualizado acelerado de los resultados de búsqueda: cabecera únicamente, el resto se cargará después de hacer clic en \"+\".\n 0: Inactivo\n 1: Activo (por lote)\n 2: Activo (por reseña)'),
(734,'pmb','avis_note_display_mode','','Modo de visualización de las nota para los avisos de reseña.\n 0 : Nota no visible.\n 1 : Mostrar la nota bajo la forma de asterísco.\n 2 : Mostrar la nota bajo la forma de texto.\n 3 : Mostrar la nota bajo la forma de texto y asterísco.'),
(735,'cms','active','','Módulo \'Portal\' activado.\n 0 : No.\n 1 : Si.'),
(736,'pmb','indexation_lang','','Elegir el idioma de la indexación por defecto. (ej : fr_FR,en_UK,...,ar), si este idioma esta vacio, será utilizado el idioma de la interfaz del catalogador.'),
(737,'opac','websubscribe_show_location','','Mostrar la posibilidad de que el lector pueda elegir la localización para las inscripciones en línea.\n 0: No\n 1: Si'),
(738,'opac','collstate_order','','Orden de visualización de los estados de las colecciones, en el orden dado, separado por comas : archempla_libelle,collstate_cote'),
(739,'opac','default_sort','','Selecccionar por defecto las búsquedas OPAC.\nDe la forma, c_num_6 (c para creciente. d para decreciente, num o text para número y texto y finalmente el identificador del campo (ver fichero xml sort.xml)'),
(740,'pmb','fine_precision','','Número de decimales para la visualización de multas'),
(741,'opac','search_cache_duration','','Período de validez (en segundos) de la caché para las búsquedas OPAC'),
(742,'pmb','path_php','','Ruta absoluta del interpretador PHP, local o remoto'),
(743,'opac','explnum_order','','Orden de visualización de los documentos digitales, en el orden dado, separado por comas : explnum_mimetype, explnum_nom, explnum_id'),
(744,'pmb','amende_comptabilisation','','Fecha en la que el inicio de la multa será contabilizado \r\n 0 : a partir de la fecha de devolución \r\n 1 : a partir de la fecha de grácia'),
(745,'pmb','pret_calcul_retard_date_debut_incluse','','¿Contar la fecha de retorno o de recordatorio como día de retraso para calcular la multa? \r\n 0 : No \r\n  1 : Si'),
(746,'opac','exclude_fields','','Identificación de los campos a excluir de la búsqueda por todos los campos (lista disponible dentro del fichero includes/indexation/champ_base.xml)'),
(747,'opac','serialcirc_active','','Activar la circulación de periódicos dentro del OPAC \r\n 0: No \r\n 1: Si'),
(748,'pmb','bdd_subversion','','Subversion de la base de datos'),
(749,'pmb','import_modele_authorities','','¿Que clase de importación utilizar para las reseñas de autoridades?'),
(750,'pmb','location_resa_planning','','¿Utilizar la gestión de la previsión localizada?\n 0: No\n 1: Si'),
(751,'demandes','email_demandes','','Información por email de la evolución de los pedidos.\n 0 : No\n 1 : Si'),
(752,'pmb','short_loan_management','','Gestión de los préstamos cortos\n 0: No\n 1: Si'),
(753,'pmb','loan_trust_management','','Gestión del monopolio del préstamo\n 0: No\n x: número de días entre 2 préstamos de un ejemplar de una misma reseña (o boletín)'),
(754,'opac','perio_a2z_abc_search','','Búsqueda alfabética en la navegación de periódicos en OPAC.\n0 : No.\n1 : Si.'),
(755,'opac','perio_a2z_max_per_onglet','','Búsqueda en el navegador de periódicos en OPAC : número máximo de reseñas por pestaña.'),
(756,'pmb','indexation_docnum_ext','','Configuración de la gestión de acceso a los programs externos para la indexación de documentos digitales :\n\n Cada parámetro se define con un par : \"nombre=valor\"\n Los parámetros son separados por un \"punto y coma\".\n\n\n Ejemplos de utilización de \"pyodconverter\", \"jodconverter\" et \"pdftotext\" :\n\npyodconverter_cmd=/opt/openoffice.org3/program/python /opt/ooo_converter/DocumentConverter.py %1s %2s;\njodconverter_cmd=/usr/bin/java -jar /opt/ooo_converter/jodconverter-2.2.2/lib/jodconverter-cli-2.2.2.jar %1s %2s;\njodconverter_url=http://localhost:8080/converter/converted/%1s;\npdftotext_cmd=/usr/bin/pdftotext -enc UTF-8 %1s -;'),
(757,'opac','notices_format_onglets','','Lista de id de plantillas de reseña para añadir a las pestañas personalizadas en el registro de reseña\nEjemplo: 1,3,ISBD,PUBLIC\nEl parámetro notices_format debe ponerse a 0 para colocar ISBD y PÚBLICO'),
(758,'opac','visionneuse_alert','','Mensaje de advertencia en la apertura de documentos digitales.'),
(759,'opac','cms','','id de CMS utilizado en OPAC'),
(760,'pmb','expl_data','','Columnas de ejemplares, dentro del orden dado, separadas por comas: expl_cb,expl_cote,location_libelle,section_libelle,statut_libelle,tdoc_libelle #n : id de los campos personalizados \r\n expl_cb es obligatorio y será añadio si no está'),
(761,'pmb','expl_display_location_without_expl','','Mostrar la lista de localizaciones sin ejemplares \n 0: No\n 1: Si'),
(762,'opac','show_group_checkout','','El responsable de un grupo de lectores ve los préstamos de su grupo\n 0: No\n 1: Si'),
(763,'opac','facette_in_bandeau_2','','La navegación por facettes aparece en el banner o en el banner 2 \n0 : en el banner\n1 : en el banner 2'),
(764,'opac','autolevel2','','0 : modo normal de búsqueda.\n1 : Mostrar el resultado de la búsqueda por todos los campos después del cálculo de nivel 1 de búsqueda.\n2 : Mostrar directamente el resultado de la búsqueda por todos los campos sin pasar por el cálculo de nivel 1 de búsqueda.'),
(765,'opac','first_page_params','','Estructura JSON recapitulando los parámetros a inicializar en la página principal :\nEjemplo : \n{\n\"lvl\":\"cmspage\",\n\"pageid\":2\n}'),
(766,'opac','show_links_invisible_docnums','','Mostrar los enlaces a los documentos digitales no visibles en modo fuera de línea. (No funciona para los derechos de acceso).\n 0 : No.\n1 : Si.'),
(767,'pmb','img_folder','','Directorio de almacenamiento de las imágenes'),
(768,'pmb','img_url','','URL de acceso al directorio de imagenes (pmb_img_folder)'),
(769,'pmb','book_pics_msg','','Mensaje en la visualización de las miniaturas de las reseñas correspondiente a la ruta proporcionada por el parámetro book_pics_url'),
(770,'opac','book_pics_msg','','Mensaje en la visualización de las miniaturas de las reseñas correspondiente a la ruta proporcionada por el parámetro book_pics_url'),
(771,'opac','visionneuse_alert_doctype','','Lista de tipos de documentos para los cúales se generará una alerta (separados por comas).'),
(772,'pmb','archive_warehouse','','Identificación del almaceń de archivado para la eliminación de reseñas.'),
(773,'pmb','printer_name','','Nombre de la impresora de tickets de préstamo, utilizando el applet jzebra. El nombre de la impresora debe coincidir con la clase desarrollada específicamente para su utilización.\nEjemplo: Denominación de la impresora\'metapace\' para utilizar el driver classes/printer/metapace.class.php'),
(774,'empr','groupes_localises','','Grupo de lectores localizados para informe del responsable \n0: No \n1: Si'),
(775,'opac','allow_simili_search','','Activar las búsquedas similares en una reseña :\n0 : No\n1 : Activar la búsqueda \"En la misma sección\" y \"Puede que le interese\"\n2 : Activar solamente la búsqueda \"En la misma sección\"\n3 : Activar solamente la búsqueda \"Puede que le interese\"'),
(776,'opac','notices_depliable_plus','','Imagen a utilizar delante de un título de reseña plegado'),
(777,'opac','notices_depliable_moins','','Imagen a utilizar delante de un título de reseña desplegado'),
(778,'pmb','pret_groupement','','Activar el préstamo de ejemplares reagrupados en un sólo lote. La gestión de los grupos se realiza en Circulación / Grupo de ejemplares :\n 0 : No \n 1 : Si'),
(779,'transferts','regroupement_depart','','Activar el reagrupamiento de salidas \n 0: No \n 1: Si'),
(780,'pmb','rfid_afi_security_codes','','Gestión del antirobo por el registro AFI.\nEl primer valor corresponde al antirobo activado, el segundo corresponde al antirobo desactivado.\nEjemplo: 07,C2 '),
(816,'pmb','num_carte_auto','','¿Número de carnet de lector automático?\n 0:No (si se utilizan carnets preimpresos\n 1: Si, completamente numérico\n 2,a,b,c: Si con prefijo: a=longitud del prefijo, b=número de cifras de la parte numérica, c=prefijo fijo (opcional)\n 3: función de generación específica dentro del fichero nombrado de la misma forma, a colocar dentro de pmb/circ/empr'),
(1148,'acquisition','mel_rej_cor','','Cuerpo del email de rechazo de sugerencia'),
(1166,'cms','url_base_cms_build','','url de construcción de CMS del OPAC'),
(945,'categories','show_only_last','','En la ficha de una reseña : \n 0 mostrar todo \n 1 : mostrar únicamente la última hoja del árbol de la categoría'),
(1163,'opac','simple_search_suggestions','','Activar la sugerencia de palabras en la búsqueda simple a través de la terminación\n0 : Desactivar\n1 : Activar\n\nNB : Esta función necesita la instalación de la extensión levenshtein en MySQL'),
(1164,'opac','stemming_active','','Activar el stemming en la búsqueda\n0 : Desactivar\n1 : Activar\n'),
(1181,'pmb','logs_exclude_robots','','¿Excluir los robots en los logs OPAC? \n0:No \n1:Si \n Poner seguido de una coma para excluir eventualmente los logs OPAC provenientes de ciertas direcciones IP separadas a su vez por comas (por ejemplo: 1,127.0.0.1,192.168.0.1)'),
(1182,'pmb','notice_img_pics_max_size','','Tamaño máximo de las miniaturas cargadas de las reseñas, en longitud o en altura '),
(1183,'pmb','psexec_cmd','','Parámetros de ejecución de psexec (planificador bajo windows)\nAñadir la opción -accepteula a las versiones más recientes'),
(1185,'opac','show_bandeau_2','','¿Mostrar el banner_2?\n 0 : No \n 1 : Si'),
(1186,'opac','param_social_network','','Tabla de configuración del API de gestión de las interconexiones con redes sociales.\n			Formato JSON.\n			Ejemplo :\n			{\n			\"token\":\"ra-4d9b1e202c30dea1\",\n			\"version\":\"300\",\n			\"buttons\":[\n			{\n			\"attributes\":{\n			\"class\":\"addthis_button_preferred_1\"\n			}\n			},\n			{\n			\"attributes\":{\n			\"class\":\"addthis_button_preferred_2\"\n			}\n			},\n			{\n			\"attributes\":{\n			\"class\":\"addthis_button_preferred_3\"\n			}\n			},\n			{\n			\"attributes\":{\n			\"class\":\"addthis_button_preferred_4\"\n			}\n			},\n			{\n			\"attributes\":{\n			\"class\":\"addthis_button_compact\"\n			}\n			},\n			{\n			\"attributes\":{\n			\"class\":\"addthis_counter addthis_bubble_style\"\n			}\n			}\n			],\n			\"toolBoxParams\":{\n			\"class\":\"addthis_toolbox addthis_default_style addthis_32x32_style\"\n			},\n			\"addthis_share\":{\n			\n			},\n			\"addthis_config\":{\n			\"data_track_addressbar\":true\n			}\n			}'),
(1187,'opac','default_sort_list','','¿Añadir un combo de selección a una selección? \n 0 : No \n 1 : Si \nSepare con una coma para la adición de nuevas selecciones de esta forma: c_num_6|Etiqueta;d_text_7|Etiqueta 2;c_num_5|Etiqueta 3\n\nc para creciente, d para decreciente\nnum o text para número o texto\nidentificación del campo (ver el fichero xml sort.xml)\netiqueta de selección (opcional)'),
(1188,'transferts','pret_demande_statut','','Aplicar este estado antes de la validación'),
(1189,'opac','perio_a2z_show_bulletin_notice','','Mostrar la reseña de boletín en el navegador de periódicos'),
(1190,'pmb','procs_force_execution','','Permitir la ejecución forzada de procedimientos'),
(1191,'opac','draggable','','Permite activar arrastar y soltar en la cesta en la visualización de reseñas en el OPAC'),
(1192,'cms','cache_ttl','','Duración de la vida de la caché de los marcos del portal (en segundos)'),
(1193,'opac','meta_description','','Contenido de la meta-etiqueta descripción para los motores de búsqueda'),
(1194,'opac','meta_keywords','','Contenido de la meta-etiqueta keywords para los motores de búsqueda'),
(1195,'opac','meta_author','','Contenido de la meta-etiqueta autor para los motores de búsqueda'),
(1196,'pmb','html_allow_expl_cote','','¿Autorizar el código HTML en las signaturas de las reseñas? \n 0 : No \n 1 : Si'),
(1197,'pmb','serialcirc_subst','','Nombre del fichero para personalizar la impresión de la lista de circulación de periódicos'),
(1198,'pmb','serial_thumbnail_url_article','','¿Prerellenado de la url de la viñeta de recuento con la url de la viñeta de la reseña madre en el catálogo de periódicos? \n 0 : No \n 1 : Si'),
(1199,'pmb','mail_delay','','Tiempo de espera en milisegundos entre cada envío de email en un lote. \n 0 : No esperar'),
(1200,'pmb','curl_timeout','','Timeout cURL (en segundos) para la verificación de vínculos'),
(1201,'empr','allow_prolong_members_group','','¿Autorizar la prolongación agrupada de inscripciones de los miembros de un grupo? \n 0 : No \n 1 : Si'),
(1202,'thesaurus','auto_index_notice_fields','','Lista de campos de reseña a utilizar par al indexación automática.\n\nSintaxis: nombre_campo=peso_indexation;\n\nEl nombre de campos se especifica en el fichero XML \"pmb/includes/notice/notice.xml\"\nEl peso de la indexación es un valor de 0.00 à 1. (Si este no es precisado, el peso es 1)\n\nEjemplo :\n\ntit1=1.00;n_resume=0.5;'),
(1203,'thesaurus','auto_index_search_param','','Sobrecarga de parámetros de búsqueda de la indexación automática.\nSintaxis: parametro=valor;\n\nListas de paŕametros:\n\nmax_relevant_words = 20 (número máximo de palabras y lemas de la reseña a tener en cuenta en el cálculo)\n\nautoindex_deep_ratio = 0.05 (ratio de la profundidad del término en el thesaurus)\nautoindex_stem_ratio = 0.80 (ratio de la ponderación de los lemas / palabras)\n\nautoindex_max_up_distance = 2 (distancia máxima de búsqueda dentro de los términos genéricos del thesaurus)\nautoindex_max_up_ratio = 0.01 (ponderación de los términos genéricos)\n\nautoindex_max_down_distance = 2 (distancia máxima de búsqueda en los términos específicos del thesaurus)\nautoindex_max_down_ratio = 0.01 (ponderación de los términos específicos)\n\nautoindex_see_also_ratio = 0.01 (sobreponderación de los términos del thesaurus)\n\nautoindex_distance_type = 1 (cálculo de distancia de 1 a 4)\nautoindex_distance_ratio = 0.50 (ratio de ponderación de la distancia entre las palabras encontradas y los términos de una expresión del thesaurus)\n\nmax_relevant_terms = 10 (número máximo de términos devueltos)'),
(1204,'empr','abonnement_default_debit','','Elegir por defecto la prolongación de los lectores. \n 0 : No cargar la subscripción \n 1 : Cargar la subscripción sin la fianza \n 2 : Cargar la subscripción y la fianza'),
(1184,'pmb','synchro_rdf','','Activar la sincronización rdf. \n 0: No \n 1: Si (la activación de este parámetro requiere la reindexación)'),
(1172,'opac','websubscribe_num_carte_auto','','¿Número de carnet de lector automático? \n 2,a,b,c: Si con prefijo: a=longitud del prefijo, b=número de cifras de la parte numérica, c=prefijo fijo (opcional) \n 3, función: función de generación específica nombrado de la misma manera para colocar en pmb/opac_css/circ/empr'),
(1205,'opac','print_template_default','','En la impresión de cestas, identificación de la plantilla de reseña utilizada por defecto. Si esta vacio o a 0, se utilizará la plantilla clásica'),
(1206,'pmb','show_permalink','','¿Mostrar el enlace permanente del OPAC en gestión? \n 0 : No.\n 1 : Si.'),
(1207,'pmb','expl_show_lastempr','','¿Mostrar el prestatario precedente en la ficha del ejemplar? \n 0 : No.\n 1 : Si.'),
(1208,'pmb','gestion_financiere_caisses','','¿Activar la gestion de cajas en gestión financiera? \n 0 : No.\n 1 : Si.'),
(1209,'pmb','diarization_docnum','','Activar la segmentación de documentos digitales video o audio 0 : No activado 1 : Activado'),
(1210,'opac','default_sort_display','','¿Mostrar la descripción de la selección aplicada por defecto en el resultado de la búsqueda? \n 0 : No \n 1 : Si'),
(1211,'opac','show_bannettes','','Mostrar las bannettes en la página de inicio del OPAC.\n 0 : No.\n 1 : Si.'),
(1212,'opac','facettes_ajax','','Cargar las facettes en ajax\n0 : No\n1 : Si'),
(1213,'opac','search_all_keep_empty_words','','Conservar las palabras vacías para las autoridades dentro de la búsqueda por todos los campos\n0 : No\n1 : Si'),
(1214,'pmb','pret_already_loaned','','Activar la trampa en préstamo si el documento ya ha sido prestado al lector. Necesita la activación del archivo de los préstamos\n0 : No\n1 : Si'),
(1215,'opac','nb_notices_similaires','','Número de reseñas similares a mostrar al desplegar una reseña.\nValor máx= 6.'),
(1216,'opac','notice_reduit_format_similaire','','Formato de visualización reducido de reseñas similares :\n 0 = título+autor principal\n 1 = título+autor principal+fecha de edición\n 2 = título+autor principal+fecha de edición + ISBN\n 3 = sólo título\n P 1,2,3 = título+autor+campos personalizados id 1 2 3\n E 1,2,3 = título+autor+editor+campos personalizados id 1 2 3\n T = tit1+tit4\n 4 = título+título paralelo+autor principal\n H 1 = id de una plantilla de reseña'),
(1217,'opac','search_noise_limit_type','','Fijar los resultados de búsqueda en función de la relevancia. \n0 : No \n1 : Retirar el resultado si esta por debajo de la media-desviación típica\n2,ratio : Retirar el resultado si esta por debajo de la media-ratio de la desviación típica (ej: 2,1.96)\n3,ratio : Retirar el resultado si esta por debajo de un ratio de la máxima relevancia (ej: 3,0.25 elimar todo que sea inferior a 25% de la máxima relevancia)'),
(1218,'opac','search_relevant_with_frequency','','Utilizar la frecuencia de aparición de palabras dentro de las reseñas para el cálculo de la relevancia.\n0 : No \n1 : Si'),
(1219,'empr','prolong_calc_date_adhes_depassee','','Si la fecha de subscripción esta sobrepasada, el cálculo de la prolongación se hará a partir de :\n 0 : la fecha de fin de la subscripción\n 1 : la fecha actual'),
(1171,'opac','bannette_priv_periodicite','','Periocidad del envío por defecto en la creación de bannette privada (en días)'),
(1220,'opac','show_subscribed_bannettes','','Mostrar las bannettes a las que esta subscrito el lector en la página de inicio del OPAC :\n0 : No.\n1 : Si.'),
(1173,'pdfcartelecteur','printer_card_handler','','Gestionar la impresión:\n 1=script \"print.cb.php"\\n 2=applet jzebra \n 3= petición ajax'),
(1221,'opac','show_public_bannettes','','Mostrar las bannettes seleccionadas en la página de inicio OPAC:\n 0:No.\n 1:Si'),
(1222,'pdfcartelecteur','printer_card_name','','Nombre de la impresora'),
(1223,'pmb','default_style_addon','','¿Añadir estilos CSS a las hojas de estilo ya incluidas? \n No ponga el código CSS, ejemplo:body {background-color: #FF0000;}'),
(1174,'pdfcartelecteur','printer_card_url','','Dirección de la impresora'),
(1175,'pmb','notice_img_folder_id','','Directorio de carga de las miniaturas de las reseñas'),
(1176,'pmb','autorites_verif_js','','Script de verificación de la entrada de autoridades'),
(1177,'opac','resa_cart','','Configuración para ocultar/mostrar la reserva por cesta \n 0: No \n 1:Si'),
(1178,'pmb','print_expl_default','','En la impresión de cestas, imprimir los ejemplares marcados por defecto: \n 0: No \n 1:Si'),
(1179,'opac','collstate_data','','Columnas  de los estados de las colecciones, dentro del orden dado, separadas por comas :location_libelle,emplacement_libelle,cote,type_libelle,statut_opac_libelle,origine,state_collections,archive,lacune,surloc_libelle,note
Los valores posibles son los propios de la clase PHP \"pmb/opac_css/classes/collstate.class.php"\.'),
(1180,'transferts','retour_action_resa','','Generar una transferencia para responder a una reserva después de la devolución de un ejemplar. \n 0: No \n 1:Si');

UPDATE parametres INNER JOIN parametres_bak

ON parametres_bak.type_param=parametres.type_param AND parametres_bak.sstype_param = parametres.sstype_param

    SET parametres.comment_param=parametres_bak.comment_param;

DROP TABLE IF EXISTS parametres_bak;



SET SQL_SAFE_UPDATES=1;

