--
-- Host: localhost    Database: pmb410
-- ------------------------------------------------------
-- Server version	5.5.25-MariaDB

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

SET SQL_SAFE_UPDATES=0;

--
-- Traducción de tabla `abts_periodicites`
--

DROP TABLE IF EXISTS abts_periodicites_bak;
CREATE TABLE IF NOT EXISTS abts_periodicites_bak (
  periodicite_id int(10),
  libelle varchar(255), 
  PRIMARY KEY (periodicite_id))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO abts_periodicites_bak (periodicite_id,libelle) VALUES
(1,'Diari'),
(2,'Setmanal'),
(3,'Quinzenal'),
(4,'Mensual'),
(5,'Bimestral'),
(6,'Trimestral'),
(7,'Quatrimestral'),
(8,'Semestral'),
(9,'Anual');

UPDATE abts_periodicites INNER JOIN abts_periodicites_bak 

ON abts_periodicites_bak.periodicite_id=abts_periodicites.periodicite_id 

SET abts_periodicites.libelle=abts_periodicites_bak.libelle;


DROP TABLE IF EXISTS abts_periodicites_bak;

--
-- Traducción de tabla `arch_emplacement`
--

DROP TABLE IF EXISTS arch_emplacement_bak;
CREATE TABLE IF NOT EXISTS arch_emplacement_bak (
  archempla_id	int(8),
  archempla_libelle varchar(255) , 
  PRIMARY KEY (archempla_id))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO arch_emplacement_bak(archempla_id,archempla_libelle) VALUES
(1,'Expositor');


UPDATE arch_emplacement INNER JOIN arch_emplacement_bak 

ON arch_emplacement_bak.archempla_id=arch_emplacement.archempla_id 

SET arch_emplacement.archempla_libelle=arch_emplacement_bak.archempla_libelle;

DROP TABLE IF EXISTS arch_emplacement_bak;

--
-- Traducción de tabla `arch_statut`
--

DROP TABLE IF EXISTS arch_statut_bak;
CREATE TABLE IF NOT EXISTS arch_statut_bak (
  archstatut_id	int(8),
  archstatut_gestion_libelle varchar(255),
  archstatut_opac_libelle varchar(255),  
  PRIMARY KEY (archstatut_id))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO arch_statut_bak(archstatut_id,archstatut_gestion_libelle,archstatut_opac_libelle) VALUES
(1,'Disponible en el lloc','Disponible en el lloc');


UPDATE arch_statut INNER JOIN arch_statut_bak 

ON arch_statut_bak.archstatut_id =arch_statut.archstatut_id  

SET arch_statut.archstatut_gestion_libelle=arch_statut_bak.archstatut_gestion_libelle,
    arch_statut.archstatut_opac_libelle=arch_statut_bak.archstatut_opac_libelle;

DROP TABLE IF EXISTS arch_statut_bak;

--
-- Traducción de tabla `arch_type`
--

DROP TABLE IF EXISTS arch_type_bak;
CREATE TABLE IF NOT EXISTS arch_type_bak (
  archtype_id	int(8),
  archtype_libelle varchar(255),
  PRIMARY KEY (archtype_id))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO arch_type_bak(archtype_id, archtype_libelle) VALUES
(1,'Revista' );


UPDATE arch_type INNER JOIN arch_type_bak 

ON arch_type_bak.archtype_id =arch_type.archtype_id  

SET arch_type.archtype_libelle=arch_type_bak.archtype_libelle;
   

DROP TABLE IF EXISTS arch_type_bak;

--
-- Traducción de tabla `caddie`
--

DROP TABLE IF EXISTS caddie_bak;
CREATE TABLE IF NOT EXISTS caddie_bak (
  idcaddie int(8),
  name	varchar(255),
  comment varchar(255), 
  PRIMARY KEY (idcaddie))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO caddie_bak(idcaddie, name, comment) VALUES
(1,'Ressenyes per a exposició','Incloure en esta cistella els Ressenyes de l\'exposició virtual'),
(2,'Ressenyes a tornar a BDP','Omplir esta cistella com a control dels Ressenyes que s\'han de tornar'),
(3,'Exemplars a tornar a BDP','Omplir esta cistella amb els exemplars dels documents a tornar a la BDP'),
(4,'Ressenyes amb el títol duplicat','Duplicats del primer títol'),
(5,'Loire - Ressenyes per al tema del mes',''),
(6,'Loire - Números que contenen els articles per a l\'exposició del mes',''), 
(7,'Cochon - Ressenyes per a l\'exposició del mes pròxim','');

UPDATE caddie INNER JOIN caddie_bak 

ON caddie_bak.idcaddie =caddie.idcaddie  

SET caddie.name=caddie_bak.name,
    caddie.comment=caddie_bak.comment;
    
DROP TABLE IF EXISTS caddie_bak;

--
-- Traducción de tabla `caddie_procs`
--

DROP TABLE IF EXISTS caddie_procs_bak;
CREATE TABLE IF NOT EXISTS caddie_procs_bak (
  idproc smallint(5),
  name	varchar(255),
  comment tinytext,
  parameters	text, 
  PRIMARY KEY (idproc))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO caddie_procs_bak(idproc, name, comment,parameters) VALUES
(1,'Ressenyes per autor','Selecció de registre on el nom de l\'autor conté certes lletres',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="critere" MANDATORY="yes">
  <ALIAS><![CDATA[Caràcters inclosos en el cognom]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>25</SIZE>
 <MAXSIZE>25</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(2,'Ressenyes duplicats','Selecció de les ressenyes duplicades pel títol principal',''),
(3,'EXPL per secció/propietari','Selecció d\'exemplars per secció i per propietari',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="section" MANDATORY="yes">
  <ALIAS><![CDATA[Secció]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idsection, section_libelle from docs_section order by section_libelle]]></QUERY>
 <MULTIPLE>yes</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
 <FIELD NAME="proprio" MANDATORY="yes">
  <ALIAS><![CDATA[Proprietari]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY>select idlender, lender_libelle from lenders order by lender_libelle</QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(4,'EXPL que la signatura comença per','Selecció d\'exemplars a partir de l\'inici de la seua signatura',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="comme_cote" MANDATORY="no">
  <ALIAS><![CDATA[Inici de la signatura]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>20</SIZE>
 <MAXSIZE>20</MAXSIZE>
</OPTIONS> 
 </FIELD>
</FIELDS>'),
(6,'Mai prestats','Afig a una cistella els exemplars que mai s\'han prestat',''),
(7,'Selecció d\'exemplars per estat','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="statut" MANDATORY="yes">
  <ALIAS><![CDATA[estat]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idstatut, statut_libelle from docs_statut]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(8,'Selecció d\'exemplars per localització, secció, estat, propietari','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="section" MANDATORY="yes">
  <ALIAS><![CDATA[Secció]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>
 <MULTIPLE>yes</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
 <FIELD NAME="location" MANDATORY="yes">
  <ALIAS><![CDATA[Localització]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>
 <MULTIPLE>yes</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
 <FIELD NAME="statut" MANDATORY="yes">
  <ALIAS><![CDATA[Estat]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idstatut, statut_libelle from docs_statut order by 2]]></QUERY>
 <MULTIPLE>yes</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
 <FIELD NAME="proprio" MANDATORY="yes">
  <ALIAS><![CDATA[Proprietari]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(10,'Moure butlletins d\'una cistella a una altra publicació periòdica','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_perio" MANDATORY="yes">
  <ALIAS><![CDATA[Nou període]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select notice_id, tit1 from notices where niveau_biblio=''s'' and niveau_hierar=''1'' order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(11,'Selecció/Marcat de butlletins sense articles','',''),
(13,'Selecció/Marcat de butlletins per data','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="dated" MANDATORY="yes">
  <ALIAS><![CDATA[data d\'inici:]]></ALIAS>
  <TYPE>date_box</TYPE>
<OPTIONS FOR="date_box"></OPTIONS>
 </FIELD>
 <FIELD NAME="datef" MANDATORY="yes">
  <ALIAS><![CDATA[data de finalització:]]></ALIAS>
  <TYPE>date_box</TYPE>
<OPTIONS FOR="date_box"></OPTIONS>
 </FIELD>
</FIELDS>'),
(14,'Canvi de codi estadístic dels exemplars d\'una cistella','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_codestat" MANDATORY="yes">
  <ALIAS><![CDATA[Nou codi estadístic]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(16,'Canvi de data de depòsit dels exemplars d\'una cistella','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_date_depot" MANDATORY="yes">
  <ALIAS><![CDATA[Nova data de depòsit]]></ALIAS>
  <TYPE>date_box</TYPE>
<OPTIONS FOR="date_box"></OPTIONS> 
 </FIELD>
</FIELDS>'),
(18,'Canvi de data de retorn dels exemplars d\'una cistella','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_date_retour" MANDATORY="yes">
  <ALIAS><![CDATA[Nova data de devolució]]></ALIAS>
  <TYPE>date_box</TYPE>
<OPTIONS FOR="date_box"></OPTIONS> 
 </FIELD>
</FIELDS>'),
(19,'Canvi de localització dels exemplars d\'una cistella','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_location" MANDATORY="yes">
  <ALIAS><![CDATA[Nova localització >
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(20,'Canvi de missatge dels exemplars d\'una cistella','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_note" MANDATORY="no">
  <ALIAS><![CDATA[Nou missatge]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>25</SIZE>
 <MAXSIZE>255</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(21,'Canvi d\'una part de la valoració dels exemplars d\'una cistella','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="motif_1" MANDATORY="no">
  <ALIAS><![CDATA[Reemplaçar]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>10</SIZE>
 <MAXSIZE>10</MAXSIZE>
</OPTIONS> 
 </FIELD>
 <FIELD NAME="motif_2" MANDATORY="no">
  <ALIAS><![CDATA[Per]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>10</SIZE>
 <MAXSIZE>10</MAXSIZE>
</OPTIONS> 
 </FIELD>
</FIELDS>'),
(22,'Canvi del preu dels exemplars d\'una cistella','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_prix" MANDATORY="no">
  <ALIAS><![CDATA[Nou preu]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>10</SIZE>
 <MAXSIZE>255</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(23,'Canvi de secció dels exemplars d\'una cistella','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_section" MANDATORY="yes">
  <ALIAS><![CDATA[Nova secció]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(24,'Canvi d\'estat dels exemplars d\'una cistella','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_statut" MANDATORY="yes">
  <ALIAS><![CDATA[Nou estat]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idstatut, statut_libelle from docs_statut order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(25,'Canvi de suport dels exemplars d\'una cistella','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_typdoc" MANDATORY="yes">
  <ALIAS><![CDATA[Nou suport]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(26,'Selecció/Marcat d\'exemplars amb préstec en curs','',''),
(27,'Selecció d\'exemplars des d\'un arxiu de codi de barres','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="fichier" MANDATORY="yes">
  <ALIAS><![CDATA[fitxer]]></ALIAS>
  <TYPE>file_box</TYPE>
<OPTIONS FOR="file_box">
 <METHOD>1</METHOD>
 <TEMP_TABLE_NAME></TEMP_TABLE_NAME>
 <DATA_TYPE>1</DATA_TYPE>
</OPTIONS> 
 </FIELD>
</FIELDS>'),
(30,'Canvi de la indexación decimal de ressenyes d\'una cistella','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="nouvelle_indexation" MANDATORY="yes">
  <ALIAS><![CDATA[Nova indexació]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select indexint_id, concat(indexint_name,' ', indexint_comment) from indexint order by indexint_name]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(31,'Canvi d\'estat de ressenyes d\'una cistella','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_statut" MANDATORY="yes">
  <ALIAS><![CDATA[Nuevo estado]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select id_notice_statut, gestion_libelle from notice_statut order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(32,'Canvi de tipus de document de ressenyes d\'una cistella','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_typdoc" MANDATORY="yes">
  <ALIAS><![CDATA[Nou tipus de document]]></ALIAS>
  <TYPE>list</TYPE>
<OPTIONS FOR="list">
 <MULTIPLE>no</MULTIPLE>
 <ITEMS>
  <ITEM VALUE="b"><![CDATA[text manuscrit]]></ITEM>
  <ITEM VALUE="c"><![CDATA[partitura musical impresa]]></ITEM>
  <ITEM VALUE="d"><![CDATA[partitura musical manuscrita]]></ITEM>
  <ITEM VALUE="e"><![CDATA[document manuscrit imprés]></ITEM>
  <ITEM VALUE="f"><![CDATA[document manuscrit imprés]]></ITEM>
  <ITEM VALUE="g"><![CDATA[document projectat o vídeo]]></ITEM>
  <ITEM VALUE="i"><![CDATA[registre sonor no musical]]></ITEM>
  <ITEM VALUE="j"><![CDATA[registre sonor musical]]></ITEM>
  <ITEM VALUE="k"><![CDATA[registre gràfic bidimensional]]></ITEM>
  <ITEM VALUE="l"><![CDATA[document electrònic]]></ITEM>
  <ITEM VALUE="m"><![CDATA[document multimèdia]></ITEM>
  <ITEM VALUE="r"><![CDATA[objecte de 3 dimensions, artefactes, ...]]></ITEM>
 </ITEMS>
 <UNSELECT_ITEM VALUE="a"><![CDATA[text imprés]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(33,'Còpia els autors de ressenyes mare d\'una cistella a les seues ressenyes filles','Només agrega autors a aquelles ressenyes filles que encara no tenen autor establit',''),
(34,'Selecció/Marcat de ressenyes amb ressenyes filles','',''),
(35,'Selecció/Marcat de ressenyes amb ressenya mare','',''),
(36,'Selecció/Marcat de ressenyes per tipus de document i estat','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="type_doc" MANDATORY="yes">
  <ALIAS><![CDATA[Tipus de document]]></ALIAS>
  <TYPE>list</TYPE>
<OPTIONS FOR="list">
 <MULTIPLE>no</MULTIPLE>
 <ITEMS>
  <ITEM VALUE="a"><![CDATA[text imprés]]></ITEM>
  <ITEM VALUE="b"><![CDATA[text manuscrit]]></ITEM>
  <ITEM VALUE="c"><![CDATA[partitura musical impresa]]></ITEM>
  <ITEM VALUE="d"><![CDATA[partitura musical manuscrita]]></ITEM>
  <ITEM VALUE="e"><![CDATA[document manuscrit imprés]]></ITEM>
  <ITEM VALUE="f"><![CDATA[document manuscrit imprés]]></ITEM>
  <ITEM VALUE="g"><![CDATA[document projectat o vídeo]]></ITEM>
  <ITEM VALUE="i"><![CDATA[registre sonor no musical]]></ITEM>
  <ITEM VALUE="j"><![CDATA[registre sonor musical]]></ITEM>
  <ITEM VALUE="k"><![CDATA[registre gràfic bidimensional]]></ITEM>
  <ITEM VALUE="l"><![CDATA[document electrònic]]></ITEM>
  <ITEM VALUE="m"><![CDATA[document multimèdia]]></ITEM>
  <ITEM VALUE="r"><![CDATA[objecte de 3 dimensions, artefactes, ...]]></ITEM>
 </ITEMS>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
 <FIELD NAME="statut" MANDATORY="yes">
  <ALIAS><![CDATA[Estat registre]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY>select id_notice_statut, gestion_libelle from notice_statut order by 2</QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(37,'Selecció/Marcat de ressenyes sense ressenya filla ni ressenya mare','',''),
(39,'Selecció d\'exemplars no prestats després d\'una determinada data','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="dat" MANDATORY="yes">
  <ALIAS><![CDATA[Data últim préstec<]]></ALIAS>
  <TYPE>date_box</TYPE>
<OPTIONS FOR="date_box"></OPTIONS>
 </FIELD>
</FIELDS>'),
(5,'Canvi d\'estat dels exemplars','Permet canviar l\'estat dels exemplars d\'una cistella',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="nouveau_statut" MANDATORY="yes">
  <ALIAS><![CDATA[Nou estat]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY>SELECT idstatut, statut_libelle FROM docs_statut</QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(9,'Canviar la secció dels exemplars','',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="nouvelle_section" MANDATORY="yes">
  <ALIAS><![CDATA[Nova secció]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select * from docs_section order by section_libelle]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[Tria una secció]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>');

UPDATE caddie_procs INNER JOIN caddie_procs_bak 

ON caddie_procs_bak.idproc =caddie_procs.idproc  

SET caddie_procs.name=caddie_procs_bak.name,
    caddie_procs.comment=caddie_procs_bak.comment,
    caddie_procs.parameters=caddie_procs_bak.parameters;
    
    
DROP TABLE IF EXISTS caddie_procs_bak;

--
-- Traducción de tabla `docs_codestat`
--

DROP TABLE IF EXISTS docs_codestat_bak;
CREATE TABLE IF NOT EXISTS docs_codestat_bak (
  idcode smallint(5),
  codestat_libelle varchar(255), 
  PRIMARY KEY (idcode))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO docs_codestat_bak(idcode,codestat_libelle) VALUES
(10,'Indeterminat'),
(11,'Jóvens'),
(12,'Adults');

UPDATE docs_codestat INNER JOIN docs_codestat_bak 

ON docs_codestat_bak.idcode =docs_codestat.idcode  

SET docs_codestat.codestat_libelle=docs_codestat_bak.codestat_libelle;

DROP TABLE IF EXISTS docs_codestat_bak;

--
-- Traducción de tabla `docs_section'
--

DROP TABLE IF EXISTS docs_section_bak;
CREATE TABLE IF NOT EXISTS docs_section_bak (
  idsection smallint(5), 
  section_libelle varchar(255), 
  PRIMARY KEY (idsection))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO docs_section_bak(idsection,section_libelle) VALUES
(10,'Documentals'),
(11,'Documentals Infantils'),
(12,'Novel·les Infantils'),
(13,'Novel·les Juvenils'),
(16,'Còmics Adults'),
(17,'Còmics Infantils'),
(18,'H (Història local)'),
(19,'FR (Fons regional)'),
(20,'Còmics Juvenils'),
(21,'Novel·les policíaques'),
(23,'Novel·les lletra gran'),
(24,'Novel·les & Novel·les estrangeres'),
(25,'Documentals Juvenils'),
(26,'Contes Infantils');


UPDATE docs_section INNER JOIN docs_section_bak 

ON docs_section_bak.idsection =docs_section.idsection  

SET docs_section.section_libelle=docs_section_bak.section_libelle;

DROP TABLE IF EXISTS docs_section_bak;

--
-- Traducción de tabla `docs_statut`
--

DROP TABLE IF EXISTS docs_statut_bak;
CREATE TABLE IF NOT EXISTS docs_statut_bak (
  idstatut smallint(5),
  statut_libelle varchar(255), 
  PRIMARY KEY (idstatut))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO docs_statut_bak(idstatut,statut_libelle) VALUES
(1,'Document en bon estat'),
(2,'En curs d\'importació/adquisició'),
(11,'Deteriorat'),
(12,'Perdut'),
(13,'Consulta en sala'),
(14,'En depòsit');


UPDATE docs_statut INNER JOIN docs_statut_bak 

ON docs_statut_bak.idstatut =docs_statut.idstatut  

SET docs_statut.statut_libelle=docs_statut_bak.statut_libelle;

DROP TABLE IF EXISTS docs_statut_bak;

--
-- Traducción de tabla `docs_type`
--

DROP TABLE IF EXISTS docs_type_bak;
CREATE TABLE IF NOT EXISTS docs_type_bak (
  idtyp_doc int(5), 
  tdoc_libelle varchar(255), 
  PRIMARY KEY (idtyp_doc))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO docs_type_bak(idtyp_doc,tdoc_libelle) VALUES
(1,'Llibre'),
(12,'Cinta de vídeo'),
(13,'CD àudio'),
(14,'DVD'),
(15,'Obra d\'art'),
(16,'Targetes i plans'),
(17,'Cederrones'),
(18,'Publicacions periòdiques');

UPDATE docs_type INNER JOIN docs_type_bak 

ON docs_type_bak.idtyp_doc =docs_type.idtyp_doc 

SET docs_type.tdoc_libelle=docs_type_bak.tdoc_libelle;

DROP TABLE IF EXISTS docs_type_bak;

--
-- Traducción de tabla `empr_caddie`
--

DROP TABLE IF EXISTS empr_caddie_bak;
CREATE TABLE IF NOT EXISTS empr_caddie_bak (
  idemprcaddie	int(8), 
  name varchar(100), 
  PRIMARY KEY (idemprcaddie))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO empr_caddie_bak(idemprcaddie,name) VALUES
(1,'Panel de lectors');

UPDATE empr_caddie INNER JOIN empr_caddie_bak 

ON empr_caddie_bak.idemprcaddie =empr_caddie.idemprcaddie 

SET empr_caddie.name=empr_caddie_bak.name;

DROP TABLE IF EXISTS empr_caddie_bak;


--
-- Traducción de tabla `empr_caddie`
--

DROP TABLE IF EXISTS empr_caddie_procs_bak;
CREATE TABLE IF NOT EXISTS empr_caddie_procs_bak (
  idproc smallint(5),
  name	varchar(255),
  parameters	text  ,  
  PRIMARY KEY (idproc))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO  empr_caddie_procs_bak(idproc,name,parameters) VALUES
(1,'Canvi d\'ubicació de lectors d\'una cistella',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_location" MANDATORY="yes">
  <ALIAS><![CDATA[Nova ubicació]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(2,'Canvi de categoria de lectors d\'una cistella',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_categ" MANDATORY="yes">
  <ALIAS><![CDATA[Nova categoria]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select id_categ_empr, libelle from empr_categ order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(3,'Canvi de ciutat de lectors d\'una cistella',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_ville" MANDATORY="no">
  <ALIAS><![CDATA[Nova ciutat]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>25</SIZE>
 <MAXSIZE>255</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(4,'Canvi de codi postal de lectors d\'una cistella',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_cp" MANDATORY="no">
  <ALIAS><![CDATA[Nuevo codi postal]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>10</SIZE>
 <MAXSIZE>10</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(5,'Canvi de país de lectors d\'una cistella',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_pays" MANDATORY="no">
  <ALIAS><![CDATA[Nou país]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>25</SIZE>
 <MAXSIZE>255</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(6,'Canvi d\'estat de lectors d\'una cistella',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="nouveau_statut" MANDATORY="yes">
  <ALIAS><![CDATA[Nou estat]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idstatut, statut_libelle from empr_statut order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(7,'Canvi de codi estadístic de lectors d\'una cistella',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_codestat" MANDATORY="yes">
  <ALIAS><![CDATA[Nou codi estadístic]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select idcode, libelle from empr_codestat order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(8,'Canvi de contrasenya de lectors d\'una cistella',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_password" MANDATORY="no">
  <ALIAS><![CDATA[Nova contrasenya]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>10</SIZE>
 <MAXSIZE>10</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(9,'Canvi de data d\'inici d\'afiliació de lectors d\'una cistella',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_date_adhesion" MANDATORY="yes">
  <ALIAS><![CDATA[Nova data d\'inici d\'afiliació]]></ALIAS>
  <TYPE>date_box</TYPE>
<OPTIONS FOR="date_box"></OPTIONS> 
 </FIELD>
</FIELDS>'),
(10,'Canvi de data de fi d\'afiliació de lectors d\'una cistella',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_date_expiration" MANDATORY="yes">
  <ALIAS><![CDATA[Nova data de fi d\'afiliació]]></ALIAS>
  <TYPE>date_box</TYPE>
<OPTIONS FOR="date_box"></OPTIONS> 
 </FIELD>
</FIELDS>'),
(11,'Canvi de sexe de lectors d\'una cistella',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_sexe" MANDATORY="yes">
  <ALIAS><![CDATA[Nou sexe]]></ALIAS>
  <TYPE>list</TYPE>
<OPTIONS FOR="list">
 <MULTIPLE>no</MULTIPLE>
 <ITEMS>
  <ITEM VALUE="1"><![CDATA[Masculí]]></ITEM>
  <ITEM VALUE="2"><![CDATA[Femení]]></ITEM>
  <ITEM VALUE="0"><![CDATA[Indeterminat]]></ITEM>
 </ITEMS>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(14,'Canvi de missatge de lectors d\'una cistella',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_msg" MANDATORY="no">
  <ALIAS><![CDATA[Nou missatge]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>25</SIZE>
 <MAXSIZE>255</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(16,'Selecció/Marcat de lectors sense correu electrònic',
''),
(18,'Incorporació de lectors d\'una cistella a una llista de distribució pública (DSI)',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="bannette" MANDATORY="yes">
  <ALIAS><![CDATA[llista de distribució]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select id_bannette, nom_bannette from bannettes where proprio_bannette=0 order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(19,'Desincorporació de lectors d\'una cistella a una llista de distribució pública (DSI)',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="bannette" MANDATORY="yes">
  <ALIAS><![CDATA[llista de distribució]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select id_bannette, nom_bannette from bannettes where proprio_bannette=0 order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE=""><![CDATA[]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(21,'Canvi de professió de lectors d\'una cistella',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_prof" MANDATORY="no">
  <ALIAS><![CDATA[Nova professió]]></ALIAS>
  <TYPE>text</TYPE>
<OPTIONS FOR="text">
 <SIZE>25</SIZE>
 <MAXSIZE>255</MAXSIZE>
</OPTIONS>
 </FIELD>
</FIELDS>'),
(22,'Canvi de tipus d\'abonament de lectors d\'una cistella',
'<?xml version="1.0" encoding="iso-8859-1"?>
<FIELDS>
 <FIELD NAME="new_type_abt" MANDATORY="no">
  <ALIAS><![CDATA[Nou tipus d\'abonament]]></ALIAS>
  <TYPE>query_list</TYPE>
<OPTIONS FOR="query_list">
 <QUERY><![CDATA[select id_type_abt, type_abt_libelle from type_abts order by 2]]></QUERY>
 <MULTIPLE>no</MULTIPLE>
 <UNSELECT_ITEM VALUE="0"><![CDATA[No definit]]></UNSELECT_ITEM>
</OPTIONS>
 </FIELD>
</FIELDS>');


UPDATE empr_caddie_procs INNER JOIN empr_caddie_procs_bak 

ON empr_caddie_procs_bak.idproc=empr_caddie_procs.idproc

SET empr_caddie_procs.name=empr_caddie_procs_bak.name,
     empr_caddie_procs.parameters=empr_caddie_procs_bak.parameters;

DROP TABLE IF EXISTS empr_caddie_procs_bak;


--
-- Traducción de tabla `empr_categ`
--

DROP TABLE IF EXISTS empr_categ_bak;
CREATE TABLE IF NOT EXISTS empr_categ_bak (
  id_categ_empr	smallint(5), 
  libelle varchar(255), 
  PRIMARY KEY (id_categ_empr))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO empr_categ_bak(id_categ_empr,libelle) VALUES
(1,'Xiquets'),
(2,'Jubilats'),
(3,'Empleats'),
(4,'Sense ocupació'),
(5,'Alumnes de secundària/Estudiants'),
(6,'Col·legials'),
(7,'Adults');


UPDATE empr_categ INNER JOIN empr_categ_bak 

ON empr_categ_bak.id_categ_empr =empr_categ.id_categ_empr

SET empr_categ.libelle=empr_categ_bak.libelle;

DROP TABLE IF EXISTS empr_categ_bak;


--
-- Traducción de tabla `empr_codestat`
--

DROP TABLE IF EXISTS empr_codestat_bak;
CREATE TABLE IF NOT EXISTS empr_codestat_bak (
  idcode smallint(5), 
  libelle varchar(255), 
  PRIMARY KEY (idcode))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO empr_codestat_bak(idcode,libelle) VALUES
(2,'Comunitad de Municipis'),
(3,'Municipi'),
(4,'Departament'),
(5,'Europa'),
(6,'Fora d\'Europa'),
(7,'França');


UPDATE empr_codestat INNER JOIN empr_codestat_bak 

ON empr_codestat_bak.idcode =empr_codestat.idcode

SET empr_codestat.libelle=empr_codestat_bak.libelle;

DROP TABLE IF EXISTS empr_codestat_bak;


--
-- Traducción de tabla `empr_statut`
--

DROP TABLE IF EXISTS empr_statut_bak;
CREATE TABLE IF NOT EXISTS empr_statut_bak (
  idstatut smallint(5), 
  statut_libelle varchar(255), 
  PRIMARY KEY (idstatut))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO empr_statut_bak(idstatut,statut_libelle) VALUES
(1,'Actiu'),
(2,'Prohibit');

UPDATE empr_statut INNER JOIN empr_statut_bak 

ON empr_statut_bak.idstatut =empr_statut.idstatut

SET empr_statut.statut_libelle=empr_statut_bak.statut_libelle;

DROP TABLE IF EXISTS empr_statut_bak;


--
-- Traducción de tabla `expl_custom`
--

DROP TABLE IF EXISTS expl_custom_bak;
CREATE TABLE IF NOT EXISTS expl_custom_bak (
  idchamp int(10), 
  titre	varchar(255),  
  PRIMARY KEY (idchamp))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO expl_custom_bak(idchamp,titre) VALUES
(2,'Origen'),
(3,'Data d\'adquisició'),
(4,'Data de destrucció');



UPDATE expl_custom INNER JOIN expl_custom_bak 

ON expl_custom_bak.idchamp =expl_custom.idchamp

SET expl_custom.titre=expl_custom_bak.titre;

DROP TABLE IF EXISTS expl_custom_bak;


--
-- Traducción de tabla `expl_custom_lists`
--

DROP TABLE IF EXISTS expl_custom_lists_bak;
CREATE TABLE IF NOT EXISTS expl_custom_lists_bak (
  expl_custom_list_value varchar(255) , 
  expl_custom_list_lib	varchar(255))

ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO expl_custom_lists_bak(expl_custom_list_value,expl_custom_list_lib) VALUES
('DEP','Depòsit'),
('DON','Donació'),
('ACH','Compra');


UPDATE expl_custom_lists INNER JOIN expl_custom_lists_bak 

ON expl_custom_lists_bak.expl_custom_list_value =expl_custom_lists.expl_custom_list_value

SET expl_custom_lists.expl_custom_list_lib=expl_custom_lists_bak.expl_custom_list_lib;

DROP TABLE IF EXISTS expl_custom_lists_bak;

--
-- Traducción de tabla `facettes`
--

DROP TABLE IF EXISTS facettes_bak;
CREATE TABLE IF NOT EXISTS facettes_bak (
  id_facette int(10),
  facette_name	varchar(255),
  PRIMARY KEY(id_facette))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO facettes_bak(id_facette,facette_name) VALUES
(1,'Categories'),
(2,'Ubicació'),
(3,'Paraula clau'),
(4,'Secció'),
(5,'Tipus de document'),
(6,'Tipus de registre');

UPDATE facettes INNER JOIN facettes_bak 

ON facettes_bak.id_facette =facettes.id_facette

SET facettes.facette_name=facettes_bak.facette_name;

DROP TABLE IF EXISTS facettes_bak;


--
-- Traducción de tabla `infopages`
--

DROP TABLE IF EXISTS infopages_bak;
CREATE TABLE IF NOT EXISTS infopages_bak (
  id_infopage	int(10),
  title_infopage varchar(255) ,
  PRIMARY KEY(id_infopage))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO infopages_bak(id_infopage,title_infopage) VALUES
(1,'Noticies trobades'),
(2,'PMB Versió 4.1'),
(6,'Ens trobem'),
(7,'Menció legal'),
(3,'Ajuda en línia'),
(4,'Consultar Calendari'),
(5,'Ajuda en la busca senzilla');


UPDATE infopages INNER JOIN infopages_bak 

ON infopages_bak.id_infopage =infopages.id_infopage

SET infopages.title_infopage=infopages_bak.title_infopage;

DROP TABLE IF EXISTS infopages_bak;


--
-- Traducción de tabla `lenders`
--


DROP TABLE IF EXISTS lenders_bak;
CREATE TABLE IF NOT EXISTS lenders_bak (
  idlender smallint(5),
  lender_libelle varchar(255),
  PRIMARY KEY(idlender))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO lenders_bak(idlender,lender_libelle) VALUES
(1,'BDP'),
(2,'Fons propi');


UPDATE lenders INNER JOIN lenders_bak 

ON lenders_bak.idlender =lenders.idlender

SET lenders.lender_libelle=lenders_bak.lender_libelle;

DROP TABLE IF EXISTS lenders_bak;


--
-- Traducción de tabla `noeuds`
--

DROP TABLE IF EXISTS noeuds_bak;
CREATE TABLE IF NOT EXISTS noeuds_bak (
  id_noeud int(9),
  autorite varchar(255),
  PRIMARY KEY(id_noeud))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO noeuds_bak(id_noeud,autorite) VALUES
(1,'SUPERIOR'),
(2,'SENSE CLASSIFICAR'),
(3,'ÒRFENS');


UPDATE noeuds INNER JOIN noeuds_bak 

ON noeuds_bak.id_noeud =noeuds.id_noeud

SET noeuds.autorite=noeuds_bak.autorite;

DROP TABLE IF EXISTS noeuds_bak;

--
-- Traducción de tabla `notice_statut`
--


DROP TABLE IF EXISTS origine_notice_bak;
CREATE TABLE IF NOT EXISTS origine_notice_bak (
  orinot_id	int(8),
  orinot_nom	varchar(255),
  PRIMARY KEY(orinot_id))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO origine_notice_bak(orinot_id, orinot_nom) VALUES
(3,'Catàleg intern'),
(2,'BnF'),
(1,'Catàleg intern'),
(4,'FR-751131015');


UPDATE origine_notice INNER JOIN origine_notice_bak 

ON origine_notice_bak.orinot_id =origine_notice.orinot_id

SET origine_notice.orinot_nom=origine_notice_bak.orinot_nom;

DROP TABLE IF EXISTS origine_notice_bak;


--
-- Traducción de tabla `notice_statut`
--

DROP TABLE IF EXISTS notice_statut_bak;
CREATE TABLE IF NOT EXISTS notice_statut_bak (
  id_notice_statut smallint(5),
  gestion_libelle varchar(255),
  opac_libelle	varchar(255),
  PRIMARY KEY(id_notice_statut))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO notice_statut_bak(id_notice_statut,gestion_libelle,opac_libelle) VALUES
(1,'Sense Estat',''),
(2,'Préstec ràpid',''),
(3,'Ordenat','Ordenat'),
(4,'En procés d\'importació/recuperació','');


UPDATE notice_statut INNER JOIN notice_statut_bak 

ON notice_statut_bak.id_notice_statut =notice_statut.id_notice_statut

SET notice_statut.gestion_libelle=notice_statut_bak.gestion_libelle,
     notice_statut.opac_libelle=notice_statut_bak.opac_libelle;

DROP TABLE IF EXISTS notice_statut_bak;


--
-- Traducción de tabla `origin_authorities`
--

DROP TABLE IF EXISTS origin_authorities_bak;
CREATE TABLE IF NOT EXISTS origin_authorities_bak (
  id_origin_authorities	int(10),
  origin_authorities_name varchar(255),
  PRIMARY KEY(id_origin_authorities))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO origin_authorities_bak(id_origin_authorities, origin_authorities_name) VALUES
(1,'Catáleg intern'),
(2,'BnF');


UPDATE origin_authorities INNER JOIN origin_authorities_bak 

ON origin_authorities_bak.id_origin_authorities =origin_authorities.id_origin_authorities

SET origin_authorities.origin_authorities_name=origin_authorities_bak.origin_authorities_name;

DROP TABLE IF EXISTS origin_authorities_bak;


--
-- Traducción de tabla `procs`
--

DROP TABLE IF EXISTS procs_bak;
CREATE TABLE IF NOT EXISTS procs_bak(
idproc smallint(5),
name varchar(255),
comment tinytext,
parameters text,
PRIMARY KEY (idproc))

ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO procs_bak(idproc,name,comment,parameters) VALUES
(169,'Permís per a utilitzar tots els procediments a tots els usuaris','Permet a tots els usuaris utilitzar tots els procediments',''),
(170,'Permís per a utilitzar tots els procediments de les cistelles del catàleg','Permet a tots els usuaris utilitzar tots els procediments de les cistelles del catàleg',''),
(171,'Permís per a utilitzar tots els procediments de les cistelles de lectors','Permet a tots els usuaris utilitzar tots els procediments de les cistelles de lectors',''),
(184,'Nombre de lectors per categoria','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categ_lecteur\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoria de lectors]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(185,'Nombre de lectors per codi estadístic','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"codestat_lecteur\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Codi estadístic]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode,libelle from empr_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(186,'Nombre de lectors per estat','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"statut_lecteur\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estat del lector]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idstatut, statut_libelle from empr_statut order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(192,'Catàleg:nombre de registres monografies(total, establit durant l\'any i allò que s\'ha importat durant l\'any','A executar en Administració>Accions Personalitzades','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(193,'Préstecs: Compte de préstecs/categoria de lectors/tipus de document','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"anneee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(194,'Gastos d\'adquisicions documentals','Suma del camp preu per exemplar','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns):]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(195,'Col·leccions: Documents audiovisuals i Altres Documents: Adquisicions','A executar en Administració>Accions Personalitzades','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(196,'Col·leccions: Adquisicions impreses: nombre de títols i unitats per propietari i codi estadístic','A executar en Administració>Accions Personalitzades','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(197,'Col·leccions: Documents audiovisuals i Altres Documents: Eliminacions','A executar en Administració>Accions Personalitzades','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixstatutpilon\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Qual és l\'estat dels exemplars a eliminar ? :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idstatut,statut_libelle from docs_statut order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(198,'Col·leccions: Documents audiovisuals i Altres Documents: Unitats del fons propi','Manuscrits, Documents cartogràfics, Música impresa, Documents gràfics, Documents audiovisuals, Altres documents. A executar en Administració>Accions Personalitzades','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Tria localització]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS></OPTIONS>\n </FIELD>\n</FIELDS>'),
(199,'Col·leccions: Eliminacions impresos:número de títols i unitats per propietari i codi estadístic','A executar en Administració: Accions Personalitzades','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixstatutpilon\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Qual és l\'estat dels exemplars a eliminar ? :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idstatut, statut_libelle from docs_statut order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(200,'Col·leccions: Impresos: Nombre de títols i unitats per propietari i codi estadístic','A executar en Administracció: Accions Personalitzades','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(201,'Col·leccions: Publicacions seriades actuals per codi estadístic','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietario : ]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(202,'Lectors: Comptes d\'usuaris actius per categoria i codi estadístic (A executar imperativament a final d\'any)','Un usuari esta actiu si té un carnet vàlid i va demanar prestat un llibre l\'any indicat','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoria(es):]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(203,'Lectors: Comptes d\'usuaris actius per categoria, edat i sexe (a executar imperativament a final d\'any)','Un usuari esta actiu si té un carnet vàlid i va demanar prestat un llibre l\'any indicat','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoria(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(204,'Lectors: Comptes d\'usuaris actius (carnet vàlid dins de l\'any indicat)','Per categoria, edat i sexe','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoria(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(205,'Lectors: Comptes d\'usuaris actius per codi estadístic (carnet vàlid dins de l\'any indicat)','Per categoria i codi estadístic','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoria(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(206,'Lectors: Comptes de nous inscrits','Lectors inscrits dins de l\'any indicat per categoria, edat i sexe','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any:]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categora(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(207,'Lectors: Comptes de nous inscrits per codi estadístic','Lectors inscrits dins de l\'any indicat per categoria i codi estadístic','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categora(es) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(208,'Nombre d\'exemplars comprats/donats en un any /suport / Localització / Codi Estadístic / Secció','Utilitze esta estadística si el camp \"data de compra"\ esta informat','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idlocation, location_libelle FROM docs_location ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(209,'Nombre d\'exemplars comprats/donats en un any /suport / Secció','Utilitze esta estadística si el camp \"data de compra"\ esta informat','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"section\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idsection, section_libelle FROM docs_section ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"suppoort\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idtyp_doc, tdoc_libelle FROM docs_type ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(210,'Nombre d\'exemplars comprats per secció i localització per any en funció de la data de compra','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>Select idlocation, location_libelle FROM docs_location ORDER BY location_libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"anneeencours\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any en curs]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS></OPTIONS>\n </FIELD>\n</FIELDS>'),
(211,'Nombre d\'exemplars creats per secció i localització per any en curs','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>Select idlocation, location_libelle FROM docs_location ORDER BY location_libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"anneeencours\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any en curs]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS></OPTIONS>\n </FIELD>\n</FIELDS>'),
(212,'Nombre de documents comprats i donats','durant un any i per suport / Localització / Codi Estadístic','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>Select idlocation, location_libelle FROM docs_location ORDER BY location_libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"anneeencours\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any en curs]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS></OPTIONS>\n </FIELD>\n</FIELDS>'),
(213,'Nombre de documents comprats, donats o presos per Estat, Suport i Secció','','xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"anneeacq\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"supoort\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idtyp_doc, tdoc_libelle FROM docs_type ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idsection, section_libelle FROM docs_section ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(214,'Nombre d\'exemplars per secció','',''),
(215,'Nombre d\'exemplars per codi estadístic','',''),
(216,'Nombre d\'exemplars per nota','Tenint en compte la nota en la seua totalitat',''),
(217,'Nombre d\'exemplars per inici de nota 1','3 primers caràcters de la nota / classificació en nota',''),
(218,'Nombre d\'exemplars per inici de nota 2','3 primers caràcters de la notes / classificació en freqüència d\'utilització',''),
(219,'Nombre d\'exemplars per inici de nota i per localització','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[localització]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idlocation, location_libelle FROM docs_location ORDER BY 2]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(220,'Nombre d\'exemplars per inici de nota, localització i secció','3 primers caràcters de la note / classificació en freqüència d\'utilització','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idsection, section_libelle FROM docs_section ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(221,'Nombre d\'exemplars per localització','',''),
(222,'Nombre d\'exemplars per localització/codi estadístic','',''),
(223,'Nombre d\'exemplars per localització/secció','',''),
(224,'Nombre d\'exemplars per localització/estat','',''),
(225,'Nombre d\'exemplars per localització/suport','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(226,'Nombre d\'exemplars per origen d\'exemplar','','xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(227,'Nombre d\'exemplars per propietari','',''),
(228,'Nombre d\'exemplars eliminats','Per localització, suport i codi estadístic','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(229,'Nombre d\'exemplars per propietari/codi estadístic','',''),
(231,'Nombre d\'exemplars per propietari/localització','',''),
(232,'Nombre d\'exemplars per propietari/localització/codi estadístic','',''),
(233,'Nombre d\'exemplars per propietari/localització/secció','',''),
(234,'Nombre de\'exemplars per propietari/localització/secció/supor/codi estadístic','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idsection, section_libelle FROM docs_section ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"codestatt\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Codi Estadístic]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idcode, codestat_libelle FROM docs_codestat ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"typdocc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idtyp_doc, tdoc_libelle FROM docs_type ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"proprioo\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idlender, lender_libelle FROM lenders ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(235,'Nombre d\'exemplars per propietari/localització/estat','',''),
(236,'Nombre d\'exemplars per propietari/localització/suport','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(238,'Nombre d\'exemplars per propietari/secció','',''),
(240,'Nombre d\'exemplarts per propietari/estat/localització/secció/suport/codi estadístic','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idsection, section_libelle FROM docs_section ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"codestatt\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Códi Estadístic]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idcode, codestat_libelle FROM docs_codestat ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"typdocc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idtyp_doc, tdoc_libelle FROM docs_type ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"proprioo\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlender, lender_libelle FROM lenders ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"statutt\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estat]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idstatut, statut_libelle FROM docs_statut ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(241,'Nombre d\'exemplars per propietari/suport','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(242,'Nombre d\'exemplars per propietari/suport/codi estadístic','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idsection, section_libelle FROM docs_section ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"codestatt\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Códi Estadístic]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idcode, codestat_libelle FROM docs_codestat ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"typdocc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idtyp_doc, tdoc_libelle FROM docs_type ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"proprioo\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idlender, lender_libelle FROM lenders ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(243,'Nombre d\'exemplars per estat','',''),
(244,'Nombre d\'exemplars per suport','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(245,'Nombre d\'exemplars per suport/localització/secció','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(246,' Nombre d\'exemplars per tipus de document','',''),
(248,'Nombre de lectors','',''),
(249,'Nombre de lectors per tipus d\'abonament','',''),
(250,'Nombre de lectors per tipus d\'abonament on la data d\'inscripció esta dins del període indicat','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(251,'Nombre de lectors per tipus d\'abonament on la data de caducitat esta dins del període indicat','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(252,'Nombre de lectors actius per tipus d\'abonament','',''),
(253,'Nombre de lectors actius per categoríes per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[categoria]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT id_categ_empr, libelle FROM empr_categ ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(254,'Nombre de lectors actius per codi estadístic/sexe/tram d\'edat per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any de càlcul :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(255,'Nombre de lectors actius per codi estadístic/tram d\'edat per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any de càlcul :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(256,'Nombre de lectors actius per sexe i tram d\'edat per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any de càlcul :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoria]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by libelle</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(257,'Nombre de lectors actius per sexe, tram d\'edat i ciutat per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any de càlcul :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(258,'Nombre de lectors actius per tram d\'edat per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any de càlcul :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(259,'Nombre de lectors actius per municipi de residència per a una o diverses categorias','Atenció: només té en compte als lectors la data de inici o final d\'inscripció esta dins de l\'any indicat','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoria :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any de càlcul :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(261,'Nombre de lectors per categoria on la data d\'inscripció esta dins del període indicat','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[categoria]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT id_categ_empr, libelle FROM empr_categ ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(262,'Nombre de lectors per categoria on la data de caducitat esta dins del període indicat','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[categoria]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT id_categ_empr, libelle FROM empr_categ ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(263,'Nombre de lectors per categoria i localització','',''),
(265,'Nombre de lectors per codi estadístic i sexe','',''),
(267,'Nombre de lectors per codi estadístic/sexe/tram d\'edat on la data de caducitat esta dins del període indicat','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[categoria]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT id_categ_empr, libelle FROM empr_categ ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(268,'Nombre de lectors per codi estadístic/sexe/tram d\'edat on la data d\'indscripció esta dins del període indicat','','xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Anya de càlcul :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(270,'Nombre de lectors per data de finalització de la inscripció','Número de lectores donde la fecha de caducidad del abono=año indicado','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"anneee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any de finalització de l\'abonament]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(271,'Nombre de lectors amb deute','',''),
(272,'Nombre de lectors amb deute/import','',''),
(273,'Nombre de lectors que van demanar préstecs per tipus d\'abonament per a un dia','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Data :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(274,'Nombre de lectors que van demana préstecs per tipus d\'abonament per a un període i una localització','es basa en l\'històric de préstecs (duració 120 dies)','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Des de :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fins a :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"localisation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[localització :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idlocation, location_libelle FROM docs_location ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(275,'Nombre de lectors que van demanar préstecs per secció i per localització per a un període','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Des de :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fins a :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(276,'Nombre de lectors per localització','A condició que es puga localitzar els lectors','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(277,'Nombre de lectors per sexe','',''),
(281,'Nombre de lectors per municipi de residència on la data d\'inscripció esta dins del període indicat','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(282,'Nombre de lectors per municipi de residència on la data de caducitat esta dins del període indicat','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 1]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data 2]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(283,'Nombre de préstecs en curs per localització','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"localisation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[triar una localització :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(284,'Nombre de préstecs úmero de préstamos /a principi de marca/setmana/mes/any/secció/localització/suport entre 2 dates','Estadístiques setmanals a principi de marca','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date_debut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Data d\'inici]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date_fin\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Data de fi]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"cote\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un principi de marca (per ex. \"R \" per a Romans)...]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS></OPTIONS>\n </FIELD>\n <FIELD NAME=\"localisationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idsection, section_libelle FROM docs_section ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(285,'Nombre de préstecs per suport i sexe','','xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idtyp_doc, tdoc_libelle from docs_type order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Codi(s) Estadístic(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, libelle from empr_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Des de]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fins a]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n</FIELDS>'),
(286,'Nombre de préstecs d\'un exemplar entre 2 dates','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data d\'inici]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[data de fi]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"cb\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[codi de barres]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>15</SIZE>\r\n <MAXSIZE>15</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(287,'Nombre de préstecs per marca, propietari, localització, secció, suport, codi estadístics, per data d\'adquisició entre 2 dates','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Préstecs efecutats entre:]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[I :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"dateacq1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Data d\'adquisició entre :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"dateacq2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[I :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Triar un o més propietaris :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Triar una o més localitzacions :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Triar una o més seccions :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Triar un o més suports :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Triar un o més codis estadístics :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(288,'Nombre de préstecs per tipus d\'abonament per a un període donat','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Des de :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fins a :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(289,'Nombre de préstecs per categoria(autoritat) per a un any','','xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoria :]]></ALIAS>\n  <TYPE>selector</TYPE>\n<OPTIONS FOR=\"selector\">\r\n <METHOD>1</METHOD>\r\n <DATA_TYPE>2</DATA_TYPE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(290,'Nombre de préstecs per categoria de lectors per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS></OPTIONS>\n </FIELD>\n</FIELDS>'),
(291,'Nombre de préstecs per codi estadístic d\'exemplar i per localització','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Codi(s) Estadístic(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Des de]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fins a]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(292,'Nombre de préstecs per codi estadístic del lector','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idtyp_doc, tdoc_libelle from docs_type order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Codi(s) Estadístic(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, libelle from empr_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Des de]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fins a]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n</FIELDS>'),
(293,'Nombre de préstecs per marca, propietari, localització, secció, suport, codi estadístics entre 2 dates','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Entre :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[I :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un o  més propietaris :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un o més localitzacions :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Elija una o varias secciones :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie u o més suports :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un o més codis estadístics :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(294,'Nombre de préstecs per indexació decimal per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(295,'Nombre de préstecs per dia i tram horari','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"debut_període\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[inici del període :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"fin_període\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fi del període :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n</FIELDS>'),
(296,'Nombre de préstecs per dia, tram horari i localització','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"debut_període\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[inici del període :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"fin_període\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[fi del període :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"localisation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[localització :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlocation, location_libelle from docs_location order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(297,'Nombre de préstecs per localització per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(298,'Nombre de préstecs per localització i codi estadístic per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixCS\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Codi(s) Estadístic(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(299,'Nombre de préstecs per localització i secció','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Inici :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fi :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(300,'Nombre de préstecs per localització, secció i suport','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Des de :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fins a :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(301,'Nombre de préstecs per localització, secció i suport','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Des de :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fins a :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(302,'Nombre de préstecs per propietari, localització, secció, suport i codi estadístic','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un o més propietaris :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un o més localitzacions :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un o més seccions :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un o més suports :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un o més codis estadístics :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Entre :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[I :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(303,'Nombre de préstecs per localització i suport per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation,location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(304,'Nombre de préstecs per localitzacio, suport i codi estadístics','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Codi(s) Estadístic(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Inici :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fi :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(305,'Nombre de préstecs per mes i per any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any de càlcul :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(306,'Nombre de préstecs per a un període segons el seu ISSN entre 2 dates','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Inici :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fi :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"cb\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[ISSN :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>50</SIZE>\r\n <MAXSIZE>50</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(307,'Nombre de préstecs per propietari','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"Du\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Des de]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"Au\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fins a]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(308,'Nombre de préstecs per propietari i codi estadístic','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Codi(s) estadístic(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Des de :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fins a :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(309,'Nombre de préstecs per propietari, localització i secció','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlender\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender,lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Año :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(310,'Nombre de préstecs per propietari, localització i suport','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suporte(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlender\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(311,'Nombre de préstecs per propietari i suport','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Inici :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fi :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(312,'Nombre de préstecs per propietari, suport i codi estadístic','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender,lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Codi(s) estadístic(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Inici :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fi :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(313,'Nombre de préstecs per secció per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>20</SIZE>\r\n <MAXSIZE>255</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(314,'Nombre de préstecs per secció i localització per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlocation, location_libelle from docs_location order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(315,'Nombre de préstecs per sexe per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(316,'Nombre de préstecs per sexe i tram d\'edat per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(318,'Nombre de préstecs per suport','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idtyp_doc, tdoc_libelle from docs_type order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Codi(s) Estadístic(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, libelle from empr_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Des de]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fins a]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n</FIELDS>'),
(319,'Nombre de préstecs per suport i per categoria de lectors','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcateg\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoria(s) de lectors :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select id_categ_empr, libelle from empr_categ order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Inici :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fi :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(320,'Nombre de préstecs per suport i codi estadístic d\'exemplars','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Codi(s) Estadístic(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idcode, codestat_libelle from docs_codestat order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Des de]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fins a]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n</FIELDS>'),
(321,'Nombre de préstecs per suport i codi estadístic de lectors','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idtyp_doc, tdoc_libelle from docs_type order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Codi(s) Estadístic(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, libelle from empr_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Des de]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fins a]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n</FIELDS>'),
(322,'Nombre de préstecs per suport i marca','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Inici :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fi :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(323,'Nombre de préstecs per suport i tram d\'edat per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"choixtypdoc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idtyp_doc, tdoc_libelle from docs_type order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(324,'Nombre de préstecs per tram d\'edat per a un any','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(325,'Nombre de préstecs per tram d\'edat per a un període','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Des de :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Fins a :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(326,'Nombre de préstecs per trimestre d\'un exemplar en els últims 3 anys','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"codebarreexpl\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Introduïsca o copie el codi de barres de l\'exemplar...]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\n <SIZE>20</SIZE>\n <MAXSIZE>255</MAXSIZE>\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(327,'Nombre de préstecs per municipi del lector per a un any (sense triar el municipi)','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixville\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Municipi(s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select distinct(arc_empr_ville), arc_empr_ville from pret_archive order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(328,'Llistat d\'obres comprades/donades en un any /suport/localització/codi estadístic/secció/propietari','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie una o més localitzacions :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlocation, location_libelle from docs_location order by 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un o més propietaris :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(329,'Llista de marques per localització','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[localització]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idlocation, location_libelle FROM docs_location ORDER BY 2]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(330,'Llista de marques per localització 2','Especificar el nombre de caràcters per a l\'inici de la marca','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"nomb\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[nombre de caràcters :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>3</SIZE>\r\n <MAXSIZE>2</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[localització]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(331,'Llista de marques per localització i secció','','<xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idsection, section_libelle FROM docs_section ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idlocation, location_libelle FROM docs_location ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(332,'Llista d\'exemplars mai prestats per a un període donat','classificats per data d\'adquisició','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"datedebut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Data d\'inici :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"datefin\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Data de fi :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n</FIELDS>'),
(333,'Llista d\'exemplars destruïts dind d\'un any','es basa en el camp Data de Destrucció','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixannee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(334,'Llista d\'exemplars prestats entre 2 dates per propietari, localització, secció, suport, codi estadístic triant la data d\'adquisició','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Préstecs entre :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[I :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"dateacq1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Data d\'adquisició entre :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2acq\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[I :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un o més propietaris :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixlocation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie una o més localitzacionss :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie una o més seccions :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un o més suports :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un o més codis estadístics :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(335,'Llista d\'exemplars per propietari','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"proprietaire\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by idlender</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\">Trie un prestador</UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(336,'Llista d\'exemplars per propietari, localització, secció, suport, codi estadístic entre 2 dates d\'adquisició','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"date1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Data d\'adquisició entre :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"date2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[I :]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS> \n </FIELD>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie una o més localitzacions :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un o més propietaris :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie una o més seccions :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsupport\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un o més suports :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idtyp_doc, tdoc_libelle from docs_type order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixcodestat\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Trie un o més codis estadístics :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idcode, codestat_libelle from docs_codestat order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(337,'Llista d\'exemplars d\'un propietari per estat','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"statut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estat :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idstatut, statut_libelle from docs_statut</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"Proprietaire\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(338,'Llista d\'exemplars per propietari/estat/localització/secció/suport/codi estadístic/marca/títol/preu/autor principal/editor/any d\'edició','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"locationn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlocation, location_libelle FROM docs_location ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"sectionn\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idsection, section_libelle FROM docs_section ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"codestatt\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Codi Estadístic]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idcode, codestat_libelle FROM docs_codestat ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"typdocc\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Suport]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idtyp_doc, tdoc_libelle FROM docs_type ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"proprioo\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT idlender, lender_libelle FROM lenders ORDER BY 2</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"statutt\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estat]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT idstatut, statut_libelle FROM docs_statut ORDER BY 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(339,'Llista d\'exemplars d\'un propietari per estat/localització/secció','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixproprio\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari (s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixstatut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estat (s) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idstatut, statut_libelle from docs_statut order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(340,'Llista d\'exemplars d\'una o més seccions per propietari','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"sections\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idsection, section_libelle from docs_section</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"preteur\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Proprietari :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by idlender</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\">Trie un propietari</UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(341,'Llista d\'exemplars per estat','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estat :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idstatut,statut_libelle from docs_statut</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\">Trie un estat</UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(342,'Nombre d\'exemplars per propietari,secció','',''),
(343,'Llista de prestataris per nom, cognoms i municipi','',''),
(344,'Llista de lectors per tipus d\'abonament','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"type_abonnement\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[tipus d\'abonament :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[SELECT id_type_abt, type_abt_libelle FROM type_abts ORDER BY 2]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(345,'Llista de lectors per categories','',''),
(347,'Llista de lectors amb informació múltiple','',''),
(348,'Llista de lectors per sexe','',''),
(349,'Llista de lectors per tram d\'edat','els anys indicats esta inclosos en la busca','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"naiss1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[any d\'inici :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"naiss2\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[any de fi :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>4</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(350,'Llista de lectors per municipi','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"villle\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Municipi]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>20</SIZE>\r\n <MAXSIZE>20</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(351,'Llista de transaccions per prestatari','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"typcom\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Tipus de compte]]></ALIAS>\n  <TYPE>list</TYPE>\n<OPTIONS FOR=\"list\">\r\n <MULTIPLE>no</MULTIPLE>\r\n <ITEMS>\r\n  <ITEM VALUE=\"1\"><![CDATA[Abonament]]></ITEM>\r\n  <ITEM VALUE=\"2\"><![CDATA[Multa]]></ITEM>\r\n  <ITEM VALUE=\"3\"><![CDATA[Préstec]]></ITEM>\r\n </ITEMS>\r\n <UNSELECT_ITEM VALUE=\"0\"><![CDATA[Tots]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"empr\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Prestatari]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_empr, concat(empr_nom,\' \',empr_prenom) from empr order by empr_nom</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"0\">Tous</UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"date_debut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Data d\'inici]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n <FIELD NAME=\"date_fin\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Data de fi]]></ALIAS>\n  <TYPE>date_box</TYPE>\n<OPTIONS FOR=\"date_box\"></OPTIONS>\n </FIELD>\n</FIELDS>'),
(352,'Llista de documents mai prestats','',''),
(353,'Llista de documents menys prestats','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param_annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[any de càlcul :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(354,'Llista de documents més prestats','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param_annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[any de càlcul :]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(355,'Llista de préstecs en curs per localització','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"localisation\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[localització]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\n <MULTIPLE>yes</MULTIPLE>\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(356,'Llista de préstecs en curs per localització i secció','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"choixloca\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Localització(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlocation, location_libelle from docs_location order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"choixsection\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció(ns) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section order by 2]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(357,'Assignar a un usuari els mateixos permisos sobre les cistelles del catàleg que un altre usuari','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"userarattacher\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Assignar permisos a l\'usuari (Destí) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"usermodele\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Seleccionar l\'usuari els permisos del quale es van a duplicar (Font) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(358,'Assignar a un usuari els mateixos permisos sobre les cistelles del catàleg que un altre usuari','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"userarattacher\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Assignar permisos a l\'usuari (Destí) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"usermodele\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Seleccionar l\'usuari els permisos del qual es van a duplicar (Font) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(359,'Assignar a un usuari els mateixos permisos sobre els procediments de les cistelles del catàleg que un altre usuari','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"userarattacher\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Assignar els permisos a l\'usuari (Destí) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"usermodele\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Seleccionar a l\'usuari els permisos del qual es van a duplicar (Font) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(360,'Assignar a un usuari els mateixos permisos sobre els procediments de les cistelles de circulació que un altre usuari','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"userarattacher\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Assignar els permisos a l\'usuari (Destí) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"usermodele\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Seleccionar l\'usuari els permisos del qual es va a duplicar (Font) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(361,'Assignar a un usuari els mateixos permisos sobre les estadístiques que un altre usuari','','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"userarattacher\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Assignar els permisos a l\'usuari (Destí) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"usermodele\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Seleccionar l\'usuari els permisos del qual es van a duplicar (Font) :]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>SELECT userid, username FROM users ORDER BY 2</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(1,'Llista d\'exemplars/estat','Llista parametritzada d\'exemplars per estat','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estat]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idstatut,statut_libelle from docs_statut]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[Selecciona un estat]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(2,'Recompte exemplars/estat','Nombre d\'exemplars per estat d\'exemplar',''),
(3,'Recompte exemplars / propietari / estat','Nombre d\'exemplars per propietari i per estat d\'exemplar',''),
(4,'Llista d\'exemplars d\'un propietari / estat','Llista d\'exemplars d\'un propietari per estat, signatura, codi de barres, títol (pràctic per a fer llistes de documents no marcats abans d\'una importació)','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"statut\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Estat]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idstatut, statut_libelle from docs_statut</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"Proprietaire\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Propietari]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(5,'Recompte exemplars / secció','Nombre d\'exemplars per secció',''),
(6,'Llista d\'exemplars per a una o més seccions per propietari','Llista d\'exemplars per una o més seccions per a un propietari','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"sections\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Secció(ns)]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idsection, section_libelle from docs_section]]></QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"preteur\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Propietari]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY><![CDATA[select idlender, lender_libelle from lenders order by idlender]]></QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[Tria un propietari]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(7,'Estat : Recompte exemplars / proprietari','Nombre d\'exemplars per propietari d\'exemplar',''),
(8,'Llista exemplars per a un propietari','Llista dels exemplars per a un propietari ordenats per signatura i codi de barres','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"proprietaire\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Propietari]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select idlender, lender_libelle from lenders order by idlender</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\">Tria un propietari</UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(9,'Recompte usuaris / categoria','Nombre d\'usuaris per categoria',''),
(10,'Llista usuaris / categories','Llista d\'usuaris per categories d\'usuari,usuari',''),
(11,'Estadistiques: Recompte de préstecs /categories d\'usuaris en un any','Nombre de préstecs per categoria d\'usuaris en un any','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[any]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS></OPTIONS>\n </FIELD>\n <FIELD NAME=\"mois\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[mes]]></ALIAS>\n  <TYPE>list</TYPE>\n<OPTIONS FOR=\"list\">\r\n <MULTIPLE>yes</MULTIPLE>\r\n <ITEMS>\r\n  <ITEM VALUE=\"1\"><![CDATA[Gener]]></ITEM>\r\n  <ITEM VALUE=\"2\"><![CDATA[Febrer]]></ITEM>\r\n  <ITEM VALUE=\"3\"><![CDATA[Març]]></ITEM>\r\n  <ITEM VALUE=\"4\"><![CDATA[Abril]]></ITEM>\r\n  <ITEM VALUE=\"5\"><![CDATA[Maig]]></ITEM>\r\n  <ITEM VALUE=\"6\"><![CDATA[Juny]]></ITEM>\r\n  <ITEM VALUE=\"7\"><![CDATA[Juliol]]></ITEM>\r\n  <ITEM VALUE=\"8\"><![CDATA[Agost]]></ITEM>\r\n  <ITEM VALUE=\"9\"><![CDATA[Setembre]]></ITEM>\r\n  <ITEM VALUE=\"10\"><![CDATA[Octubre]]></ITEM>\r\n  <ITEM VALUE=\"11\"><![CDATA[Novembre]]></ITEM>\r\n  <ITEM VALUE=\"12\"><![CDATA[Desembre]]></ITEM>\r\n </ITEMS>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(12,'Estadistiques: Recompte d\'usuaris /edat','Nombre d\'usuaris per úm. de usuarios por franges d\'edat en un any','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any de càlcul]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoria]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(13,'Estadistiques: Recompte d\'usuaris/sexe/edat','Nombre d\'usuaris per sexe i franja d\'edat per a un any','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any de càlcul]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoria]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by libelle</QUERY>\r\n <MULTIPLE>no</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(14,'Estadistiques: Recompte d\'usuaris/població/categoria','Nombre d\'usuaris per població de residència per a una o més categories','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"categorie\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Categoria]]></ALIAS>\n  <TYPE>query_list</TYPE>\n<OPTIONS FOR=\"query_list\">\r\n <QUERY>select id_categ_empr, libelle from empr_categ order by libelle</QUERY>\r\n <MULTIPLE>yes</MULTIPLE>\r\n <UNSELECT_ITEM VALUE=\"\"></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"annee\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any de càlculo]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>'),
(15,'Estadistiques: Recompte de préstecs per mes','Nombre de préstecs per a un any','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[Any de càlcul]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>5</SIZE>\r\n <MAXSIZE>4</MAXSIZE>\r\n</OPTIONS> \n </FIELD>\n</FIELDS>'),
(16,'Estadistiques: Recompte de préstecs/secció per a un any','Nombre de préstecs per seccio per a un any','<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n<FIELDS>\n <FIELD NAME=\"param1\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[any]]></ALIAS>\n  <TYPE>text</TYPE>\n<OPTIONS FOR=\"text\">\r\n <SIZE>20</SIZE>\r\n <MAXSIZE>255</MAXSIZE>\r\n</OPTIONS>\n </FIELD>\n <FIELD NAME=\"mois\" MANDATORY=\"yes\">\n  <ALIAS><![CDATA[mes]]></ALIAS>\n  <TYPE>list</TYPE>\n<OPTIONS FOR=\"list\">\r\n <MULTIPLE>yes</MULTIPLE>\r\n <ITEMS>\r\n  <ITEM VALUE=\"1\"><![CDATA[Gener]]></ITEM>\r\n  <ITEM VALUE=\"2\"><![CDATA[Febrer]]></ITEM>\r\n  <ITEM VALUE=\"3\"><![CDATA[Març]]></ITEM>\r\n  <ITEM VALUE=\"4\"><![CDATA[Abril]]></ITEM>\r\n  <ITEM VALUE=\"5\"><![CDATA[Maig]]></ITEM>\r\n  <ITEM VALUE=\"6\"><![CDATA[Juny]]></ITEM>\r\n  <ITEM VALUE=\"7\"><![CDATA[Juliol]]></ITEM>\r\n  <ITEM VALUE=\"8\"><![CDATA[Agost]]></ITEM>\r\n  <ITEM VALUE=\"9\"><![CDATA[Setembre]]></ITEM>\r\n  <ITEM VALUE=\"10\"><![CDATA[Octubre]]></ITEM>\r\n  <ITEM VALUE=\"11\"><![CDATA[Novembre]]></ITEM>\r\n  <ITEM VALUE=\"12\"><![CDATA[Desembre]]></ITEM>\r\n </ITEMS>\r\n <UNSELECT_ITEM VALUE=\"\"><![CDATA[]]></UNSELECT_ITEM>\r\n</OPTIONS>\n </FIELD>\n</FIELDS>');

UPDATE procs INNER JOIN procs_bak 

ON procs_bak.idproc =procs.idproc

SET procs.name=procs_bak.name,
    procs.comment=procs_bak.comment,
    procs.parameters=procs_bak.parameters;

DROP TABLE IF EXISTS procs_bak;


--
-- Traducción de tabla `procs_classements`
--


DROP TABLE IF EXISTS procs_classements_bak;
CREATE TABLE IF NOT EXISTS procs_classements_bak (
  idproc_classement	smallint(5),
  libproc_classement	varchar(255),
  PRIMARY KEY(idproc_classement))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO procs_classements_bak(idproc_classement, libproc_classement) VALUES
(2,'Autoritzacions'),
(5,'Estadístiques-DLL'),
(9,'Estadístiques-Lectors'),
(14,'Estadístiques-Exemplars'),
(15,'Estadísticas-Préstecs'),
(16,'Llists-Exemplars'),
(17,'Llistats-Lectors'),
(18,'Accions-Neteja'),
(19,'Llistats-Préstecs'),
(20,'Migració');


UPDATE procs_classements INNER JOIN procs_classements_bak 

ON procs_classements_bak.idproc_classement =procs_classements.idproc_classement

SET procs_classements.libproc_classement=procs_classements_bak.libproc_classement;

DROP TABLE IF EXISTS procs_classements_bak;


--
-- Traducción de tabla`sauv_sauvegardes`
--

DROP TABLE IF EXISTS sauv_sauvegardes_bak;
CREATE TABLE IF NOT EXISTS sauv_sauvegardes_bak (
  sauv_sauvegarde_id	int(15),
  sauv_sauvegarde_nom	varchar(50),
  PRIMARY KEY(sauv_sauvegarde_id))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO sauv_sauvegardes_bak(sauv_sauvegarde_id,sauv_sauvegarde_nom) VALUES
(1,'tot');

UPDATE sauv_sauvegardes INNER JOIN sauv_sauvegardes_bak 

ON sauv_sauvegardes_bak.sauv_sauvegarde_id=sauv_sauvegardes.sauv_sauvegarde_id

SET sauv_sauvegardes.sauv_sauvegarde_nom=sauv_sauvegardes_bak.sauv_sauvegarde_nom;

DROP TABLE IF EXISTS sauv_sauvegardes_bak;


--
-- Traducción de tabla`sauv_tables`
--

DROP TABLE IF EXISTS sauv_tables_bak;
CREATE TABLE IF NOT EXISTS sauv_tables_bak (
  sauv_table_id	int(15),
  sauv_table_nom varchar(50),
  PRIMARY KEY(sauv_table_id))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO sauv_tables_bak(sauv_table_id,sauv_table_nom) VALUES
(1,'Biblio'),
(2,'Autoritats'),
(3,'Cap utilitat'),
(4,'Z3950'),
(5,'Usuaris'),
(6,'Aplicació'),
(7,'TOT'),
(9,'Cistelless'),
(10,'DSI'),
(11,'Finances');


UPDATE sauv_tables INNER JOIN sauv_tables_bak 

ON sauv_tables_bak.sauv_table_id=sauv_tables.sauv_table_id

SET sauv_tables.sauv_table_nom=sauv_tables_bak.sauv_table_nom;
     
DROP TABLE IF EXISTS sauv_tables_bak;


--
-- Traducción de tabla `search_perso`
--

DROP TABLE IF EXISTS search_perso_bak;
CREATE TABLE IF NOT EXISTS search_perso_bak (
  search_id	int(8),
  search_name	varchar(255),
  search_human	text,
  PRIMARY KEY(search_id))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO search_perso_bak(search_id, search_name,search_human) VALUES
(1,'Control importació i marcat BPD','<i><strong>Data creació</strong> = ()</i> <strong>I</strong> <i><strong>Localització</strong> = ()</i> <strong>I</strong> <i><strong>Estat</strong> = ()</i> ');


UPDATE search_perso INNER JOIN search_perso_bak 

ON search_perso_bak.search_id=search_perso.search_id

SET search_perso.search_name=search_perso_bak.search_name,
     search_perso.search_human=search_perso_bak.search_human;

DROP TABLE IF EXISTS search_perso_bak;


--
-- Traducción de tabla `statopac_request`
--

DROP TABLE IF EXISTS statopac_request_bak;
CREATE TABLE IF NOT EXISTS statopac_request_bak (
  idproc	int(8),
  name	varchar(255),
  comment tinytext,
  PRIMARY KEY(idproc))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO statopac_request_bak(idproc,name,comment) VALUES
(1,'Nombre de visites per data','Distingix les sessions'),
(2,'Nombre de visites per data (direccions IP)','Distingix les direccions IP'),
(3,'Paraules introduïdes','Mostra les diferents paraules introduïdes en les busques'),
(4,'Exportacions','Nombre d\'exportacions llançades des d\'OPAC'),
(5,'Impressions de cistelles','Impressions de cistelles llançades des d\'OPAC'),
(6,'Primera pàgina mostrada','Primera pàgina mostrada (quan un lector arriba a OPAC) ordenat per freqüència'),
(7,'DSI','Nombre de lectors utilitzant la DSI dins de l\'OPAC'),
(8,'Paraules més buscades','Mostra les paraules més buscades en l\'OPAC'),
(9,'Busca avançada','Busques avançades ordenades per freqüència'),
(10,'Busques existosas o no','Mostra les busques i si es van registrar resultats o no'),
(11,'Tipus de busca','Mostra els tipus de busca realitzades en l\'OPAC ordenats per freqüència'),
(12,'Consultes d\'infopage',''),
(13,'Seccions d\'assistència','');



UPDATE statopac_request INNER JOIN statopac_request_bak 

ON statopac_request_bak.idproc=statopac_request.idproc

SET statopac_request.name=statopac_request_bak.name,
     statopac_request.comment=statopac_request_bak.comment;

DROP TABLE IF EXISTS statopac_request_bak;


--
-- Traducción de tabla `statopac_vues`
--

DROP TABLE IF EXISTS statopac_vues_bak;
CREATE TABLE IF NOT EXISTS statopac_vues_bak (
  id_vue  int(8),
  nom_vue varchar(255),
  PRIMARY KEY(id_vue))  
  
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO statopac_vues_bak(id_vue, nom_vue) VALUES

(1,'Estadístiques de visites'),
(2,'Busques'),
(3,'Navegació'),
(4,'Lectors'),
(5,'Infopages');

UPDATE statopac_vues INNER JOIN statopac_vues_bak

ON statopac_vues_bak.id_vue=statopac_vues.id_vue

SET statopac_vues.nom_vue=statopac_vues_bak.nom_vue;

DROP TABLE IF EXISTS statopac_vues_bak;


--
-- Traducción de tabla `suggestions_categ`
--

DROP TABLES IF EXISTS suggestions_categ_bak;
CREATE TABLE IF NOT EXISTS suggestions_categ_bak(
id_categ int(12),
libelle_categ varchar(255),
PRIMARY KEY(id_categ))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO suggestions_categ_bak(id_categ, libelle_categ) VALUES

(1,'categoría per defecto');

UPDATE suggestions_categ INNER JOIN suggestions_categ_bak

ON suggestions_categ_bak.id_categ=suggestions_categ.id_categ

SET suggestions_categ.libelle_categ=suggestions_categ_bak.libelle_categ;

DROP TABLE IF EXISTS suggestions_categ_bak;


--
-- Traducción de tabla `cms_editorial_types`
--

DROP TABLES IF EXISTS cms_editorial_types_bak;
CREATE TABLE IF NOT EXISTS cms_editorial_types_bak(
id_editorial_type int(10),
editorial_type_label	varchar(255) ,  
PRIMARY KEY (id_editorial_type))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO cms_editorial_types_bak(id_editorial_type , editorial_type_label) VALUES

(1,'CP per Article'),
(2,'CP per Rúbrica');

UPDATE cms_editorial_types INNER JOIN cms_editorial_types_bak

ON cms_editorial_types_bak.id_editorial_type=cms_editorial_types.id_editorial_type

SET cms_editorial_types.editorial_type_label=cms_editorial_types_bak.editorial_type_label;

DROP TABLE IF EXISTS cms_editorial_types_bak;

--
-- Traducción de tabla `lignes_actes_statuts`
--

DROP TABLES IF EXISTS lignes_actes_statuts_bak;
CREATE TABLE IF NOT EXISTS lignes_actes_statuts_bak(
id_statut int(3),
libelle	text ,  
PRIMARY KEY (id_statut))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO lignes_actes_statuts_bak(id_statut , libelle) VALUES

(1,'Tractament normal');


UPDATE lignes_actes_statuts INNER JOIN lignes_actes_statuts_bak

ON lignes_actes_statuts_bak.id_statut=lignes_actes_statuts.id_statut

SET lignes_actes_statuts.libelle=lignes_actes_statuts_bak.libelle;

DROP TABLE IF EXISTS lignes_actes_statuts_bak;

--
-- Traducción de tabla `notice_tpl'
--

DROP TABLES IF EXISTS notice_tpl_bak;
CREATE TABLE IF NOT EXISTS notice_tpl_bak(
notpl_id int(10),
notpl_name varchar(256),
notpl_comment varchar(256),
  
PRIMARY KEY (notpl_id))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO notice_tpl_bak(notpl_id ,notpl_name,notpl_comment) VALUES

(5,'Plantilla de visualització personalitzada sense miniatura','Plantilla de visualització personalitzada sense miniatura'),
(4,'Plantilla de visualització personalitzada',''),
(6,'Bibliografia','Servicis PMB');


UPDATE notice_tpl INNER JOIN notice_tpl_bak

ON notice_tpl_bak.notpl_id=notice_tpl.notpl_id

SET notice_tpl.notpl_name=notice_tpl_bak.notpl_name,
    notice_tpl.notpl_comment=notice_tpl_bak.notpl_comment;		

DROP TABLE IF EXISTS notice_tpl_bak;


--
-- Traducción de tabla 'z_attr'
--

DROP TABLE IF EXISTS z_attr_bak;
CREATE TABLE IF NOT EXISTS z_attr_bak(
attr_bib_id int (6),
attr_libelle varchar(250),
attr_attr varchar(250))

ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO z_attr_bak(attr_bib_id,attr_libelle,attr_attr) VALUES

(2,'tema','21'),
(2,'títol','4'),
(2,'autor','1003'),
(2,'isbn','7'),
(3,'tema','21'),
(3,'títol','4'),
(3,'autor','1003'),
(3,'isbn','7'),
(5,'tema','21'),
(5,'títol','1004'),
(5,'autor','1003'),
(5,'isbn','7'),
(7,'tema','21'),
(7,'títol','4'),
(7,'autor','1003'),
(7,'isbn','7'),
(8,'tema','21'),
(8,'títol','4'),
(8,'autor','1'),
(8,'isbn','7'),
(8,'paraules','1016'),
(10,'tema','21'),
(10,'títol','4'),
(10,'autor','1003'),
(10,'isbn','7'),
(12,'tema','21'),
(12,'títol','4'),
(12,'autor','1003'),
(12,'isbn','7'),
(11,'tema','21'),
(11,'títol','4'),
(11,'autor','1003'),
(11,'isbn','7'),
(15,'tema','21'),
(15,'títol','4'),
(15,'autor','1003'),
(15,'isbn','7'),
(17,'tema','21'),
(17,'títol','4'),
(17,'autor','1003'),
(17,'isbn','7'),
(21,'tema','21'),
(21,'títol','4'),
(21,'autor','1003'),
(21,'isbn','7');

UPDATE z_attr INNER JOIN z_attr_bak

ON z_attr_bak.attr_bib_id=z_attr.attr_bib_id AND z_attr_bak.attr_attr=z_attr.attr_attr

SET z_attr.attr_libelle=z_attr_bak.attr_libelle;
    

DROP TABLE IF EXISTS z_attr_bak;

--
-- Traducción tabla 'parameters
--

DROP TABLES IF EXISTS parametres_bak;
CREATE TABLE IF NOT EXISTS parametres_bak(
id_param int(6),
type_param varchar(20) COLLATE utf8_unicode_ci DEFAULT NULL,
sstype_param varchar(255) COLLATE utf8_unicode_ci DEFAULT NULL,
valeur_param text,
comment_param longtext,
  
PRIMARY KEY (id_param))
ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO parametres_bak(id_param,type_param,sstype_param,valeur_param,comment_param) VALUES
(782, 'pmb', 'bdd_version', '', 'Última versió de la base de dades, no canviar excepte per una versió si un paràmetre no s\'ha actualitzat bé i tornar a realitzar l\'actualització. En general, contacta abans amb la llista de correu pmb.user@sigb.net'),
(783, 'z3950', 'accessible','', 'Z3950 accessible ?\r\n 0 : no, menú inaccessible\r\n 1 : Sí, la llibreria PHP_JAZZ està activada, la busca z3950 és possible'),
(784, 'pmb', 'nb_lastautorities','','Nombre de les últimes autoritats a mostrar en la gestió d\'autoritats'),
(785, 'pdflettreretard', '1before_list','','Text que apareixerà abans de la llista de documents retardats en la carta de reclamació'),
(786, 'pdflettreretard', '1after_list', '', 'Text que apareix després de la llista de documents retardats en la carta'),
(787, 'pdflettreretard', '1fdp', '', 'Signatari de la carta.'),
(788, 'pdflettreretard', '1madame_monsieur', '', 'Encapçalament de la carta'),
(789, 'pdflettreretard', '1nb_par_page', '', 'Nombre de documents amb retard impresos en les pàgines següents.'),
(790, 'pdflettreretard', '1nb_1ere_page', '', 'Nombre d\'obres en retard impresos en la primera pàgina'),
(791, 'pdflettreretard', '1taille_bloc_expl', '', 'Grandària d\'un bloc (2 línies) entre les obres obres amb retard. L\'inici de cada obra en retard s\'espaiarà amb este valor en la pàgina'),
(792, 'pdflettreretard', '1debut_expl_1er_page', '', 'Inici de la llista dels exemplars en la primera pàgina, en mm després del bord superior de la pàgina. Ha d\'estar regulat en funció del text que precedix a la llista de les obres, la qual pot ser més o menys llarga.'),
(793, 'pdflettreretard', '1debut_expl_page', '', 'Inici de la llista dels exemplars en les pàgines següents, en mm després del bord superior de la pàgina..'),
(794, 'pdflettreretard', '1limite_after_list', '', 'Posició màxima en la part inferior de la pàgina. Si un element imprés tendix a sobrepassar este límit, serà imprés en la pàgina següent.'),
(795, 'pdflettreretard', '1marge_page_gauche', '', 'Marge de l\'esquerra en mm'),
(796, 'pdflettreretard', '1marge_page_droite', '', 'Marge de la dreta en mm'),
(797, 'pdflettreretard', '1largeur_page', '', 'Llarg de la pàgina en mm'),
(798, 'pdflettreretard', '1hauteur_page', '', 'Alt de la pàgina en mm'),
(799, 'pdflettreretard', '1format_page', '', 'Format de la pàgina : \r\n P : Portrait = Horitzontal\r\n L : Landscape = apaïsat'),
(800, 'pdfcartelecteur', 'pos_h', '', 'Posició horitzontal en mm a partir del bord esquerre de la la pàgina'),
(801, 'pdfcartelecteur', 'pos_v', '', 'Posició vertical en mm a partir del bord superior de la pàgina'),
(802, 'pdfcartelecteur', 'biblio_name', '', 'Nom de la biblioteca o centre de recursos imprés en el carnet d\'usuari. Posar $biblio_name per a reprendre el nom especificat en la localització de l\'exemplar o be posar una altra cosa.'),
(803, 'pdfcartelecteur', 'largeur_nom', '', 'Llarg d\'acord amb la impressió del nom de l\'usuari en mm'),
(804, 'pdfcartelecteur', 'valabledu', '', '''Vàlid del'' en "VÀLID DEL  ##/##/#### al ##/##/####"'),
(805, 'pdfcartelecteur', 'valableau', '', '''al'' en "vàlid del ##/##/#### AL ##/##/####"'),
(806, 'pdfcartelecteur', 'carteno', '', 'Text que precedix al número de carnet'),
(807, 'sauvegarde', 'cle_crypt1', '', ''),
(808, 'sauvegarde', 'cle_crypt2', '', ''),
(809, 'pmb', 'resa_dispo', '', 'La reserva de documents està disponible ?\r\n 0 : No\r\n 1 : Sí'),
(810, 'mailretard', '1objet', '', 'Assumpte del correu electrònic de reclamació per retard'),
(811, 'mailretard', '1before_list', '', 'Text que apareix en la llista de documents en retard del correu electrònic de retard'),
(812, 'mailretard', '1after_list', '', 'Text que apareixerà abans de la llista de documents en retard en el correu electrònic'),
(813, 'mailretard', '1madame_monsieur', '', 'Encapçalament del correu'),
(814, 'mailretard', '1fdp', '', 'Signatari del correu electrònic de retard'),
(815, 'pmb', 'serial_link_article', '', 'Incloure en els articles l\'enllaç a la revista de la qual procedixen al catalogar les publicacions periòdiques ?\r\n 0 : No\r\n 1 : Sí'),
(817, 'opac', 'modules_search_title', '', 'Busca simple per títol:\r\n 0 : No\r\n 1 : Sí\r\n 2 : autoritzada i seleccionada per defecte'),
(818, 'opac', 'modules_search_author', '', 'Busca simple per autor:\r\n 0 : No\r\n 1 : Sí\r\n 2 : autoritzada i seleccionada per defecte'),
(819, 'opac', 'modules_search_publisher', '', 'Busca simple per editorial:\r\n 0 : No\r\n 1 : Sí\r\n 2 : autoritzada i validada per defecte'),
(820, 'opac', 'modules_search_collection', '', 'Busca simple per col·lecció:\r\n 0 : No\r\n 1 : Sí\r\n 2 : autoritzada i validada per defecte'),
(835, 'opac', 'authors_aut_sort_records', '', 'Mode de visualització dels autors : selecció de registres'),
(821, 'opac', 'modules_search_subcollection', '', 'Busca simple per subcol·lecció:\r\n 0 : No\r\n 1 : Sí\r\n 2 : autoritzada i validada per defecte'),
(822, 'opac', 'modules_search_category', '', 'Busca simple per categoria:\r\n 0 : No\r\n 1 : Sí\r\n 2 : autoritzada i validada per defecte'),
(823, 'opac', 'modules_search_keywords', '', 'Busca simple per indexació lliure (paraules clau):\r\n 0 : No\r\n 1 : Sí\r\n 2 : autoritzada i validada per defecte'),
(824, 'opac', 'modules_search_abstract', '', 'Busca simple pel camp resum:\r\n 0 : No\r\n 1 : Sí\r\n 2 : autoritzada i validada per defecte'),
(825, 'opac', 'modules_search_content', '', 'Busca simple per les notes de contingut:\r\n 0 : No\r\n 1 : Sí\r\n 2 : autoritzada i validada per defecte\r\nNO USAT DE MOMENT'),
(826, 'opac', 'categories_categ_path_sep', '', 'Separador per a les categories'),
(827, 'opac', 'categories_columns', '', 'Nombre de columnes del sumari general de les categories'),
(828, 'opac', 'categories_categ_rec_per_page', '', 'Nombre de registres mostrats per pàgina en l\'exploració de les categories'),
(829, 'opac', 'categories_categ_sort_records', '', 'Explorador de categories : mode de selecció dels registres :\r\n index_sèrie, tnvol, index_sew > per títol de sèrie, número en la sèrie i índex de títols\r\n rand() : aleatori'),
(830, 'opac', 'search_results_first_level', '', 'Número de resultats mostrats en la primera pàgina'),
(831, 'opac', 'search_results_per_page', '', 'Número de resultats mostrats en les pàgines següents'),
(833, 'opac', 'categories_sub_display', '', 'Número de subcategories en la primera pàgina'),
(834, 'opac', 'categories_sub_mode', '', 'Mode de visualització de les subcategories : \r\n rand() > aleatori\r\n libelle_categorie > orde alfabètic'),
(836, 'opac', 'default_lang', '', 'Llengua de l\'opac : es_ES, fr_FR o en_US o ara'),
(837,'opac','show_categ_browser','','Mostrar categories en la pàgina principal de l\'OPAC:\n0: No\n1: Si\n1 3,1: Si, junt amb l\'id 3 més 1 del thesaurus (precisar el tesaurus a mostrar i l\'orde)'),
(838, 'opac', 'show_book_pics', '', 'Mostrar les imatges dels llibres en la fitxa del document :\r\n 0 : No\r\n 1 : Sí'),
(839, 'opac', 'resa', '', 'És pot reservar des de l\'OPAC ? 1: Sí  ou 0: no'),
(840, 'opac', 'resa_dispo', '', 'Es pot reservar un document disponible per l\'OPAC \r\n 1: sí \r\n 0: no'),
(841, 'opac', 'show_meteo', '', 'Mostrar el temps en l\'OPAC 1: sí o 0: no'),
(842, 'opac', 'duration_session_auth', '', 'Duració de la sessió de l\'usuari en l\'OPAC en segons'),
(843, 'pmb', 'relance_adhesion', '', 'Nombre de dies abans de l\'expiració del carnet per a iniciar la renovació'),
(844, 'pmb', 'pret_adhesion_depassee', '', 'Es pot prestar si el carnet està caducat ? : 0 NO, 1 POSSIBLE'),
(845, 'pdflettreadhesion', 'fdp', '', 'Fórmula de cortesia en la part inferior de la pàgina'),
(846, 'pdflettreadhesion', 'madame_monsieur', '', 'Cortersía del destinatari'),
(847, 'pdflettreadhesion', 'texte', '', 'Frase d\'introducció de la finalització de l\'abonament'),
(848, 'pdflettreadhesion', 'marge_page_gauche', '', 'Marge esquerre de la pàgina en mm'),
(849, 'pdflettreadhesion', 'marge_page_droite', '', 'Marge dret de la pàgina en mm'),
(850, 'pdflettreadhesion', 'largeur_page', '', 'Llarg de la pàgina en mm'),
(851, 'pdflettreadhesion', 'hauteur_page', '', 'Alt de la pàgina mm'),
(852, 'pdflettreadhesion', 'format_page', '', 'P per a Vertical, L per a apaïsat (Horitzontal)'),
(853, 'mailrelanceadhesion', 'objet', '', 'Assumpte de la carta de renovació del carnet. Utilitza biblio_name per a reprendre el nom inclòs en la localització dels exemplars.'),
(854, 'mailrelanceadhesion', 'texte', '', 'Text de la renovació, !!date_fin_adhesion!! serà reemplaçat per la data de final de l\'abonament de l\'usuari'),
(855, 'mailrelanceadhesion', 'madame_monsieur', '', 'Encapçalament de la carta de renovació de l\'abonament'),
(856, 'mailrelanceadhesion', 'fdp', '', 'Fórmula de cortesia en la part inferior de la pàgina'),
(857, 'opac', 'show_marguerite_browser', '', '0 o 1 : margarida de les categories'),
(858, 'opac', 'show_100cases_browser', '', '0 o 1 : visualització de les 100 categories'),
(859, 'pmb', 'indexint_decimal', '', '0 o 1 : la classificació interna és decimal tipus Dewey'),
(860, 'opac', 'modules_search_indexint', '', 'Busca simple per la classificació:\r\n 0 : no\r\n 1 : sí\r\n 2 : autoritzada i seleccionada per defecte'),
(862, 'categories', 'show_empty_categ', '', 'Mostrar les categories que no contenen cap registre? \r\n0=no, 1=sí'),
(861, 'empr', 'birthdate_optional', '', 'Any de naixement opcional : \r\n 0 > no: és obligatori\r\n 1 sí'),
(81,'thesaurus','categories_show_empty_categ','','Mostrar les categories que no contenen cap registre:\r\n0=No, 1=Si'),
(82,'thesaurus','categories_term_search_n_per_page','','Nombre de termes mostrats per pàgina en una busca per termes dins de les categories'),
(864, 'opac', 'show_loginform', '', 'Mostrar l\'opció als usuaris de connectar-se en l\'OPAC \r\n 0 > no\r\n 1 sí'),
(865, 'opac', 'default_style', '', 'Estil gràfic de l\'OPAC, 1 estil per defecte, nomargin : sense veure la columna de l\'esquerra'),
(866, 'opac', 'show_exemplaires', '', 'Mostrar els exemplars en l\'OPAC ?\n 1 Sí,\n 0 : No'),
(867, 'pmb', 'import_modele', '', 'Quin script de funcions d\'importació s\'usa per a personalitzar la importació ?'),
(868, 'pmb', 'quotas_avances', '', 'Opcions de préstec avançat ? \r\n 0 : No\r\n 1 : Sí'),
(869, 'opac', 'logo', '', 'Nom de l\'arxiu de la imatge del logo'),
(870, 'opac', 'logosmall', '', 'Nom de l\'arxiu amb la imatge xicoteta del logo'),
(871, 'opac', 'show_bandeaugauche', '', 'Mostrar el menú lateral de l\'esquerra ? \n 0 : No\n 1 : Sí'),
(872, 'opac', 'show_liensbas', '', 'Mostrar els enllaços(pmb, google, bibli) en la part inferior de la pàgina ? \n 0 : No\n 1 : Sí'),
(873, 'opac', 'show_homeontop', '', 'Mostrar l\'enllaç INICI (tornar a l\'inici) davall el nom de la biblioteca o del centre de recursos (necessari en cas de no haver-hi el menú lateral esquerre) ? \r\n 0 : No\r\n 1 : Sí'),
(874, 'pmb', 'resa_quota_pret_depasse', '', 'És possible la reserva si hi ha algun préstec en retard ? \n 0 : No\n 1 : Sí'),
(875, 'pmb', 'import_limit_read_file', '', 'Límit de la grandària de lectura d\'un arxiu a importar, en general amb 100 o 200 ha de funcionar, si hi ha problemes d\'estafe out : abaixar la grandària, 50 per exemple.'),
(876, 'pmb', 'import_limit_record_load', '', 'Límit de la grandària de processar registres a l\'importar, en general 100 o 200 ha de funcionar, si hi ha problemes de time out : abaixar la grandària, 50 per exemple.'),
(877, 'opac', 'biblio_preamble_p1', '', 'Paràgraf 1 amb informació (per exemple, descripció del fons)'),
(878, 'opac', 'biblio_preamble_p2', '', 'Paràgraf 2 d\'informació: inici usuaris'),
(879, 'opac', 'biblio_quicksummary_p1', '', 'Paràgraf 1 de resum, es mostra a través del full d\'estil, veure id quickSummary.p1'),
(880, 'opac', 'biblio_quicksummary_p2', '', 'Paràgraf 2 de resum, es mostra a través del full d\'estil, veure id quickSummary.p2'),
(881, 'opac', 'show_dernieresnotices', '', 'Mostrar les últimes notícies creades en la part inferior de la pàgina ? \n 0 : No\n 1 : Sí'),
(882, 'opac', 'show_etageresaccueil', '', 'Mostrar les estanteries virtuals en la part inferior de la pàgina d\'inici ? \n 0 : No\n 1 : Sí'),
(883, 'opac', 'biblio_important_p1', '', 'Infos importants 1, en el full d\'estil, veure id important.p1'),
(884, 'opac', 'biblio_important_p2', '', 'Infos importants, en el full d\'estil, veure id important.p2'),
(885, 'opac', 'biblio_name', '', 'Nom de la biblioteca o centre de recursos a mostrar en l\'opac'),
(886, 'opac', 'biblio_website', '', 'Pàgina web de la biblioteca o centre de recursos a mostrar en l\'opac'),
(887, 'opac', 'biblio_adr1', '', 'Direcció 1 de la biblioteca o centre de recursos a mostrar en l\'opac'),
(888, 'opac', 'biblio_town', '', 'Població a mostrar en l\'opac'),
(889, 'opac', 'biblio_cp', '', 'Codi postal a mostrar en l\'opac'),
(890, 'opac', 'biblio_country', '', 'País a mostrar en l\'opac'),
(891, 'opac', 'biblio_phone', '', 'Telèfon a mostrar en l\'opac'),
(892, 'opac', 'biblio_dep', '', 'Departament en l\'opac per a mostrar el temps'),
(893, 'opac', 'biblio_email', '', 'Correu electrònic de contacte a mostrar en l\'opac'),
(894, 'opac', 'etagere_notices_order', '', 'Orde de visualització dels registres en les estanteries en l\'opac \n  index_sèrie, tit1 : per títol de sèrie i títol \n rand()  : aleatori'),
(895, 'opac', 'etagere_notices_format', '', 'Format de visualització dels registres en les estanteries en la pantalla d\'iniciol \r\n 1 : ISBD només \r\n 2 : Públic només \r\n 4 : ISBD i Públic \r\n 8 : Reduït (títol+autors) només'),
(896, 'opac', 'etagere_notices_depliables', '', 'Mostrar els registres ampliables en les estanteries de la pàgina d\'inici \r\n 0 : No \r\n 1 : Sí'),
(897, 'opac', 'etagere_nbnotices_accueil', '', 'Nombre de registres mostrats en les categories de la pantalla d\'inici \r\n 0 : Tots \r\n -1 : Cap \r\n x : x registres mostrats com a màxim'),
(898, 'opac', 'nb_aut_rec_per_page', '', 'Nombre de registres mostrats per a una autoritat'),
(899,'opac','notices_format','','Format de visualització dels ressenyes en els resultats de busca \n 0 : Utilitzar el paràmetre notices_format_onglets \n 1 : només ISBD  \n 2 : només Públic \n 4 : ISBD i Públic \n 5 : ISBD i Públic amb ISBD primer \n 8 : Reduït només (títol+autors)'),
(900,'opac','notices_depliable','','Mostrar desplegable de ressenyes en els resultats de busca:\n0: Sense desplegable\n1: Desplgar al fer clic en l\'icona\n2: Desplegar fent clic en tota la haciendo clic en toda la línia del títol'),
(901, 'opac', 'term_search_n_per_page', '', 'Nombre de termes mostrats per pàgina en la busca per terme'),
(902, 'opac', 'show_empty_categ', '', 'Al buscar per terme, ¿ mostrar les categories que no contenen cap registre ?:\r\n 0 : No \r\n 1 : Sí'),
(903, 'opac', 'allow_extended_search', '', 'S\'autoritza o no la busca avançada en l\'opac \n 0 : No \n 1 : Sí'),
(904, 'opac', 'allow_term_search', '', 'S\'autoritza o no la busca per termes en l\'opac\n 0 : No \n 1 : Sí'),
(905, 'opac', 'term_search_height', '', 'Altura en píxels del marc de busca per termes (si no s\'indica o està buit : per defecte 200 píxels)'),
(906, 'opac', 'categories_nb_col_subcat', '', 'Nom de columnes de subcategories al navegar en els categories \n 3 per defecte'),
(907, 'opac', 'max_resa', '', 'Nombre màxim de reserves sobre un document \r\n 5 per defecte \r\n 0 per a il·limitades'),
(908, 'pmb', 'show_help', '', 'Mostrar l\'ajuda contextual de PMB en la part de gestió \r\n 1 Sí \r\n 0 No'),
(909, 'opac', 'show_help', '', 'Mostrar l\'ajuda en línia en l\'OPAC de PMB  \n 1 Sí \n 0 No'),
(910, 'opac', 'cart_allow', '', 'Cistelles disponibles en l\'OPAC de PMB  \n 1 Sí \n 0 No'),
(911, 'opac', 'max_cart_items', '', 'Nombre màxim de registres en una cistella d\'administradors.'),
(912, 'opac', 'show_section_browser', '', 'Mostrar els enllaços de localitzacions i seccions ?\n 0 : No\n 1 : Sí'),
(913, 'opac', 'nb_localisations_per_line', '', 'Nombre de localitzacions mostrades per línia en la pàgina d\'inici (si show_section_browser=1)'),
(914, 'opac', 'nb_sections_per_line', '', 'Nombre de seccions mostrades per línia al visualitzar la localització (si show_section_browser=1)'),
(915, 'opac', 'cart_only_for_subscriber', '', 'Cistelles de registres reservades als usuari o membres de la biblioteca o el centre de recursos ?\r\n 1: Sí\r\n 0: No, autoritzades per a tots els internautes'),
(916, 'opac', 'notice_reduit_format', '', 'Format de visualització reduït dels registres :\r\n 0 normal = títol+autors principals\r\n P 1,2,3: Perso. : tit+aut+camps persos id 1 2 3\r\n E 1,2,3: Perso. : tit+aut+edit+camps persos id 1 2 3 \r\n T : tit1+tit4'),
(917, 'pdflettreresa', 'before_list', '', 'Text que apareix abans de la llista d\'obres reservades en la carta de confirmació de reserves'),
(918, 'pdflettreresa', 'after_list', '', 'Text que apareix després de les llista d\'obres'),
(919, 'pdflettreresa', 'fdp', '', 'Firma de la carta, usar $biblio_name per a incloure el paràmetre "biblio name" o bé introduïx una altra cosa.'),
(920, 'pdflettreresa', 'madame_monsieur', '', 'Encapçalament de la carta'),
(921, 'pdflettreresa', 'nb_par_page', '', 'Número de document en retard impresos en les pàgines següents.'),
(922, 'pdflettreresa', 'nb_1ere_page', '', 'Nombre de documents en retard impresos en la primera pàgina'),
(923, 'pdflettreresa', 'taille_bloc_expl', '', 'Grandària d\'un bloc (2 línies) d\'obres en reserva. L\'inici de cada obra reservada serà espaiada amb este valor en la pàgina'),
(924, 'pdflettreresa', 'debut_expl_1er_page', '', 'Inici de la llista d\'obres en la primera pàgina, en mm a comptar des del bord superior de la pàgina. Ha d\'estar regulat en funció del text que precedix a la llista d\'obres, que pot ser mes o menys llarg.'),
(925, 'pdflettreresa', 'debut_expl_page', '', 'Inici de la llista d\'obres en els pàgines següents, en mm a comptar des del bord superior de la pàgina.'),
(926, 'pdflettreresa', 'limite_after_list', '', 'Posició límit en la part inferior de la pàgina. Si un element imprés sobrepassa este límit, s\'imprimirà en la pàgina següent.'),
(927, 'pdflettreresa', 'marge_page_gauche', '', 'Marge esquerre en en mm'),
(928, 'pdflettreresa', 'marge_page_droite', '', 'Marge dret  en mm'),
(929, 'pdflettreresa', 'largeur_page', '', 'Ample de la pàgina en mm'),
(930, 'pdflettreresa', 'hauteur_page', '', 'Alt de la pàgina  en mm'),
(931, 'pdflettreresa', 'format_page', '', 'Format de la pàgina : \r\n P : Vertical\r\n L : Landscape = apaïsat'),
(932, 'opac', 'categories_max_display', '', 'Per a la pàgina d\'inici, nom màxim de categories principals mostrades'),
(933, 'opac', 'search_other_function', '', 'Funció complementària per a les busques en la pàgina d\'inici'),
(934, 'opac', 'lien_bas_supplementaire', '', 'Enllaç suplementari en la part inferior de la pàgina d\'inici, a introduir completa : a href= lien /a' ),
(935, 'z3950', 'import_modele', '', 'Quin script de funcions d\'importació cal usar per a personalitzar la importació en la integració z3950 ?'),
(936, 'ldap', 'server', '', 'Servidor LDAP, IP o host'),
(937, 'ldap', 'basedn', '', 'Arrel del nom de domini LDAP'),
(938, 'ldap', 'port', '', 'Port del servidor LDAP'),
(939, 'ldap', 'filter', '', 'Servidor LDAP, IP o host'),
(940, 'ldap', 'fields', '', 'Camps del servidor LDAP'),
(941, 'ldap', 'lang', '', 'Llengua del servidor LDAP'),
(942, 'ldap', 'groups', '', 'Grups del servidor LDAP'),
(943, 'ldap', 'accessible', '', 'LDAP accessible ?'),
(944, 'opac', 'categories_show_only_last', '', 'En la fitxa d\'un registre : \n 0 mostrar tot \n 1 : mostrar únicament l\'últim full de l\'arbre de categories'),
(164,'thesaurus','categories_show_only_last','','En la fitxa d\'un registre: \n 0 Mostrar tot \n 1 : mostrar únicament l\'última branca de l\'árbre de la categoria'),
(946, 'pmb', 'prefill_cote', '', 'Script personalitzat de construcció de la signatura de l\'exemplar'),
(947, 'ldap', 'proto', '', 'Versió del protocol LDAP : 3 o 2'),
(948, 'ldap', 'binddn', '', 'Descripció de la connexió : construcció de la cadena binddn per a enllaçar l\'autentificació al servidor LDAP en l\'OPAC'),
(949, 'empr', 'corresp_import', '', 'Taula de correspondències columnes/camps en la importació d\'usuaris a partir d\'un arxiu ASCII'),
(950, 'pmb', 'type_audit', '', 'Gestió/visualització de les dates de creació/modificació \n 0: Cap\n 1: Creació i última modificació\n 2: Creació i totes les dates de modificació'),
(951, 'pmb', 'gestion_abonnement', '', 'Usar la gestió dels abonaments dels usuaris ? \n 0 : No\n 1 : Sí, gestió simple, \n 2 : Sí, gestió avançada'),
(952,'pmb','utiliser_calendrier','','Utilitzar el calendari de dies d\'obertura?\n 0 : No\n 1 : Si, per al càlcul de les dates de venciment i els retards\n 2 : Si, únicament per al càlcul de les dates de retorn'),
(953, 'pmb', 'gestion_financiere', '', 'Usar el mòdul de gestió financera ? \n 0 : No\n 1 : Sí'),
(954, 'pmb', 'gestion_tarif_prets', '', 'Usar la gestió de tarifes de préstecs ? \n 0 : No\n 1 : Sí, gestió simple, \n 2 : Sí, gestió avançada'),
(955, 'pmb', 'gestion_amende', '', 'Usar la gestió de les multes :\n 0 = No\n 1 = Gestió simple\n 2 = Gestió avançada'),
(956, 'finance', 'amende_jour', '', 'Multa per dia de retard per a tot tipus de documents. Atenció, el separador decimal és el punt, no la coma'),
(957, 'finance', 'delai_avant_amende', '', 'Termini abans de cobrar la multa, en dies'),
(958, 'finance', 'delai_recouvrement', '', 'Termini entre la 3a reclamació i l\'actualització de cobrament oficial de la multa, en dies'),
(959, 'finance', 'amende_maximum', '', 'Multa màxima, siga quin siga el retard, la multa es limita a este import. 0 per a desactivar esta opció'),
(960, 'pdflettreresa', 'priorite_email', '', 'Prioritat dels cartes de confirmació de reserva per correu electrònic després de la validació d\'una reserva :\n 0 : Carta sola\n 1 : Correu electrònic, si no n\'hi ha carta\n 2 : Mail I carta\n 3 : Cap alerta'),
(961, 'pdflettreresa', 'priorite_email_manuel', '', 'Prioritats de les cartes de confirmació de reserva per correu electrònic després de la seua impressió després d\'imprimir a partir del botó:\n 0 : Carta sola\n 1 : Correu electrònic, si no n\'hi ha carta\n 2 : Mail I carta\n 3 : Cap alerta'),
(962, 'finance', 'blocage_abt', '', 'Bloqueig del préstec si el compte de l\'abonament té deutes\n 0 : sense bloqueig\n 1 : bloqueig amb opció a forçar . : bloqueig inevitable.'),
(963, 'finance', 'blocage_pret', '', 'Bloqueig del préstec si el compte de préstecs té deutes\n 0 : sense bloqueig \n 1 : bloqueig amb opció a forçar . : bloqueig inevitable.'),
(964, 'finance', 'blocage_amende', '', 'Bloqueig del préstec si el compte de multes té deutes\n 0 : sense bloqueig \n 1 : bloqueig amb opció a forçar . : bloqueig inevitable..'),
(965, 'pmb', 'gestion_devise', '', 'Divisa de la gestió financera, la que es visualitzarà en codi HTML'),
(966, 'opac', 'book_pics_url', '', 'URL de les imatges dels registres, en la direcció proporcionada, !!isbn!! es reemplaçarà pel codi ISBN o EAN del registre sense cap guió o punt. \r\n exemple : http://www.monsite/opac/images/vignettes/!!isbn!!.jpg'),
(967, 'opac', 'lien_moteur_recherche', '', 'Enllaç suplementari en la pàgina d\'inici, a introduir complet : a href= enllaç'),
(968, 'pmb', 'pret_express_statut', '', 'Estat del registre al crear un exemplar en préstec ràpid'),
(969, 'opac', 'notice_affichage_class', '', 'Nom de la classe per a la personalització de la visualització de registres'),
(970, 'pmb', 'confirm_retour', '', 'Al tornar documents, ¿ el retorn ha de confirmar-se ? \n 0 : No, es poden passar els codis de barres uns darrere d\'altres \n 1 : Sí, és necessari validar la devolució després de cada codi de barres'),
(971, 'opac', 'show_meteo_url', '', 'URL del temps a mostrar'),
(972, 'pmb', 'limitation_dewey', '', 'Nombre màxim de caràcters en la Dewey (676) a l\'importar : \r\n 0 cap limitació \r\n 3 : limitació de 000 a 999 \r\n 5 (exemple) limitació 000.0 \r\n -1 : no importar'),
(973, 'finance', 'delai_1_2', '', 'Termini entre la 1ª i la 2ª reclamació'),
(974, 'finance', 'delai_2_3', '', 'Termini entre la 2ª i la 3ª reclamació'),
(975, 'pmb', 'lecteurs_localises', '', 'Usuaris localitzats ? \n 0: No \n 1: Sí'),
(976, 'dsi', 'active', '', 'DSI activada ? \n 0: No \n 1: Sí'),
(977, 'dsi', 'auto', '', 'DSI automàtica activada ? \r\n 0: No \r\n 1: Sí'),
(978, 'dsi', 'insc_categ', '', 'Subscripció automàtica a les cistelles de la categoria de l\'usuari al crear-ho ? \n 0: No \n 1: Sí'),
(979, 'opac', 'allow_bannette_priv', '', 'Possibilitat per als usuaris de crear o modificar les seues cistelles privades \r\n 0: No \r\n 1: Sí'),
(980, 'opac', 'allow_resiliation', '', 'Possibilitat per als usuaris de cancel·lar la seua subscripció als cistelles pro \r\n 0: No \r\n 1: Sí'),
(981, 'opac', 'show_categ_bannette', '', 'Mostrar les cistelles de la categories de l\'usuari i la seua disponibilitat per a subscriure\'s \r\n 0: No \r\n 1: Sí'),
(982, 'opac', 'url_base', '', 'URL de l\'opac : normalment posar la url públca del web http://mipagina/opac/ no oblidar-se el / final'),
(983, 'finance', 'relance_1', '', 'Cost per la primera carta de reclamació'),
(984, 'finance', 'relance_2', '', 'Cost per la segona carta de reclamació'),
(985, 'finance', 'relance_3', '', 'Cost per la tercera carta de reclamació'),
(986, 'finance', 'statut_perdu', '', 'Estat (d\'exemplar) perdut per a les obres no tornades'),
(987, 'pdflettreretard', '2after_list', '', 'Text que apareix després de la llista de documents en retard en la carta de reclamació'),
(988, 'pdflettreretard', '2before_list', '', 'Text que apareix abans de la llista de documents en retard en la carta de reclamació'),
(989, 'pdflettreretard', '2debut_expl_1er_page', '', 'Inici de la llista d\'exemplars en la primera pàgina, en mm a partir del marge superior de la pàgina. Ha d\'estar regulat en funció del text que precedix a la llista d\'obres, que pot ser més o menys llarg.'),
(990, 'pdflettreretard', '2debut_expl_page', '', 'Inici de la llista dels exemplars en les pàgina següent, en mm a partir del marge superior de la pàgina.'),
(991, 'pdflettreretard', '2fdp', '', 'Firma de la carta'),
(992, 'pdflettreretard', '2format_page', '', 'Format de la pàgina : \r\n P : Vertical\r\n L: Horitzontal'),
(993, 'pdflettreretard', '2hauteur_page', '', 'Alt de la pàgina en mm'),
(994, 'pdflettreretard', '2largeur_page', '', 'Llarg de la pàgina en mm'),
(995, 'pdflettreretard', '2limite_after_list', '', 'Posició límit en la part inferior de la pàgina. Si un element imprés tendix a passar este límit, s\'imprimirà en la pàgina següent.'),
(996, 'pdflettreretard', '2madame_monsieur', '', 'Encapçalament de la carta'),
(997, 'pdflettreretard', '2marge_page_droite', '', 'Marge dret en mm'),
(998, 'pdflettreretard', '2marge_page_gauche', '', 'Marge esquerre en mm'),
(999, 'pdflettreretard', '2nb_1ere_page', '', 'Nombre d\'obres en retard impreses en la primera pàgina'),
(1000, 'pdflettreretard', '2nb_par_page', '', 'Nombre d\'obres en retard impreses en les pàgina següent'),
(1001, 'pdflettreretard', '2taille_bloc_expl', '', 'Grandària de bloc (2 línies) d\'obra en retard. L\'inici de cada obra en retard serà espaiat este valor'),
(1002, 'pdflettreretard', '3after_list', '', 'Text que apareix després de la llista d\'obres en retard en la carta de reclamació'),
(1003, 'pdflettreretard', '3before_list', '', 'Text que apareix abans de la llista de documents en retard en la carta de reclamació'),
(1004, 'pdflettreretard', '3debut_expl_1er_page', '', 'Inici de la llista d\'exemplars en la primera pàgina, en mm a partir del marge superior de la pàgina. Ha d\'estar regulat en funció del text que precedix a la llista d\'obres, que pot ser més o menys llarg.'),
(1005, 'pdflettreretard', '3debut_expl_page', '', 'Inici de la llista dels exemplars en la pàgina següent, en mm a partir del marge superior de la pàgina.'),
(1006, 'pdflettreretard', '3fdp', '', 'Firma de la carta.'),
(1007, 'pdflettreretard', '3format_page', '', 'Format de la pàgina : \r\n P : Vertical\r\n L: Horitzontal'),
(1008, 'pdflettreretard', '3hauteur_page', '', 'Alt de la pàgina en mm'),
(1009, 'pdflettreretard', '3largeur_page', '', 'Llarg de la pàgina en mm'),
(1010, 'pdflettreretard', '3limite_after_list', '', 'Posició límit en la part inferior de la pàgina. Si un element imprés tendix a passar este límit, s\'imprimirà en la pàgina següent.'),
(1011, 'pdflettreretard', '3madame_monsieur', '', 'Encapçalament de la carta'),
(1012, 'pdflettreretard', '3marge_page_droite', '', 'Marge dret en mm'),
(1013, 'pdflettreretard', '3marge_page_gauche', '', 'Marge esquerre en mm'),
(1014, 'pdflettreretard', '3nb_1ere_page', '', 'Nombre d\'obres en retard impreses en la primera pàgina'),
(1015, 'pdflettreretard', '3nb_par_page', '', 'Nombre d\'obres en retard impreses en les pàgina següent.'),
(1016, 'pdflettreretard', '3taille_bloc_expl', '', 'Grandària de bloc (2 línies) d\'obra en retard. L\'inici de cada obra en retard serà espaiat este valor'),
(1017, 'pdflettreretard', '3before_recouvrement', '', 'Text anterior a la llista d\'obres reclamades'),
(1018, 'opac', 'bannette_notices_order', ' ', 'Orde dels registres en les cistelles en l\'opac\n  index_serie, tnvol, index_sew : ordenades per títol de sèrie i per títol\n rand()  : aletorio'),
(1019, 'opac', 'bannette_notices_format', '', 'Format de visualització dels registres en les cistelles \n 1 : només ISBD \n 2 : Públic només \n 4 : ISBD i Públic \n 8 : Reduït (títol+autors) només'),
(1020, 'opac', 'bannette_notices_depliables', '', 'Mostrar ampliació dels registres en les cistelles \n 0 : No \n 1 : Sí'),
(1021, 'opac', 'bannette_nb_liste', '', 'Nombre de registres per cistella en la llista de cistelles \r\n 0 Tots \r\n N : maxi N\r\n -1 : cap'),
(1022, 'opac', 'dsi_active', '', 'DSI, cistelles accessibles dónes de l\'OPAC ? \r\n 0 : No \r\n 1 : Sí'),
(1023, 'mailretard', '2after_list', '', 'Text que apareix després de la llista d\'obres en retard en el correu electrònic de reclamació.'),
(1024, 'mailretard', '2before_list', '', 'Text que apareix abans de la llista de documents en retard en el correu electrònic de reclamació'),
(1025, 'mailretard', '2fdp', '', 'Firma del correu electrònic de reclamació'),
(1026, 'mailretard', '2madame_monsieur', '', 'Encapçalament del correu electrònic'),
(1027, 'mailretard', '2objet', '', 'Assumpte del correu electrònic de reclamació'),
(1028, 'mailretard', '3after_list', '', 'Text que apareix després de la llista d\'obres en retard en el correu electrònic de reclamació.'),
(1029, 'mailretard', '3before_list', '', 'Text que apareix abans de la llista de documents en retard en el correu electrònic de reclamació'),
(1030, 'mailretard', '3fdp', '', 'Firma del correu electrònic de reclamació'),
(1031, 'mailretard', '3madame_monsieur', '', 'Encapçalament del correu electrònic'),
(1032, 'mailretard', '3objet', '', 'Assumpte del correu electrònic de reclamació'),
(1033, 'mailretard', '3before_recouvrement', '', 'Text anterior a la llista d\'obres reclamades'),
(1034, 'mailretard', 'priorite_email', '', 'Prioritat de les cartes de reclamació :\n 0 : Carta només \n 1 : Correu electrònic, si no n\'hi ha carta \n 2 : Correu electrònic I carta'),
(1035, 'pmb', 'import_modele_lecteur', '', 'Model d\'importació dels usuaris'),
(1036, 'pmb', 'blocage_retard', '', 'Bloquejar el préstec amb una duració igual al retard ? 0=no, 1=sí'),
(1037,'pmb','blocage_delai','','Període a partir del qual el retard serà tingut en compte per al bloqueig'),
(1038, 'pmb', 'blocage_max', '', 'Nombre màxim de dies a bloquejar (0 = sense límit)'),
(1039, 'pmb', 'blocage_coef', '', 'Coeficient de proporció dels dies de retard per a bloquejar'),
(1040, 'pmb', 'blocage_retard_force', '', '1 = El préstec pot forçar-se quan un usuari estiga bloquejat, 2 = No es pot forçar'),
(1041, 'opac', 'etagere_order', '', 'Orde de les estanteries en la pantalla d\'inici, \n name = per nom\n name DESC = per nom descendent'),
(1042, 'pmb', 'book_pics_show', '', 'Veure les cobertes dels llibres en gestió\r\n 1: sí  \r\n 0: no'),
(1043, 'pmb', 'book_pics_url', '', 'URL de les imatges dels registres, en el camí introduït , !!isbn!! es reemplaçarà pel codi ISBN o EAN del registre eliminant tots els guions o punts. \r\n exemple : http://www.mipagina/opac/imagenes/cubiertas/!!isbn!!.jpg'),
(1044, 'pmb', 'opac_url', '', 'URL de l\'OPAC vist des de la part de gestió, per defecte ./opac_css/'),
(1045, 'opac', 'resa_popup', '', 'Formulari de connexió en forma de popup ? :\n 0 : No\n 1 : Sí'),
(1046, 'pmb', 'vignette_x', '', 'Llarg de la imatge creada per a un document electrònic'),
(1047, 'pmb', 'vignette_y', '', 'Alt de la imatge creada per a un document electrònic'),
(1048, 'pmb', 'vignette_imagemagick', '', 'Camí de l\'executable ImageMagick (/usr/bet/imagemagick per exemple)'),
(1049, 'opac', 'show_rss_browser', '', 'Veure les fonts RSS del catàleg en la pàgina d\'inici 1: sí o 0: no'),
(1050, 'pmb', 'mail_methode', '', 'Mètode d\'enviament dels correus electrònics : \n php : funció mail() de php\n smtp,hote:port,auth,user,pass : en smtp, posar 0 o 1 per a l\'autentificació...'),
(1051, 'opac', 'mail_methode', '', 'Mètode d\'enviament dels correus electrònics en l\'opac : \n php : funció mail() de php\n smtp,hote:port,auth,user,pass : en smtp, posar 0 o 1 per a l\'autentificació...'),
(1052, 'opac', 'search_show_typdoc', '', 'Mostrar opció per tipus de document per a les busques en la pàgina d\'inici'),
(1053, 'pmb', 'verif_on_line', '', 'En el menú Administració > Ferramentes > Act Base : verificació de versions més recents de PMB en línia ? \r\n0 : no : si no estàs connectat a internet\r\n 1 : Sí : si estàs connectat a internet'),
(1054, 'opac', 'show_languages', '', 'Mostrar un menú desplegable de selecció de llengua ? \r\n 0 : No \r\n 1 : Sí \r\nNo uses un espai entre els codis de llengües, només una coma  fr_FR,it_IT,en_UK,nl_NL,oc_FR'),
(1055, 'pmb', 'pdf_font', '', 'Font tipogràfica per als camps variables en els pdf - Font Arial'),
(1056, 'pmb', 'pdf_fontfixed', '', 'Font tipogràfica per als camps fixos en els pdf - Font Courier'),
(1057, 'z3950', 'debug', '', 'Buidar (exportar arxiu) dels registres trobats en Z3950 \r\n 0: No \r\n 1: Sí'),
(1058, 'pmb', 'nb_lastnotices', '', 'Nombre d\'últims registres a mostrar en Catàleg - Últims registres'),
(1059, 'opac', 'show_dernieresnotices_nb', '', 'Nombre d\'últims registres a mostrar en Catàleg - Últims registres'),
(1060,'pmb','recouvrement_auto','','Per defecte nivell de recuperació proposat en la gestió de recuperació si nivell=3 i ha d\'estar en 4: \r\n 1: Si, recuperació proposada per defecte \r\n 0: No fer res per defecte'),
(1061, 'pmb', 'keyword_sep', '', 'Separador de paraules clau en la zona d\'indexació lliure, espai o ; o , o .'),
(1062, 'thesaurus', 'mode_pmb', '', 'Nivell d\'ús del tesauro.\n 0 : Un sol tesauro per defecte.\n 1 : Selecció de tesauro possible.'),
(1063, 'thesaurus', 'defaut', '', 'Identificador del tesauro per defecte.'),
(1064, 'thesaurus', 'liste_trad', '', 'Llista d\'idiomes mostrats en els tesauros.\n(ex : es_ES,en_UK,...,ar)'),
(1065, 'opac', 'thesaurus', '', 'Nivell d\'ús dels tesauro.\n 0 : Un sol tesauro per defecte.\n 1 : Selecció de tesuaro possible.'),
(1066, 'acquisition', 'active', '', 'Mòdul d\'adquisicions activat.\n 0 : No.\n 1 : Sí.'),
(1067, 'acquisition', 'gestion_tva', '', 'Gestió de l\'IVA.\n 0 : No.\n 1 : Sí.'),
(1068, 'acquisition', 'poids_sugg', '', 'Valoració dels suggeriments per defecte en percentatge.\r\n B=Personal centre, U=Usuaris, V=Visitants.\r\n ex : U=1.00,E=0.70,V=0.00 \r\n'),
(1069, 'acquisition', 'format', '', 'Grandària del Número i Prefixos de les actes de compres.\nex : 8,CA,DD,BL,FA \n8 = Prefix + 8 xifres\nCA=Comanda Compra, DD=Petició de pressupost,BL=Albarà d\'entrega, FA=Factura de compra'),
(1070, 'acquisition', 'budget', '', 'Ús d\'un pressupost per a les comandes.\n 0:opcional\n 1:obligatori'),
(1071, 'acquisition', 'pdfcde_format_page', '', 'Amplària x Altura de la pàgina en mm'),
(1072, 'acquisition', 'pdfcde_orient_page', '', 'Orientació de la pàgina: P=Retrat L=Apaïsat'),
(1073, 'acquisition', 'pdfcde_marges_page', '', 'Marges de la pàgina en mm : Superior,Inferior,Dreta,Esquerra'),
(1074, 'acquisition', 'pdfcde_pos_logo', '', 'Posició del logo: Distància amb relació a la vora esquerre de la pàgina, Distància amb relació a l\'anada de la pàgina, Ample, Alt'),
(1075, 'acquisition', 'pdfcde_pos_raison', '', 'Posició Raó social: Distància amb relació a la vora esquerre de la pàgina, Distància amb relació a l\'anada de la pàgina, Llarg, Alt, Grandària font'),
(1076, 'acquisition', 'pdfcde_pos_date', '', 'Posició Data: Distància amb relació al marge superior esquerre de la pàgina, Distància amb relació a la vora superior de la pàgina, Ample, Alt, Grandària de la font'),
(1077, 'acquisition', 'pdfcde_pos_adr_fac', '', 'Posició Direcció de facturació: Distància amb relació al marge superior esquerre de la pàgina, Distància amb relació al marge superior de la pàgina, Ample, Alt, Grandària de la font'),
(1078, 'acquisition', 'pdfcde_pos_adr_liv', '', 'Posició Direcció d\'entrega: Distància amb relació al marge superior esquerre de la pàgina, Distància amb relació al marge superior de la pàgina, Ample, Alt, Grandària de la font'),
(1079, 'acquisition', 'pdfcde_pos_adr_fou', '', 'Posició Direcció proveïdor: Distància amb relació al marge superior esquerre de la pàgina, Distància amb relació al márger superior de la pàgina, Ample, Alt, Grandària de la font'),
(1080, 'acquisition', 'pdfcde_pos_num', '', 'Posició número de comanda: Distància amb relació al marge superior esquerre de la pàgina, Distància amb relació al marge superior de la pàgina, Ample, Alt, Grandària de la font'),
(1081, 'acquisition', 'pdfcde_text_size', '', 'Grandària de la font del text'),
(1082, 'acquisition', 'pdfcde_text_before', '', 'Text anterior de la comanda'),
(1083, 'acquisition', 'pdfcde_text_after', '', 'Text posterior a la comanda'),
(1084, 'acquisition', 'pdfcde_tab_cde', '', 'Llista de comandes: Ample línia, Grandària font'),
(1085, 'acquisition', 'pdfcde_pos_tot', '', 'Posició total de la comanda: Distància amb relació al marge esquerre de la pàgina, Amplària,  Altura línia, Grandària font'),
(1086, 'acquisition', 'pdfcde_pos_footer', '', 'Posició davall de la pàgina: Distància amb relació a la vora inferior de la pàgina, Grandària de la font'),
(1087, 'acquisition', 'pdfcde_pos_sign', '', 'Posició firma: Distància amb relació a la vora esquerre de la pàgina, Amplària, Altura línia, Grandària font'),
(1088, 'acquisition', 'pdfcde_text_sign', '', 'Text firma'),
(1089, 'acquisition', 'pdfdev_format_page', '', 'Ample x Alt de la pàgina en mm'),
(1090, 'acquisition', 'pdfdev_orient_page', '', 'Orientació de la pàgina: P= Vertical L=Apaïsat'),
(1091, 'acquisition', 'pdfdev_marges_page', '', 'Marges de la pàgina en mm : Dalt, Baix, Dreta, Esquerra'),
(1092, 'acquisition', 'pdfdev_pos_logo', '', 'Posició del logo: Distància amb relació a la vora esquerre de la pàgina, Distància amb relació a la vora de dalt de la pàgina, Ample, Alt'),
(1093, 'acquisition', 'pdfdev_pos_raison', '', 'Posició Raó social: Distància amb relació a la vora esquerre de la pàgina, Distància amb relació a la vora de dalt de la pàgina, Ample, Alt, Grandària de la font'),
(1094, 'acquisition', 'pdfdev_pos_date', '', 'Posició Data: Distància amb relació a la vora esquerre de la pàgina, Distància amb relació a la vora de dalt de la pàgina, Ample, Alt, Grandària de la font'),
(1095, 'acquisition', 'pdfdev_pos_adr_fac', '', 'Posició Direcció de facturació: Distància amb relació a la vora esquerre de la pàgina, Distància amb relació a la vora de dalt de la pàgina, Ample, Alt, Grandària de la font'),
(1096, 'acquisition', 'pdfdev_pos_adr_liv', '', 'Posició Direcció d\'entrega: Distància amb relació a la vora esquerre de la pàgina, Distància amb relació a la vora de dalt de la pàgina, Ample, Alt, Grandària de la font'),
(1097, 'acquisition', 'pdfdev_pos_adr_fou', '', 'Posició Direcció distribuïdor: Distància amb relació a la vora esquerre de la pàgina, Distància amb relació a la vora de dalt de la pàgina, Ample, Alt, Grandària de la font'),
(1098, 'acquisition', 'pdfdev_pos_num', '', 'Posició número de comanda: Distància amb relació a la vora esquerre de la pàgina, Distància amb relació a la vora de dalt de la pàgina, Ample, Alt, Grandària de la font'),
(1099, 'acquisition', 'pdfdev_text_size', '', 'Grandària de la font del text'),
(1100, 'acquisition', 'pdfdev_text_before', '', 'Text anterior a la llista de comandes'),
(1102, 'acquisition', 'pdfdev_text_after', '', 'Text després de la llista de comandes'),
(1103, 'acquisition', 'pdfdev_tab_dev', '', 'Llista de comandes: Alt línia, Grandària de la font'),
(1104, 'acquisition', 'pdfdev_pos_footer', '', 'Posició inferior de la pàgina: Distància amb relació a la vora inferior de la pàgina,  Grandària de la font'),
(1105, 'acquisition', 'pdfdev_pos_sign', '', 'Posició firma: Distància amb relació a la vora esquerre de la pàgina,  Ample, Alt, Grandària de la fuent'),
(1106, 'acquisition', 'pdfdev_text_sign', '', 'Text firma'),
(1107, 'opac', 'export_allow', '', 'Exportació de registres a partir de l\'opac : \n 0 : prohibit \n 1 : per a tots \n 2 : per als usuaris registrats únicament'),
(1108, 'opac', 'resa_planning', '', 'Usar un pla de reserva ? \n 0: No \n 1: Sí'),
(1109, 'opac', 'resa_contact', '', 'Codi HTML d\'informació sobre la persona a contactar per exemple en cas de problemes de reserva.'),
(1110, 'opac', 'default_operator', '', 'Operador per defecte. 0 : OR, 1 : AND.'),
(1111, 'opac', 'modules_search_all', '', 'Busca simple en el conjunt de camps :0 : no,  1 : autoritzada,  2 : autoritzada i validada per defecte'),
(1112, 'acquisition', 'pdfliv_format_page', '', 'Alt x Ample de la pàgina en mm'),
(1113, 'acquisition', 'pdfliv_orient_page', '', 'Orientació de la pàgina: P=Retrat L=Apaïsat'),
(1114, 'acquisition', 'pdfliv_marges_page', '', 'Marges de la pàgina en mm : Marges de la pàgina en mm : Alt, Davall, Esquerre'),
(1115, 'acquisition', 'pdfliv_pos_raison', '', 'Posició Raó social: Distància amb relació a la vora esquerre de la pàgina, Distància amb relació a la part de dalt de la pàgina, Ample, Alt, Grandària de la font'),
(569,'pmb','latest_order','','Classificació dels últims registres? \n notice_id desc : per id de registre decreixent: ideal però pot ser problemàtic després d’una migració o una importació \n create_date desc: per la columna data de creació.'),
(1116,'acquisition','pdfliv_pos_adr_liv','','Posició Direcció d\'entrega: Distància amb relació a la vora esquerre de la pàgina, Distància amb relació a la part de dalt de la pàgina, Ample,  Alt, Grandària de la font'),
(1117,'acquisition','pdfliv_pos_adr_fou','','Posició elements del proveïdor: Distància amb relació a la vora esquerre de la pàgina, Distància amb relació a la part de dalt de la pàgina, Ample, Alt, Grandària de la font'),
(1118, 'acquisition', 'pdfliv_pos_num', '', 'Posició número Comanda/ Entrega: Distància amb relació a la vora esquerre de la pàgina, Distància amb relació a la part de dalt de la pàgina, Ample, Alt, Grandària de la font'),
(1119, 'acquisition', 'pdfliv_tab_liv', '', 'Llista d\'entregues: Alt línia, Grandària font'),
(1120, 'acquisition', 'pdfliv_pos_footer', '', 'Posició inferior de la pàgina: Distància amb relació a la part inferior de la pàgina,  Grandària font'),
(1121, 'pmb', 'default_operator', '', 'Operador per defecte. \n 0 : OR, \n 1 : AND.'),
(1122, 'mailretard', 'priorite_email_3', '', 'Fer el tercer nivell de reclamació per correu electrònic :\n 0 : No, carta \n 1 : Sí, per mail'),
(1123, 'opac', 'show_suggest', '', 'Proposar fer suggeriments en l\'OPAC.\n 0 : No.\n 1 : Sí, amb autenticació.\n 2 : Sí, sense autenticació.'),
(1124, 'acquisition', 'email_sugg', '', 'Informació per correu electrònic de l\'evolució dels suggeriments.\n 0 : No\n 1 : Sí'),
(1125, 'acquisition', 'pdfliv_text_size', '', 'Grandària de la font del text'),
(1126, 'acquisition', 'pdfliv_pos_date', '', 'Posició Data: Distància amb relació a la vora esquerre de la pàgina, Distància amb relació a l\'altura de la pàgina, Ample, Alt, Grandària de la font'),
(1127, 'acquisition', 'pdffac_text_size', '', 'Grandària de la font'),
(1128, 'acquisition', 'pdffac_format_page', '', 'Ample x Alt de la pàgina en mm'),
(1129, 'acquisition', 'pdffac_orient_page', '', 'Orientació de la pàgina: P=Retrat L=Apaïsat'),
(1130, 'acquisition', 'pdffac_marges_page', '', 'Marges de la pàgina en mm : Alt, Davall, Dreta, Esquerra'),
(1131, 'acquisition', 'pdffac_pos_raison', '', 'Posició Raó social: Distància amb relació al marge esquerre de la pàgina, Distància amb relació a l\'alçària de la pàgina, Ample, Alt, Grandària de la font'),
(1132, 'acquisition', 'pdffac_pos_date', '', 'Posició Data: Distància amb relació al marge esquerre de la pàgina, Distància amb relació a l\'alçària de la pàgina, Ample, Alt, Grandària de la font'),
(1133, 'acquisition', 'pdffac_pos_adr_fac', '', 'Posició Direcció de facturació: Distància amb relació al marge esquerre de la pàgina, Distància amb relació a l\'alçària de la pàgina, Ample, Alt, Grandària de la font'),
(1134, 'acquisition', 'pdffac_pos_adr_fou', '', 'Posició elements distribuïdor: Distància amb relació al marge esquerre de la pàgina, Distància amb relació a l\'alçària de la pàgina, Ample, Alt, Grandària de la font'),
(1135, 'acquisition', 'pdffac_pos_num', '', 'Posició número Comanda/Factura: Distància amb relació al marge esquerre de la pàgina, Distància amb relació a l\'alçària de la pàgina, Ample, Alt, Grandària de la font'),
(1136, 'acquisition', 'pdffac_tab_fac', '', 'Llista de facturació: Alt línia, Grandària font'),
(1137, 'acquisition', 'pdffac_pos_tot', '', 'Posició total de comanda: Distància amb relació al marge esquerre de la pàgina, Ample, Alt, Grandària de la font'),
(1138, 'acquisition', 'pdffac_pos_footer', '', 'Posició baix de la pàgina: Distància amb relació a la part inferior de la pàgina,  Grandària de la font'),
(1139, 'acquisition', 'pdfsug_text_size', '', 'Grandària de la font text'),
(1140, 'acquisition', 'pdfsug_format_page', '', 'Ample x Alt de la pàgina en mm'),
(1141, 'acquisition', 'pdfsug_orient_page', '', 'Orientació de la pàgina: P=Retrat L=Apaïsat'),
(1142, 'acquisition', 'pdfsug_marges_page', '', 'Marges de la pàgina en mm : Alt, Davall, Dreta, Esquerra'),
(1143, 'acquisition', 'pdfsug_pos_titre', '', 'Posició títol: Distància amb relació al marge esquerre de la pàgina, Distància amb relació a l\'alçària de la pàgina, Ample, Alt, Grandària de la font'),
(1144, 'acquisition', 'pdfsug_pos_date', '', 'Posició data: Distància amb relació al marge esquerre de la pàgina, Distància amb relació a l\'alçària de la pàgina, Ample, Alt, Grandària de la font'),
(1145, 'acquisition', 'pdfsug_tab_sug', '', 'Llista de suggeriments: Alt línia, Grandària font'),
(1146, 'acquisition', 'pdfsug_pos_footer', '', 'Posició inferior de la pàgina: Distància amb relació a la part inferior de la pàgina, Grandària de la font'),
(1147, 'acquisition', 'mel_rej_obj', '', 'Assumpte del correu electrònic de suggeriment no acceptada'),
(1149, 'acquisition', 'mel_con_obj', '', 'Assumpte del correu electrònic de confirmació suggeriment acceptada'),
(1150, 'acquisition', 'mel_con_cor', '', 'Cos del missatge de confirmació de suggeriment acceptada'),
(1151, 'acquisition', 'mel_aba_obj', '', 'Assumpte del correu electrònic de suggeriment no possible'),
(1152, 'acquisition', 'mel_aba_cor', '', 'Cos del missatge de suggeriment no possible'),
(1153, 'acquisition', 'mel_cde_obj', '', 'Assumpte del correu electrònic de suggeriment demanat'),
(1154, 'acquisition', 'mel_cde_cor', '', 'Cos del missatge de suggeriment demanat'),
(1155, 'acquisition', 'mel_rec_obj', '', 'Cos del missatge de correu electrònic de suggeriment en la biblioteca'),
(1156, 'acquisition', 'mel_rec_cor', '', 'Cos del missatge de correu d\'arribada de suggeriment'),
(1157, 'opac', 'allow_tags_search', '', 'Busca per etiquetes (paraules clau usuaris) \n 1 = sí \n 0 = no'),
(1158, 'opac', 'allow_add_tag', '', 'Permetre als usuaris afegir una etiqueta a un registre.\n 0 : no\n 1 : sí\n 2 : identificació obligatòria per a afegir'),
(1159, 'opac', 'avis_allow', '', 'Permetre consultar/afegir un comentari en els registres \n 0 : no \n 1 : sense estar identificat : consulta possible, sense afegir \n 2 : identificació obligatòria per a consultar i afegir'),
(1161, 'categories', 'categ_in_line', '', 'Mostrar categories en línia.\n 0 : No.\n 1 : Sí.'),
(1160, 'opac', 'avis_nb_max', '', 'Nombre màxim de comentaris conservats per registre. Els més vells son eliminats en favor de més recents quan s\'arribe a eixe número.'),
(1162, 'opac', 'categories_categ_in_line', '', 'Mostrar categories en línia.\r\n 0 : No.\r\n 1 : Sí.'),
(489, 'opac', 'expl_data', '', 'Columnes dels ejamplares dins de l\'orde donat, separades per comes: expl_cb,expl_cote,tdoc_libelle,location_libelle,section_libelle'),
(863, 'categories', 'term_search_n_per_page', '', 'Nombre de descriptors mostrats per pàgina en una busca per descriptors en les categories'),
(1101, 'acquisition', 'pdfdev_comment', '', 'Mostrar els comentaris: 0=no, 1=sí'),
(1167, 'pdflettreretard', '1before_list_group', '', 'Text que apareixerà abans de la llista de documents retardats en la carta de reclamació'),
(1168, 'pdflettreretard', '1after_list_group', '', 'Text que apareix després de la llista de documents retardats en la carta'),
(1169, 'pdflettreretard', '1fdp_group', '', 'Signatari de la carta.'),
(1170, 'pdflettreretard', '1madame_monsieur_group', '', 'Encapçalament de la carta'),
(380,'pmb','show_rtl','','Visualització possible de dreta a esquerra \r\n 0 No \r\n 1 Si'),
(381,'opac','avis_show_writer','','Mostrar el redactor de l\'avís: \n 0 : No \n 1 : Nom i Cognoms \n 2 : només loguet OPAC'),
(382,'pmb','form_editables','','Caselles de registres editables \r\n 0 No \r\n 1 Si'),
(383,'acquisition','sugg_to_cde','','Transferències de suggeriments de comanda.\n 0 : No.\n 1 : Si.'),
(384,'thesaurus','categories_categ_in_line','','Mostrar categories en línia \n 0 : No.\n 1 : Si.'),
(386,'pmb','label_construct_script','','Script de construcció d\'etiqueta de signatura'),
(387,'dsi','func_after_diff','','Script a executar després de la difusió d\'una bannette'),
(388,'opac','notice_groupe_fonction','','Que fitxer/funció incloure en la presentació dels resultats si tots els registres d\'una busca es troben entre els tipus mencionats \n exemple : a,b text;c,d música;k fotográfia inclourà (text.inc.php) i cridarà a la funció text()'),
(389,'opac','photo_mean_size_x','','Dimensió X de la fotografia format \'moyen\', si està buida, no redimensionar'),
(390,'opac','photo_mean_size_y','','Dimensió Y de la fotografia format \'moyen\', si està buida, no redimensionar'),
(391,'opac','photo_watermark','','Marca d\'aigua a afegir a les fotografies, si està buida, no afegir'),
(392,'opac','photo_show_form','','Afegir el formulari de comanda de fotografia? \n 0: No \n 1:Si'),
(393,'opac','photo_email_form','','Separar per espais si hi ha múltiples correus electrònics de destinataris de comandes de fotografia'),
(394,'opac','photo_watermark_transparency','','Transparència de la marca d\'aigua de 0 a 100 en %'),
(395,'opac','show_onglet_empr','','Mostrar la pestanya de compte de prestatari junt amb la resta de pestanyes de busca? \n 0: No \n 1: Si \n 2: mostrar la pestanya de prestatari quan l\'usuari esta autenticat (i en este cas faça clic sobre la pestanya que porta a empr.php)'),
(396,'pmb','url_base','','URL de la base de gestió: típicament posa la url http://miservidor/pmb/ no s\'oblide de la / final'),
(397,'opac','show_empr','','Afegir el prestatari actual dins de la llista dels exemplars?\n 0 : No\n 1 : per als abonats\n 2 : per a tot el món'),
(398,'opac','show_login_form_next','','Després de la connexió del prestatari que mòdul es dirigirà? \n Buit= Compte del prestatari \n index.php = Menú d\'inici'),
(399,'opac','allow_term_troncat_search','','Truncat automàtic a la dreta \n 1 = Si \n 0 = No'),
(400,'opac','show_results_first_page','','Mostrar els resultats en la primera pàgina en una busca per tots els camps \r\n 0=No \r\n 1=Si'),
(401,'opac','nb_results_first_page','','Nombre de registres a mostrar en una busca pel criteri Tots els camps'),
(402,'opac','show_infobulles_categ','','Mostrar tooltips en les etiquetes de les categories. \n 0=No \n 1=Si'),
(403,'acquisition','sugg_display','','Nom de la funció personalitzada dels suggeriments de visualització'),
(404,'acquisition','sugg_categ','','Assignació de suggeriments a una categoria de suggeriments.\n 0 : No\n 1 : Si'),
(405,'acquisition','sugg_categ_default','','Identificació de la categoria de suggeriment per defecte'),
(406,'opac','sugg_categ','','Assignació de suggeriments a una categoria de suggeriments.\n 0 : No\n 1 : Si.'),
(407,'opac','sugg_categ_default','','Identificació de la categoria de suggeriments per defecte.'),
(408,'acquisition','pdfsug_print','','Que script utilitzar per a personalitzar la impressió de les llistes de suggeriments?'),
(409,'acquisition','pdfdev_print','','Que script utilitzar per a personalitzar la impressió de pressupostos?'),
(410,'acquisition','pdfcde_print','','Que script utilitzar per a personalitzar la impressió de comandes?'),
(411,'acquisition','pdfliv_print','','Que script utilitzar per a personalitzar la impressió dels albarans d\'entrega?'),
(412,'acquisition','pdffac_print','','Que script utilitzar per a personalitzar la impressió de factures?'),
(413,'pmb','notice_reduit_format','','Format de visualització dels resums de registres:\n 0 = títol+autor principal\n 1 = títol+autor principal+data d\'edició \n 2 = títol+autor principal+data d\'edició+ISBN\n 3 = només títol\n P 1,2,3 = títol+autor+camps personalitzats id 1 2 3\n E 1,2,3 = títol+autor+editor+camps personalitzats id 1 2 3\n T = títulot1+títulot4\n 4 = títol+títol paral·lel+autor principal\n H 1 = id d\'una plantilla de registre'),
(414,'pmb','resa_planning','','Utilitzar un pla de reserva? \n 0: No \n 1: Si'),
(415,'pmb','antivol','','Control remot del Sistema magnètic antirobatòria ? \n 1 Si \n 0 No'),
(416,'acquisition','custom_calc_numero','','Funció personalitzada de numeració de les accions de compra.'),
(417,'pmb','numero_exemplaire_auto','','Autoritzar la numeració automàtica de l\'exemplar? \n 0 : No\n 1 : Si, per a monografies i butlletins \n 2 : Si, només per a monografies\n 3 : Si, només per a butlletins'),
(418,'pmb','numero_exemplaire_auto_script','','Nom del fitxer del scrip php per a la generació automàtica dels codis dels exemplars'),
(419,'empr','lecteur_controle_doublons','','Control sobre la duplicitat de lectors:\r\n0 : sense control de duplicitat en l\'entrada de la fitxa del lector. \r\n1,empr_nom,empr_prenom,... : busca de duplicats en els camps \'empr\', \r\n2,empr_nom,empr_prenom,... : busca de duplicats en els camps \'empr\', i camps personalizables.\r\n3,empr_nom, empr_prenom ,... : ídem, en addició al test en el grup.'),
(420,'pmb','pret_nombre_prolongation','','Nombre de prolongacions autoritzades'),
(421,'pmb','pret_restriction_prolongation','','0 : sense restricció\r\n1 : prolongació limitada al paràmetre pret_nom_prolongation \r\n2 : prolongació gestionat per quotes'),
(422,'opac','pret_prolongation','','0 : sense prolongació\r\n1 : prolongació autoritzada'),
(423,'mailretard','1after_list_group','','Text que apareix després de la llista d\'obres amb retard dins del correu electrònic'),
(424,'mailretard','1before_list_group','','Text que apareix abans de la llista d\'obres amb retard en el correu de recordatori de retard'),
(425,'mailretard','1fdp_group','','Firmant del correu de recordatori de retard'),
(426,'mailretard','1madame_monsieur_group','','Encapçalament del correu'),
(427,'mailretard','1objet_group','','Objecte del correu electrònic de recordatori de retard'),
(428,'pmb','first_week_day_format','','Format de la setmana: \n 0, la setmana comença en dilluns \n 1 la setmana comença en diumenge'),
(429,'opac','export_allow_expl','','Exportar els exemplars junt amb els registres : \n 0 : No \n 1 : Si'),
(430,'opac','nb_max_tri','','Nombre màxim de registres per als que la selecció està autoritzada.'),
(431,'pmb','nb_max_tri','','Nombre màxim de registres per als que la selecció està autoritzada.'),
(432,'opac','pret_duree_prolongation','','Nombre de dies de prolongació autoritzada'),
(433,'opac','surlignage','','Ressaltar dels termes buscats:\r\n0 : sense ressaltat\r\n1 : ressaltat obligatori\r\n2 : ressaltat activat\r\n3 : ressaltat desactivat'),
(434,'opac','nb_max_criteres_tri','','Nombre màxim de criteris de selecció a mostrar'),
(435,'empr','show_caddie','','Mostrar el mòdul de cistelles de lectors: \r\n 0: No \r\n 1: Si'),
(436,'empr','pics_url','','La URL de les fotografies dels prestataris a la ruta prevista,  !!num_carte!! serà reemplaçada pel número de carnet del prestatari.\n exemple: http://wwww.miweb/fotos/lectores/!!num_carte!!.jpg'),
(437,'empr','pics_max_size','','Grandària màxima de les fotografies dels prestataris, en amplària o altura'),
(438,'thesaurus','classement_mode_pmb','','Nivell d\'utilització dels plans de classificació d\'indexació.\n 0 : Un només pla de classificació. \n 1 : Triar un pla de classificació possible..'),
(439,'thesaurus','classement_defaut','','Identificació del pla de classificació per defecte'),
(440,'empr','electronic_loan_ticket','','Enviar un tiquet de préstec electrònic? \n 0: No, \n 1: Si'),
(441,'empr','electronic_loan_ticket_obj','','Objecte del correu electrònic del tiquet del preśtamo electrònic'),
(442,'empr','electronic_loan_ticket_msg','','Cos del correu electrònic del tiquet de préstec electrònic'),
(443,'pmb','droits_explr_localises','','Els drets de gestió dels exemplars estan localitzats? \n 0: No \n 1: Si'),
(444,'empr','fiche_depliee','','La fitxa del prestatari serà automàticament: \n 0 : plegada \n 1 : doblegada'),
(445,'empr','statut_adhes_depassee','','Id de l\'estat per al qual els prestataris la data d\'adhesió este dels quals sobrepsada no apareguen en la zona d\'alerta'),
(446,'opac','authorized_styles','','Estils de l\'OPAC autoritzats, separats per comes'),
(447,'empr','relance_adhesion','','Els recordatoris d\'adhesió són enviats: \n 0 : exclusivament per carta \n 1 : correu electrònic, carta per defecte'),
(448,'empr','show_rows','','Columnes mostrades en la llista de lectors, afegir columnes separades per comes. Les columnes disponibles per a mostrar en la llista de lectors són: \n n: cognoms+nom \n a: direcció \n b: codi de barres \n c: categories \n g: grups \n l: localització \n s: estat \n cp: codi postal \n v: municipi \n i: data de naixement \n ab: tipus d\'abonament \n #n : id dels camps personalitzats\n 1: icona cistella'),
(449,'empr','sort_rows','','Columnes que estaran disponibles per a la selecció de prestataris. Les columnes possibles són : \n n: cognoms+nom \n b: codi de barres \n c: categories \n g: grups \n l: localització \n s: estat \n cp: codi postal \n v: municipi \n i: data de naixement \n ab: tipus d\'abonament \n #n : id dels camps personalitzats'),
(450,'empr','filter_rows','','Columnes disponibles per a filtrar la llista de prestataris : \n v: municipi\n l: localització\n c: categoria\n s: estat\n g: grup\n i: data de naixement\n cp: codi postal\n cs : codi estadístic\n ab : tipus d\'abonament\n #n : id dels camps personalitzat'),
(451,'empr','header_format','','Camps personalitzats que seran mostrats en la capçalera de la fitxa del prestatari. Afegir els id separats per comes'),
(452,'empr','archivage_prets','','Arxivar els préstecs dels prestataris? \n 0: No \n 1: Si\nATENCIÓ per a França:le recordem l\'obligació de declarar el seu tractament a la CNIL (www.cnil.fr) si activa esta funcionalitat'),
(453,'empr','archivage_prets_purge','','Nombre màxim de dies a conservar els arxius nominatius de préstecs: \n0: il·limitat \nN: NÚM. de dies'),
(454,'opac','autres_lectures','','Mostrar els préstecs d\'altres lectors del document actual? \n 0: No \n 1: Si'),
(455,'opac','autres_lectures_tri','','Seleccionar altres lectures proposades : \n rand(): aleatori \n tit: per Títol'),
(456,'opac','autres_lectures_nb_mini_emprunts','','Nombre mínim de préstecs per a ser comptabilitzats\n 1: un només préstec serà suficient per a proposar el registre com a lectura associada \n N: N mínim de préstecs necessaris'),
(457,'opac','autres_lectures_nb_maxi','','Nombre màxim de lectures associades propostes'),
(458,'opac','autres_lectures_nb_jours_maxi','','Retard en dies a partir del qual els preśtamos no serà comptabilitzats, 0 per a il·limitat'),
(459,'opac','empr_hist_nb_max','','Nombre màxim de préstecs precedents a mostrar, 0 per a il·limitat'),
(460,'opac','empr_hist_nb_jour_max','','Retard en dies a partir del qual els préstecs precedents no seran mostrats, 0 per a il·limitat'),
(461,'opac','allow_tags_search_min_occ','','Nombre mínim d\'ocurrències d\'un tag per a ser mostrat, 1 per a tots'),
(462,'pmb','etat_collections_localise','','L\'estat de les col·leccions està localitzat? \n 0 : No \n 1 : Si'),
(463,'pmb','clean_nb_elements','','Nombre d\'elements a processar per passada de neteja bàsica'),
(464,'pmb','rfid_activate','','Registres de préstecs per platina RFID? \n 0: No \n 1: Si'),
(465,'opac','bull_results_per_page','','Número de butlletins mostrats per pàgina en la visualització de d\'un període'),
(466,'pmb','rfid_serveur_url','','URL del servidor del webservice RFID'),
(467,'opac','authorized_information_pages','','Pàgines \"incluibles\" dins de la pàgina de l\'OPAC ./index.php?lvl=information&askedpage= : \n Introduir els noms dels fitxers separats per comes'),
(468,'pmb','notice_controle_doublons','','Control de duplicats en l\'entrada de registres \n 0: Sense control de duplicats, \n 1,tit1,tit2, ... : Buscar per méthode _exacte_ de duplicats dins dels camposs, definit en el fitxer notice.xml  \n 2,tit1,tit2, ... : Buscar per _similitude_'),
(469,'opac','title_ponderation','','Augment de la ponderació de les paraules del títol \n   introduir 0 (zero) per a evitar l\'augment \n ATENCIÓ utilitzar el punt decimal'),
(470,'pmb','title_ponderation','','Augment de la ponderació de les paraules del títol \n   introduir 0 (zero) per a evitar l\'augment \n ATENCIÓ utilitzar el punt decimal'),
(471,'pmb','param_etiq_codes_barres','','Configuració del backup dels paràmetres d\'edició de les etiquetes de codis de barra'),
(472,'pmb','javascript_office_editor','','Codi HTML a inserir per a reemplaçar les textarea per un editor Office javascript'),
(473,'opac','biblio_post_adress','','Bloc d\'informació després del bloc direcció, dins del full d\'estil, veure id post_adress'),
(474,'opac','allow_external_search','','Autoritzar o no la busca per connectors externs dins de l\'OPAC \r\n 0 : No \r\n 1 : Si'),
(475,'pmb','nb_noti_calc_empty_words','','Una paraula es considerarà com a buida si apareix en un nombre mínim de registres. Introduïsca el percentatge en relació al nombre total de registres..'),
(476,'opac','fonction_affichage_liste_bull','','Funció de visualització de les llistes de butlletins'),
(517,'transferts','statut_validation','','id de l\'estat en què es col·locaran els documents les transferències dels quals han sigut validades'),
(516,'pmb','transferts_actif','','Activar el sistema de transferència d\'exemplars entre llocs \n 0: No \n 1: Si'),
(479,'dsi','bannette_notices_order','','Orde dels registres en la bannette: \n index_sèrie, tnvol, index_sew : per títol \n create_date dte : per data d\'entrada decreixent \n rand() : aleatori'),
(480,'opac','websubscribe_show','','Mostrar la possibilitat d\'inscripció en línia? \n 0: No \n 1: Si'),
(481,'opac','websubscribe_empr_status','','Id de l\'estat dels inscrits separats per comes: a l\'espera de validació, validat'),
(482,'opac','websubscribe_empr_categ','','Id de la categoria dels inscrits per la web amb la inscripció no completada'),
(483,'opac','websubscribe_empr_stat','','Id del codi estadístic dels inscrits per la web amb la inscripció no completada'),
(484,'opac','websubscribe_valid_limit','','Duració màxima de les inscripció en espera de validació'),
(485,'pmb','mail_html_format','','Format d\'enviament de correus electrònics des de l\'OPAC: \n 0: Text brut\n 1: HTML \n 2: HTML, imatges incloses\nAtenció, esta funció només funciona en mode d\'enviament smtp!'),
(486,'opac','mail_html_format','','Format d\'enviament de correus electrònics des de l\'OPAC: \n 0: Text brut\n 1: HTML \n 2: HTML, imatges incloses\nAtenció, esta funció només funciona en mode d\'enviament smtp!'),
(487,'opac','websubscribe_empr_location','','Id de la localització dels inscrits per la web amb la inscripció no completada'),
(488,'opac','allow_bannette_export','','Possibilitar als lectors a rebre les notificacions de les seues bannettes privades adjuntes al correu electrònic?\n 0: No \n 1: Si'),
(490,'opac','expl_order','','Columnes dels exemplars, en l\'orde indicat, separades per comes: expl_cb,expl_cote,tdoc_libelle,location_libelle,section_libelle'),
(491,'opac','curl_available','','Esta la biblioteca cURL disponible per a les consultes RSS particulars? \n 0: No \n 1: Si'),
(492,'pmb','curl_available','','Esta la biblioteca cURL disponible per a les consultes RSS particulars? \n 0: No \n 1: Si'),
(493,'opac','thesaurus_defaut','','Identificació del tesaurus per defecte'),
(494,'opac','recherches_pliables','','Les caselles de verificació de la busca simple marcades? \r\n 0: No \r\n 1: Si marcades per defecte \r\n 2: Si desmarcades per defecte \r\n 3: Invisibles'),
(495,'pmb','rfid_ip_port','','Associació d\'IP de l\'estació de prestem i Número de lloc utilitzat pel servidor RFID. Ex: 192.168.0.10,SerialPort=10; IpPosteClient,SerialPort=NumPortPlatine; separat per punt i coma per a designar totes les estacions'),
(496,'pmb','pret_timeout_temp','','Temps en minuts després del qual un préstec temporal és esborrat'),
(497,'opac','permalink','','Veure l\'id del registre amb un enllaç permanent? \n 0: No \n 1: Si'),
(498,'pdflettreretard','3after_recouvrement','','Text que apareix després dels virons d\'obres en recuperació si no hi ha altres altres obres de nivell 1 i 2'),
(499,'pdflettreretard','impression_tri','','Seleccionar per a la impressió de les cartes de recuperació? Els camps són els de la taula empr separats per comes. Exemple: empr_nom, empr_prenom'),
(500,'pmb','pret_date_retour_adhesion_depassee','','Pot la data de retorn superar la data de fi de la inscripció? \n 0: No: la data de retorn serà calculada per a no sobrepassar la data de fi de la inscripció. \n 1: Si, la data de retorn serà independent de la data de fi de la inscripció.'),
(501,'opac','extended_search_auto','','En busques multicriteri, seleccionant un camp s\'afig automàticament sense necessitat de fer clic sobre el botó Afegir?\n 0: No \n 1: Si'),
(502,'pmb','extended_search_auto','','En busques multicriteri, seleccionant un camp s\'afig automàticament sense necessitat de fer clic sobre el botó Afegir?\n 0: No \n 1: Si'),
(503,'thesaurus','categories_affichage_ordre','','Configuració de l\'orde de visualització de les categories d\'un registre. \n Per orde alfabètic: 0(per defecte)\nPer orde d\'entrada: 1'),
(504,'opac','categories_affichage_ordre','','Configuració de l\'orde de visualització dels categories d\'un registre. \n Per orde alfabètic: 0(por defecte)\n Per orde d\'entrada: 1'),
(505,'pmb','rfid_driver','','Driver RFID : nom del directori que conté els javascripts adequats per al maquinari'),
(506,'pmb','allow_external_search','','Autoritzar o no la busca per connectors externs (també s\'oculta el menú d\'Administració-Connectors) \r\n 0 : No \r\n 1 : Si'),
(507,'pmb','scan_pmbws_client_url','','URL de l\'interfície d\'escaneig (client de webservice)'),
(508,'pmb','scan_pmbws_url','','URL del webservice de maneig de l\'escàner'),
(509,'opac','biblio_main_header','','Text que pot aparéixer dins del bloc principal, per damunt de la resta, necessari per a certes actualitzacions en pàgines especials.'),
(510,'opac','sugg_localises','','Activar el suggeriment de localització dels lectors? \n 0: Sense localització possible.\n 1: Localització per a triar un lector \n 2: Localització restringida a la localització del lector.'),
(511,'acquisition','sugg_localises','','Activar el suggeriment de localització? \n 0: Sense localització possible. \n 1: Localització activada.'),
(512,'opac','categories_nav_max_display','','Limitar la visualització de categories en la navegació dins de les subcategories. 0: Sense limitació. >0: Nombre màxim de categories a mostrar'),
(513,'pmb','pret_aff_limitation','','Activar la limitació de visualització de la llista de préstecs en la fitxa del lector? \n 0: Inactiu. \n 1: Limitació activada'),
(514,'pmb','pret_aff_nombre','','Nombre de préstecs a mostrar si el paràmetre pret_aff_limitation esta actiu. \n 0: Veure tot. \n ## Nombre de préstecs a mostrar en la primera pàgina'),
(515,'pmb','printer_ticket_url','','Permet la utilització d\'una impressora de tiquet, connectada en local a l\'estació de préstec client. Buit : sense impressora. Url (http://localhost/printer/bixolon_srp350.php ) :impressora activa.'),
(518,'transferts','statut_transferts','','Id de l\'estat en què es col·locaran els documents en trànsit'),
(519,'transferts','validation_actif','','Activar la validació de transferències\n 0: No \n 1: Si'),
(520,'transferts','nb_jours_pret_defaut','','Nombre de dies de préstec per defecte'),
(521,'transferts','nb_jours_alerte','','Nombre de dies abans de la finalització del préstec per a mostrar l\'alerta'),
(522,'transferts','transfert_transfere_actif','','Autoritzar la transferència de l\'exemplar ja transferit'),
(523,'transferts','tableau_nb_lignes','','Nombre de transferències a mostrar dins de la taula'),
(524,'transferts','envoi_lot','','Processament per lots possible en enviament'),
(525,'transferts','reception_lot','','Processament per lots possible en recepció'),
(526,'transferts','retour_lot','','Processament per lots possible en devolució'),
(527,'transferts','retour_origine','','Obligar a la devolució de l\'exemplar al seu lloc d\'origen\n 0: No \n 1: Si'),
(528,'transferts','retour_origine_force','','Permetre l\'obligació de tornar l\'exemplar\n 0: No \n 1: Si'),
(529,'transferts','retour_action_defaut','','Acció per defecte quan es torne un préstec\n 0: canviar localització \n 1: generar transferència'),
(530,'transferts','retour_action_autorise_autre','','Autoritza una altra acció en la devolució de l\'exemplar\n 0: No\n 1: Si'),
(531,'transferts','retour_change_localisation','','Backup de la localització al canviar\n 0: No \n 1: Si'),
(532,'transferts','retour_etat_transfert','','Estat de la transferència en la generació automàtica\n 0: crear \n 1: enviar'),
(533,'transferts','retour_motif_transfert','','Motiu de la transferència en la generació automàtica'),
(534,'transferts','choix_lieu_opac','','0 per a cap elecció ni necessitat de localització o usuaris registrats, 1 per a qualsevol elecció d\'ubicació, 2 per a una ubicació fixa especificada, 3 per a la ubicació de l\'exemplar'),
(535,'transferts','site_fixe','','id del lloc per a l\'eliminació de llibres,, si choix_lieu_opac=2'),
(536,'transferts','resa_motif_transfert','','Motiu de la transferència en la generació automàtica per a una reserva'),
(537,'transferts','resa_etat_transfert','','Estat de la transferència en la generació automàtica\n 0: crear \n 1: enviar'),
(538,'pmb','recherche_ajax_mode','','Visualització accelerada dels resultats de la busca: \"xicoteta\" unicamente, carregar després de fer clic en \"+\". \n 0: Inactiu \n 1: Actiu'),
(539,'pmb','expl_title_display_format','','Format de visualització del títol de l\'exemplar en les busques multicriteris d\'exemplars. Les etiquetes dels camps corresponen als camps de la taula exemplaires, o als id dels camps personalitzats. Separats per comes. Els camps que disposen d\'una etiqueta seran reemplaçats per l\'etiqueta corresponent. Exemple: expl_location,expl_section,expl_cote,expl_cb'),
(540,'opac','empr_code_info','','Codi HTML mostrat damunt dels botons de la fitxa del prestatari.'),
(541,'opac','term_search_height_bottom','','Altura de la part superior del marc de busca per paraules (en px)'),
(542,'pmb','rfid_library_code','','Codi numèric d\'identificació de la biblioteca propietària dels exemplars (10 caràcters)'),
(543,'opac','show_infopages_id','','Id de les infopages a mostrar en la busca simple, separats per comes.'),
(544,'thesaurus','auto_postage_montant','','Activar la busca de registres de categories pare? \n  0 No, \n 1 Si'),
(545,'thesaurus','auto_postage_descendant','','Activar la busca de registres de categories filles? \n 0 No, \n 1 Si'),
(546,'thesaurus','auto_postage_nb_descendant','','Nombre de nivells de busca de registres en les categories filles. \n *: il·limitat, \n n: nombre de nivells'),
(547,'thesaurus','auto_postage_nb_montant','','Nombre de nivells de busca de registres en les categories pare. \n *: il·limitat, \n n: nombre de nivells'),
(548,'thesaurus','auto_postage_etendre_recherche','','Oferir la possibilitat d\'ampliar la busca en les categories pare i filles. \n 0: No, \n 1: Exclusivament en les categories filles, \n 2: Ampliar en les categories pares i filles, \n 3: Exclusivament en les categories pare..'),
(549,'opac','auto_postage_montant','','Activar la busca de registres en categories pare. \n 0 No, \n 1 Si'),
(550,'opac','auto_postage_descendant','','Activar la busca de registres en categories filla. \n 0 No, \n 1 Si'),
(551,'opac','auto_postage_nb_descendant','','Nombre de nivells de busca de registres en les categories filles. \n *: il·limitat, \n n: nombre de nivells'),
(552,'opac','auto_postage_nb_montant','','Nombre de nivells de busca de registres en les categories pare. \n *: il·limitat, \n n: nombre de nivells'),
(553,'opac','auto_postage_etendre_recherche','','Oferir la possibilitat d\'ampliar la busca en les categories pare i filles. \n 0: No, \n 1: Exclusivament en les categories filles, \n 2: Ampliar en les categories pares i filles, \n 3: Exclusivament en les categories pare.'),
(554,'gestion_acces','active','','Mòdul de gestió de drets d\'accés activat?\n 0 : No.\n 1 : Si'),
(555,'gestion_acces','user_notice','','Gestionar els drets d\'accés dels usuaris als registres \n 0 : No.\n 1 : Si.'),
(556,'pmb','abt_end_delay','','Termini d\'alerta per a l\'advertència dels abonaments que estan arribant a la seua finalització (en dies)'),
(557,'pmb','set_time_limit','','max_execution_timede certes operacions (exportació d\'accions personalitzades, enviaments DSI, exportacions, etc.) \n Atenció,  pot no tindre efecte si l\'allotjament no ho permet (free.fr per exemple)\n 0 : il·limitat (desaconsellat) \n ###: ### segons'),
(558,'pmb','expl_list_display_comments','','Mostrar els comentaris dels exemplars en la llista d\'exemplars : \r\n 0 : No \r\n 1 : comentari de bloqueig \r\n 2 : comentari sense bloqueig \r\n 3 : ambdós comentaris'),
(559,'pmb','confirm_delete_from_caddie','','Acció a realitzar en l\'eliminació d\'un registre situat en un panell. \r\n0 : Prohibir \r\n1 : Eliminar sense confirmació \r\n2 : Sol·licitar la confirmació d\'eliminació'),
(560,'opac','flux_rss_notices_order','','Orde de visualització de les ressenyes en els fluxos d\'eixida de l\'OPAC \n   index_serie, tnvol, index_sew : seleccionar per títol de sèrie i títol \n rand()  : aleatori \n notice_id desc per orde decreixent de creació del registre'),
(561,'opac','modules_search_titre_uniforme','','Busca simple dins de títols uniformes :\n 0 : prohibida\n 1 : autoritzada\n 2 : autoritzada i validada per defecte\n -1 : prohibida també a la recerca multicriteri'),
(562,'opac','congres_affichage_mode','','Mode visualització congrés: \n 0 : Quant als autors, \n 1 : afegir un navegador de congrés'),
(563,'opac','show_suggest_notice','','Mostrar l\'enllaç a la proposta de suggeriment en un registre existent.\n 0 : No.\n 1 : Si, amb autenticació.\n 2 : Si, sense autenticació.'),
(564,'pmb','explnum_statut','','Utilitzar un estat per als documents digitals \n 0: No \n 1: Si'),
(565,'opac','show_empty_items_block','','Mostrar el bloc exemplars inclús si no hi ha exemplars per al registre? : \n 0 : No, \n 1 : Si'),
(566,'pmb','printer_ticket_script','','Script per a personalitzar la impressió del tiquet de préstec. El directori del script es fixa a partir de l\'arrel de PMB.\nSi esta buit PMB utilitzar ./circ/ticket-pret.inc.php'),
(567,'opac','curl_proxy','','Configuració de proxy de cURL, si no hi ha proxy. En cas contrari \nhost,port,user,password;2nd_host, etc'),
(568,'pmb','curl_proxy','','Configuració de proxy de cURL, si no hi ha proxy. En cas contrari \nhost,port,user,password;2nd_host, etc'),
(570,'opac','password_forgotten_show','','Mostrar l\'enllaç \"Va oblidar la seua contrasenya?\" \n 0: No \n 1: Si'),
(571,'opac','aff_expl_localises','','Activar la visualització dels exemplars localitzats per pestanyes.\n 0 : Desactivat \n 1: En la primera pestanya mostrar els exemplars de la localització del lector, en la segona mostrar tots els exemplars'),
(572,'gestion_acces','empr_notice','','Gestió dels drets d\'accés dels prestataris a les ressenyes \n 0 : No.\n 1 : Si.'),
(573,'opac','show_infopages_id_top','','Id de les infopages a mostrar EN la busca simple, separats per coma.'),
(574,'opac','show_search_title','','Mostrar el títol del bloc de busca : \n 0 : No, \n 1 : Si'),
(575,'opac','allow_personal_search','','Activar la visualització de la pestanya de busques personalitzades \n 0 : No.\n 1 : Si..'),
(576,'ldap','opac_only','','No utilitzar l\'autenticació LDAP en gestió: \n 0: No \n 1 : Si, només en OPAC'),
(577,'pmb','multi_search_operator','','Tipus d\'operador de busca per a les llistes amb diversos valors:: \n or : per a O \n and : per a I'),
(578,'opac','multi_search_operator','','Tipus d\'operador de busca per a les llistes amb diversos valors:: \n or : per a O \n and : per a I'),
(579,'transferts','pret_statut_transfert','','Autoritzar el préstec quan l\'exemplar es transferix'),
(580,'exportparam','generer_liens','','Generar els vincles entre ressenyes per a l\'exportació'),
(581,'exportparam','export_mere','','Exportar les ressenyes mare relacionades'),
(582,'exportparam','export_fille','','Exportar les ressenyes filles relacionades'),
(583,'exportparam','export_bull_link','','Exportar els vincles als butlletins per a les ressenyes d\'article'),
(584,'exportparam','export_perio_link','','Exportar els vincles als periòdics per a les ressenyes d\'article'),
(585,'exportparam','export_art_link','','Exportar els vincles als articles per a les ressenyes de periòdics'),
(586,'exportparam','export_bulletinage','','Generar el boletinage per a les ressenyes de periòdics'),
(587,'exportparam','export_notice_perio_link','','Exportar les ressenyes relacionades amb el periòdic'),
(588,'exportparam','export_notice_art_link','','Exportar les ressenyes relacionades ambe l\'article'),
(589,'exportparam','export_notice_mere_link','','Exportar les ressenyes mares relacionades'),
(590,'exportparam','export_notice_fille_link','','Exportar les ressenyes filles relacionades'),
(591,'opac','exp_generer_liens','','Generar els vincles entre les ressenyes per a l\'exportació'),
(592,'opac','exp_export_mere','','Exportar les ressenyes mare relacionades'),
(593,'opac','exp_export_fille','','Exportar les ressenyes filles relacionades'),
(594,'opac','exp_export_bull_link','','Exportar els vincles als butlletins per a les ressenyes d\'article'),
(595,'opac','exp_export_perio_link','','Exportar els vincles als periòdics per a les ressenyes d\'article'),
(596,'opac','exp_export_art_link','','Exportar els vincles als articles per a les ressenyes de periòdics'),
(597,'opac','exp_export_bulletinage','','Generar el boletinage per a les ressenyes de periòdics'),
(598,'opac','exp_export_notice_perio_link','','Exportar les ressenyes relacionades amb el periòdic'),
(599,'opac','exp_export_notice_art_link','','Exportar les ressenyes relacionades ambe l\'article'),
(600,'opac','exp_export_notice_mere_link','','Exportar les ressenyes mare relacionades'),
(601,'opac','exp_export_notice_fille_link','','Exportar les resseyes filles relacionades'),
(602,'pmb','perio_vidage_log','','Freqüència de transferència de dades entre la taula temporal de logs a la taula d\'emmagatzematge (en dies)'),
(603,'pmb','perio_vidage_stat','','Freqüència de buidatge de la taula d\'emmagatzematge (mode,día) : \r\n0 : no fer res\r\n1,x : buidar tot els x dies\r\n2,x : buidar tot a més de x dies'),
(604,'pmb','logs_activate','','Activar les estadístiques per a l\'OPAC: \n 0 : No activat \n 1 : Activat'),
(605,'opac','shared_lists','','Activar les llistes de lectura compartida \n 0 : No activat \n 1 : Activat'),
(606,'pmb','indexation_docnum','','Activar la indexació de documents digitals \n 0 : No activat \n 1 : Activat'),
(607,'pmb','indexation_docnum_allfields','','Activar per defecte la busca dins de documents digitals per a les busques \"Tots els camps\" \n 0 : No activat \n 1 : Activat'),
(608,'opac','indexation_docnum_allfields','','Activar per defecte la busca dins de documents digitals per a les busques \"Tots els camps\" \n 0 : No activat \n 1 : Activat'),
(609,'opac','modules_search_docnum','','Busca simple dins de documents digitals \n 0 : prohibit \n 1 : Autoritzat \n 2 : Autoritzat i validat per defecte'),
(610,'pmb','location_reservation','','Utilitzar la gestió de la reserva localitzada?\n 0: No\n 1: Si'),
(611,'pmb','extension_tab','','Mostrar la pestanya Extensió? \n 0 : No \n 1 : Si'),
(612,'pmb','indexation_docnum_default','','Indexar per defecte el document digital? \n 0 : No \n 1 : Si'),
(613,'opac','shared_lists_readonly','','Llistes de lectura compartida en només lectura \n 0 : No activat \n 1 : Activat'),
(614,'opac','connexion_phrase','','Frase per a la codificació de la connexió automàtica des d\'un correu electrònic'),
(615,'pmb','afficher_numero_lecteur_lettres','','Mostrar el número i correu electrònic del lector davall la seua direcció en les diferents cartes'),
(616,'pmb','lettres_bloc_adresse_position_absolue','','Col·loque el bloc direcció d\'acord amb les coordenades absolutes.\nActivat x i\nActivat : activar esta funció (valors: 0/1)\nx : Posició horitzontal\ni : Posició vertical'),
(617,'pmb','external_service_search_cache','','Duració de les busques en el caixet, per als servicis externs, en segons.'),
(618,'pmb','external_service_session_duration','','Duració de les sessions, per als servicis externs, en segons'),
(619,'opac','allow_multiple_sugg','','Autoritzar els suggeriments múltiples.\r\n0: No\r\n1: Si'),
(620,'dsi','bannette_notices_template','','Id de la plantilla de ressenya utilitzada per defecte en la difusió de bannettes. Si esta va buidar o a 0, serà utilitzada la plantilla clàssica.'),
(621,'demandes','active','','Mòdul de peticions actiu.\n 0 : No.\n 1 : Si.'),
(622,'demandes','statut_notice','','Id d\'estat de ressenya per a la ressenya petició.'),
(623,'opac','demandes_active','','Activar les peticions per a l\'OPAC.\n 0 : No.\n 1 : Si'),
(624,'pmb','use_uniform_title','','Utilitzar els títols uniformes? \r\n 0 : No.\r\n 1 : Si.'),
(625,'opac','print_expl_default','','En la impressió de les cistelles, imprimir els exemplars marcats per defecte \n 0 : No \n 1 : Si'),
(626,'demandes','include_note','','Incloure automàticament les notes en l\'informe documental.'),
(627,'opac','ie_reload_on_resize','','Recarregar la pàgina si l\'usuari redimensiona el seu navegador (pb de CSS en IE) ? \n 0: No \n 1: Si'),
(628,'pmb','expl_show_dates','','Mostrar les dates d\'exemplars? \n 0 : Cap data.\n 1 : Data de creació i modificació.\n 2 : Data de depòsit i retorn (BDP).\n 3 : Data de creació, modificació, depòsit i retorn.'),
(629,'gestion_acces','user_notice_def','','Valor per defecte en modificació de ressenya pels drets d\'accés usuaris-ressenyes \n 0 : Recalcular.\n 1 : Triar.'),
(630,'gestion_acces','empr_notice_def','','Valor per defecte en modificació de ressenya pels drets d\'accés prestataris-ressenyes \n 0 : Recalcular.\n 1 : Triar.'),
(631,'opac','show_exemplaires_analysis','','Mostrar els exemplars del butlletí per a l\'article mostrat? \n 0: No \n 1: Si'),
(632,'pmb','show_notice_id','','Mostrar l\'identificador de la ressenya en la descripció? \n 0 : No.\n 1 : Si. \n 1,X : Si amb el prefix X'),
(633,'opac','section_notices_order','','Orde de visualització de les ressenyes en les seccions en l\'OPAC \n  index_serie, tnvol, index_sew : seleccionar per títol de sèrie i per títol'),
(634,'opac','show_onglet_help','','Mostrar la pestanya AJUDA junt amb les pestanyes de busca que mostra la infopage i amb un enllaç a la infopage en la barra de navegació \n 0 : No.\n ## : id de la infopage. \n'),
(635,'opac','navig_empr','','Mostrar la pestanya \"El seu compte\" en la barra de navegació de l\'OPAC? \n 0 : No \n 1 : Si'),
(637,'pmb','prefill_cote_ajax','','Script personalitzat de construcció de la signatura de l\'exemplar en ajax'),
(638,'pmb','hide_biblioinfo_letter','','Ocultar la informació de localització en la capçalera de les cartes (per a les biblioteques amb paper amb capçalera)'),
(639,'pmb','lettres_code_mail_position_absolue','','Situar el codi del lector i el correu electrònic d\'acord amb les coordenades absolutes.\n Activar x i \n Activat: activar esta funció (valors: 0/1) \n x : Posició horitzontal \n i : Posició vertical'),
(640,'opac','adhesion_expired_status','','Id de l\'estat per a restringir els drets dels prestataris l\'abonament dels quals a caducat. \n\rPMB fer un AND lògic amb els drets originals.'),
(641,'pmb','resa_retour_action_defaut','','Definir l\'acció per defecte a realitzar en la devolució si el document està reservat.\r\n0, Tractar més tard.\r\n1, Validar la reserva.'),
(642, 'pmb','notice_fille_format','','Mostrar les ressenyes filles \n 0: amb els seus detalls (ressenya desplada amb un més) \n 1: Només el títol'),
(643,'pmb','hide_retdoc_loc_error','','Gestió de la devolució del préstec d\'un document des d\'una altra localització:\n 0 : Tornar, sense missatge d\'error\n 1 : No tornar, amb missatge d\'error\n 2 : Tornar, amb missatge d\'error'),
(644,'pmb','selfservice_allow','','Activar la gestió del terminal de préstec?\n0 : No. \n1 : Si.'),
(645,'selfservice','loc_autre_todo','','Acció a realitzar si el document és d\'una altra localització'),
(646,'selfservice','loc_autre_todo_msg','','Missatge si el document està reservat en una altra localització'),
(647,'selfservice','resa_ici_todo','','Acció a realitzar si el document està reservat en la seua localització'),
(648,'selfservice','resa_ici_todo_msg','','Missatge si el document està reservat en la seua localització'),
(649,'selfservice','resa_loc_todo','','Acció a realitzar si el document està reservat en una altra localització'),
(650,'selfservice','resa_loc_todo_msg','','Missatge si el document està reservat en una altra localització'),
(651,'selfservice','retour_retard_msg','','Missatge si el document és tornat amb retard'),
(652,'selfservice','retour_blocage_msg','','Missatge si el document és tornat amb retard i bloqueig'),
(653,'selfservice','retour_amende_msg','','Missatge si el document és tornat amb retard i multa'),
(654,'selfservice','pret_carte_invalide_msg','','Missatge del terminal de préstec: La seua targeta no és vàlida!'),
(655,'selfservice','pret_pret_interdit_msg','','Missatge del terminal de préstec: No està autoritzat a demanar un préstec!'),
(656,'selfservice','pret_deja_prete_msg','','Missatge del terminal de préstec: Document ja prestat!'),
(657,'selfservice','pret_deja_reserve_msg','','Missatge del terminal de préstec: Vosté no pot demanar prestat este document'),
(658,'selfservice','pret_quota_bloc_msg','','Missatge del terminal de préstec: Vosté no pot demanar prestat este document'),
(659,'selfservice','pret_non_pretable_msg','','Missatge del terminal de préstec: Este document no pot ser prestat'),
(660,'selfservice','pret_expl_inconnu_msg','','Missatge del terminal de préstec: Document desconegut'),
(661,'selfservice','pret_prolonge_non_msg','','Missatge del terminal de préstec: El préstec no pot ser prorrogat'),
(675,'opac','visionneuse_params','','taula de correspondència mimetype=>clases'),
(676,'opac','allow_self_checkout','','Proposar fer préstec autónomo en l\'OPAC.\n 0 : No.\n 1 : Autoritza el préstec de document.\n 2 : Autoritza el retorn de document.\n 3 : Autoritzar el préstec i retorn de document.\n'),
(663,'opac','photo_filtre_mimetype','','Llista de mimetypes utilitzats per a mostrar els resultats en mode imatge separats per comes i entre signatures (exemple:\'application/pdf\',\'image/png\')'),
(664,'empr','sms_activation','','Activació de l\'enviament de sms. : enviament 1, enviament 2, enviament 3, enviament\n\n 0: Inactiu\n 1: Actiu'),
(665,'empr','sms_config','','Configuració de l\'enviament de sms. \nUtilizar:\n class_name=nom_de_la_classe;param_connection;\nExemple:\n class_name=smstrend;login=xxxx@sigb.net;password=xxxx;tpoa=xxxx;'),
(666,'empr','sms_msg_resa_dispo','','Text del sms enviat durant la validació d\'una reserva'),
(667,'empr','sms_msg_resa_suppr','','Text del sms enviat durant l\'eliminació d\'una reserva'),
(668,'empr','sms_msg_retard','','Text del sms enviat durant un retard'),
(669,'pmb','procedure_server_address','','Direcció del servidor de procediments remots.'),
(670,'pmb','procedure_server_credentials','','Autenticació en el servidor de procediments remots.\n1ª línia: correu electrònic\n2ª línia: contrasenya.'),
(671,'pmb','rfid_pret_mode','','Mode de funcionament del préstec:\n 0: Un document retirat de la platina es retira del préstec.\n 1: Un document retirat de la platina és conservat per a facilitar el préstec de més documents.'),
(672,'internal','emptylogstatopac','','Configuració interna, no modificar\r\n =1 si bolcat dels logs està en curs'),
(673,'fiches','active','','Mòdul \'fitxes\' activat.\n 0 : No.\n 1 : Si.'),
(674,'opac','visionneuse_allow','','Visionadora activada.\n 0 : No.\n 1 : Si'),
(677,'opac','self_checkout_url_connector','','URL de connexió en gestió per a permetre realitzar el préstec de forma autònoma.'),
(678,'finance','recouvrement_lecteur_statut','','Guardar l\'estat que prenen els lectors durant el procés de cobrament'),
(679,'thesaurus','auto_postage_search','','Activar la indexació de categories mares i filles per a la busca de ressenyes. \n 0 No, \n 1 Si'),
(680,'thesaurus','auto_postage_search_nb_descendant','','Nombre de nivells de busca de ressenyes dins de categories filles. \n *: il·limitat, \n n: nombre de nivells'),
(681,'thesaurus','auto_postage_search_nb_montant','','Nombre de nivells de busca de ressenyes dins de categories mare. \n *: il·limitat, \n n: nombre de nivells'),
(682,'opac','show_bulletin_nav','','Visualitzat d\'un navegador en els butlletins d\'un periòdic.\r\n 0 No \r\n 1 Si'),
(683,'pmb','play_pret_sound','','Reproduir alerta sonora si el préstec i la devolució es realitzen sense error? \n 0 : No.\n 1 : Si.'),
(684,'pmb','catalog_verif_js','','Script de verificació d\'entrada de ressenyes'),
(685,'opac','default_style_addon','','Afegir estils CSS a les hores ja existents?\r\n No pose el codi CSS, exemple:body {background-color: #FF0000;}'),
(686,'pmb','rfid_gates_server_url','','URL del servidor de pòrtics RFID'),
(687,'pmb','perso_sep','','Separador de valors de camp personalitzat, espai o; o, o ...'),
(688,'pmb','search_full_text','','Utilitzar un índex MySQL FULLTEXT per a la busca en els documents digitals \n 0: No \n 1: Si'),
(689,'opac','parse_html','','Activar el parseo HTML de pàgines OPAC \n 0: No \n 1: Si'),
(690,'opac','notice_enrichment','','Activar l\'enriquiment de ressenyes \n 0: No \r\n 1: Si'),
(691,'opac','show_social_network','','Activar la compartició amb les xarxes socials \r\n 0: No \r\n 1: Si'),
(692,'pmb','opac_view_activate','','Activar les vistes OPAC :\n 0 : No activat \n 1 : Activat amb la gestió clàssica \n 2 : Activat amb la gestió avançada'),
(693,'opac','opac_view_activate','','Activar les vistes OPAC :\n 0 : No activat \n 1: Activat'),
(694,'pmb','sur_location_activate','','Activar en localitzacions:\n 0 : No activado \n 1 : Activado'),
(695,'opac','sur_location_activate','','Activar en localitzacions:\n 0 : No activado \n 1 : Activado'),
(696,'pmb','opac_view_class','','Nom de la classe que substituïx a la classe opac_view per a la personalització de la gestió de les vistes OPAC'),
(697,'opac','faviconurl','','URL del fabico, si està buit=celui de PMB'),
(698,'opac','allow_affiliate_search','','Activar les busques niades en OPAC:\n 0 : No \n 1 : Si'),
(699,'acquisition','pdfrel_format_page','','Ample x Alt de la pàgina en mm'),
(700,'acquisition','pdfrel_orient_page','','Orientació de la pàgina P=Horitzontal, L=Vertical'),
(701,'acquisition','pdfrel_marges_page','','Marges de la pàgina en mm : Dalt, Baix, Dreta, Esquerra'),
(702,'acquisition','pdfrel_pos_logo','','Posició del logo: Distància des del bord esquerre de la pàgina, Distància des del bord superior de la pàgina, Ample, Alt'),
(703,'acquisition','pdfrel_pos_raison','','Posició de la Raó Social: Distància des del bord esquerre de la pàgina, Distància des del bord superior de la pàgina, Ample, Alt, Grandària de la font'),
(704,'acquisition','pdfrel_pos_date','','Posició de la Data: Distància des del bord esquerre de la pàgina, Distància des del bord superior de la pàgina, Ample, Alt, Grandària de la font'),
(705,'acquisition','pdfrel_pos_adr_rel','','Posició de la Direcció de contacte: Distància des del bord esquerre de la pàgina, Distància des del bord superior de la pàgina, Ample, Alt, Grandària de la font'),
(706,'acquisition','pdfrel_pos_adr_fou','','Posició de la Direcció del proveïdor: Distància des del bord esquerre de la pàgina, Distància des del bord superior de la pàgina, Ample, Alt, Grandària de la font'),
(707,'acquisition','pdfrel_pos_num_cli','','Posició del nombre de client: Distància des del bord esquerre de la pàgina, Distància des del bord superior de la pàgina, Ample, Alt, Grandària de la font'),
(708,'acquisition','pdfrel_pos_num','','Posició del número de comanda/pressupost: Distància des del bord esquerre de la pàgina, Ample, Alt, Grandària de la font'),
(709,'acquisition','pdfrel_text_size','','Grandària de la font del text'),
(710,'acquisition','pdfrel_pos_titre','','Posició del títol: Distància des del bord esquerre de la pàgina, Distància des del bord superior de la pàgina, Ample, Alt, Grandària de la font'),
(711,'acquisition','pdfrel_text_before','','Text abans de la taula de recordatoris'),
(712,'acquisition','pdfrel_text_after','','Text desperquè de la taula de recordatoris'),
(713,'acquisition','pdfrel_tab_rel','','Taula de recordatoris: Altura d\'esbossa, Grandària de font'),
(714,'acquisition','pdfrel_pos_footer','','Posició piule de pàgina: Distància des de la vora inferior de la pàgina, Grandària de la font'),
(715,'acquisition','pdfrel_pos_sign','','Posició de la firma: Distància des del bord esquerre de la pàgina, Ample, Alt d\'esbossa, Grandària de font'),
(716,'acquisition','pdfrel_text_sign','','Text de la firma'),
(717,'acquisition','pdfrel_by_mail','','Efectuar recordatoris per correu electrònic :\n 0 : No \n 1 : Si'),
(718,'acquisition','pdfrel_text_mail','','Text del correu electrònic'),
(719,'opac','show_perio_browser','','Mostrar el navegador de periòdics en la pàgina d\'inici de l\'OPAC.\n 0 : No.\n 1 : Si.'),
(720,'acquisition','pdfrel_pdfrtf','','Enviament de recordatoris en :\n 0 : pdf\n 1 : rtf'),
(721,'opac','show_onglet_perio_a2z','','Activar la pestanya del navegador de periòdics en OPAC.\n 0 : No.\n 1 : Si.'),
(722,'opac','avis_note_display_mode','','Mode de visualització de la nota per als avisos de ressenyes.\n 0 : Nota no visible.\n 1 : Mostrar la nota davall la forma d\'asterisc.\n 2 : Mostrar la nota baixa la forma de text.\n 3 : Mostrar la nota davall la forma de text i asteriscos.'),
(723,'opac','avis_display_mode','','Mode de visualització d\'avisos de ressenyes.\n 0 : Visible en línia al costat de la pestanya Públic/ISBD de la ressenya.\n 1 : Visible en la ressenya.'),
(724,'pmb','planificateur_allow','','Planificador activat.\n 0 : No.\n 1 : Si.'),
(725,'acquisition','pdfrel_obj_mail','','Objeto del email'),
(726,'acquisition','pdfcde_by_mail','','Efectuar els enviaments de comandes per correu electrònic :\n 0 : No \n 1 : Si'),
(727,'acquisition','pdfcde_obj_mail','','Objecte del correu electrònic'),
(728,'acquisition','pdfcde_text_mail','','Text del correu electrònic'),
(729,'acquisition','pdfdev_by_mail','','Efectuar els enviaments de sol·licituds de pressupost per correu electrònic :\n 0 : No \n 1 : Si'),
(730,'acquisition','pdfdev_obj_mail','','Objecte del correu electrònic'),
(731,'acquisition','pdfdev_text_mail','','Text del correu electrònic'),
(732,'pmb','docnum_in_database_allow','','Autoritzar l\'emmagatzematge de documents digitals en base de dades? \n 0 : No.\n 1 : Si.'),
(733,'opac','recherche_ajax_mode','','Visualitzat accelerat dels resultats de busca: capçalera únicament, la resta és carregarà després de fer clic en \"+\".\n 0: Inactiu\n 1: Actiu (per lot)\n 2: Actiu (per ressenya)'),
(734,'pmb','avis_note_display_mode','','Mode de visualització de les nota per als avisos de ressenya.\n 0 : Nota no visible.\n 1 : Mostrar la nota davall la forma d\'asterisc.\n 2 : Mostrar la nota davall la forma de text.\n 3 : Mostrar la nota davall la forma de text i asterisc.'),
(735,'cms','active','','Mòdul \'Portal\' activat.\n 0 : No.\n 1 : Si.'),
(736,'pmb','indexation_lang','','Triar l\'idioma de la indexació per defecte. (ex : fr_FR,en_UK,...,ara), si este idioma esta va buidar, serà utilitzat l\'idioma de la interfície del catalogador.'),
(737,'opac','websubscribe_show_location','','Mostrar la possibilitat que el lector puga triar la localització per a les inscripcions en línia.\n 0: No\n 1: Si'),
(738,'opac','collstate_order','','Orde de visualització dels estats de les col·leccions, en l\'orde donat, separat per comes: archempla_libelle,collstate_cote'),
(739,'opac','default_sort','','Selecccionar per defecte les busques OPAC.\nDe la forma, c_núm_6 (c per a creixent. d per a decreixent, num o text per a número i text i finalment l\'identificador del camp (veure fitxer xml sort.xml)'),
(740,'pmb','fine_precision','','Nombre de decimals per a la visualització de multes'),
(741,'opac','search_cache_duration','','Període de validesa (en segons) del caixet per a les busques OPAC'),
(742,'pmb','path_php','','Ruta absoluta de l\'interpretador PHP, local o remot'),
(743,'opac','explnum_order','','Orde de visualització dels documents digitals, en l\'orde donat, separat per comes : explnum_mimetype, explnum_nom, explnum_id'),
(744,'pmb','amende_comptabilisation','','Data en què l\'inici de la multa serà comptabilitzat \r\n 0 : a partir de la data de devolució \r\n 1 : a partir de la data de gràcia'),
(745,'pmb','pret_calcul_retard_date_debut_incluse','','Comptar la data de retorn o de recordatori com a dia de retard per a calcular la multa? \r\n 0 : No \r\n  1 : Si'),
(746,'opac','exclude_fields','','Identificació dels camps a excloure de la busca per tots els camps (llista disponible dins del fitxer includes/indexation/champ_base.xml)'),
(747,'opac','serialcirc_active','','Activar la circulació de periòdics dins de l\'OPAC \r\n 0: No \r\n 1: Si'),
(748,'pmb','bdd_subversion','','Subversion de la base de dades'),
(749,'pmb','import_modele_authorities','','Que classe d\'importació utilitzar per a les ressenyes d\'autoritats?'),
(750,'pmb','location_resa_planning','','Utilitzar la gestió de la previsió localitzada?\n 0: No\n 1: Si'),
(751,'demandes','email_demandes','','Informació per correu electrònic de l\'evolució de les comandes.\n 0 : No\n 1 : Si'),
(752,'pmb','short_loan_management','','Gestió dels préstecs curts\n 0: No\n 1: Si'),
(753,'pmb','loan_trust_management','','Gestió del monopoli del préstec\n 0: No\n x: nombre de dies entre 2 préstecs d\'un exemplar d\'una mateixa ressenya (o butlletí)'),
(754,'opac','perio_a2z_abc_search','','Busca alfabètica en la navegació de periòdics en OPAC.\n0 : No.\n1 : Si.'),
(755,'opac','perio_a2z_max_per_onglet','','Busca en el navegador de periòdics en OPAC : nombre màxim de ressenyes per pestanya.'),
(756,'pmb','indexation_docnum_ext','','Configuració de la gestió d\'accés als programs externs per a la indexació de documents digitals :\n\n Cada paràmetre es definix amb un parell : \"nom=valor\"\n Els paràmetres són separats per un \"punt i coma\".\n\n\n Exemples d\'utilització de  \"pyodconverter\", \"jodconverter\" et \"pdftotext\" :\n\npyodconverter_cmd=/opt/openoffice.org3/program/python /opt/ooo_converter/DocumentConverter.py %1s %2s;\njodconverter_cmd=/usr/bin/java -jar /opt/ooo_converter/jodconverter-2.2.2/lib/jodconverter-cli-2.2.2.jar %1s %2s;\njodconverter_url=http://localhost:8080/converter/converted/%1s;\npdftotext_cmd=/usr/bin/pdftotext -enc UTF-8 %1s -;'),
(757,'opac','notices_format_onglets','','Llista d\'id de plantilles de ressenya per a afegir a les pestanyes personalitzades en el registre de ressenya\nExemple: 1,3,ISBD,PUBLIC\nEl paràmetre notices_format ha de posar-se a 0 per a col·locar ISBD i PÚBLIC'),
(758,'opac','visionneuse_alert','','Missatge d\'advertència en l\'obertura de documents digitals.'),
(759,'opac','cms','','id de CM utilitzat en OPAC'),
(760,'pmb','expl_data','','Columnes d\'exemplars, dins de l\'orde donat, separades per comes: expl_cb,expl_fite,location_libelle,section_libelle,statut_libelle,tdoc_libelle #n : id dels camps personalitzats \r\n expl_cb és obligatori i serà va afegir si no està'),
(761,'pmb','expl_display_location_without_expl','','Mostrar la llista de localitzacions sense exemplars \n 0: No\n 1: Si'),
(762,'opac','show_group_checkout','','El responsable d\'un grup de lectors veu els préstecs del seu grup\n 0: No\n 1: Si'),
(763,'opac','facette_in_bandeau_2','','La navegació per facettes apareix en el bàner o en el bàner 2 \n0 : en el bàner\n1 : en el bàner 2'),
(764,'opac','autolevel2','','0 : mode normal de busca.\n1 : Mostrar el resultat de la busca per tots els camps després del càlcul de nivell 1 de busca.\n2 : Mostrar directament el resultat de la busca per tots els camps sense passar pel càlcul de nivell 1 de busca'),
(765,'opac','first_page_params','','Estructura JSON recapitulant els paràmetres a inicialitzar en la pàgina principal :\nExemple : \n{\n\"lvl\":\"cmspage\",\n\"pageid\":2\n}'),
(766,'opac','show_links_invisible_docnums','','Mostrar els enllaços als documents digitals no visibles en mode fora de línia. (No funciona per als drets d\'accés).\n 0 : No.\n1 : Si.'),
(767,'pmb','img_folder','','Directori d\'emmagatzematge de les imatges'),
(768,'pmb','img_url','','URL d\'accés al directori d\'imatges  (pmb_img_folder)'),
(769,'pmb','book_pics_msg','','Missatge en la visualització de les miniatures de les ressenyes corresponent a la ruta proporcionada pel paràmetre book_pics_url'),
(770,'opac','book_pics_msg','','Missatge en la visualització de les miniatures de les ressenyes corresponent a la ruta proporcionada pel paràmetre book_pics_url'),
(771,'opac','visionneuse_alert_doctype','','Llista de tipus de documents per als quals es generarà una alerta (separats per comes).'),
(772,'pmb','archive_warehouse','','Identificació del magatzem d\'arxivat per a l\'eliminació de ressenyes..'),
(773,'pmb','printer_name','','Nom de la impressora de tiquets de préstec, utilitzant l\'applet jzebra. El nom de la impressora ha de coincidir amb la classe desenrotllada específicament per a la seua utilització.\nExemple: Denominació de la impressora\'metapace\' per a utilitzar el driver  classes/printer/metapace.class.php'),
(774,'empr','groupes_localises','','Grup de lectors localitzats per a informe del responsable \n0: No \n1: Si'),
(775,'opac','allow_simili_search','','Activar les busques semblants en una ressenya :\n0 : No\n1 : Activar la busca \"En la mateixa secció\" i \"Potser li interesse\"\n2 : Activar només la busca \"En la mateixa secció\"\n3 : Activar només la busca \"Potser li interesse\"'),
(776,'opac','notices_depliable_plus','','Imatge a utilitzar davant d\'un títol de ressenya plegat'),
(777,'opac','notices_depliable_moins','','Imatge a utilitzar davant d\'un títol de ressenya desplegat'),
(778,'pmb','pret_groupement','','Activar el préstec d\'exemplars reagrupats en un només lot. La gestió dels grups es realitza en Circulació / Grup d\'exemplars :\n 0 : No \n 1 : Si'),
(779,'transferts','regroupement_depart','','Activar el reagrupament d\'eixides \n 0: No \n 1: Si'),
(780,'pmb','rfid_afi_security_codes','','Gestió de l\'antirobatori pel registre AFI.\nEl primer valor correspon a l\'antirobatori activat, el segon correspon a l\'antirobatori desactivat.\nExemple: 07,C2 '),
(816,'pmb','num_carte_auto','','Número de carnet de lector automàtic?\n 0:No (si s\'utilitzen carnets preimpresos\n 1: Si, completament numèric\n 2,a,b,c: Si amb prefix: a=longitud del prefix, b=nombre de xifres de la part numèrica, c=prefix fix (opcional)\n 3: funció de generació específica dins del fitxer anomenat de la mateixa manera, a col·locar dins de pmb/circ/empr'),
(1148,'acquisition','mel_rej_cor','','Cos del correu electrònic de rebuig de suggeriment'),
(1166,'cms','url_base_cms_build','','url de construcció de CM de l\'OPAC'),
(945,'categories','show_only_last','','En la fitxa d\'una ressenya : \n 0 mostrar tot \n 1 : mostrar únicament l\'últim full de l\'arbre de la categoria'),
(1163,'opac','simple_search_suggestions','','Activar el suggeriment de paraules en la busca simple a través de la terminació\n0 : Desactivar\n1 : Activar\n\nNB : Esta funció necessita la instal·lació de l\'extensió levenshtein en MySQL'),
(1164,'opac','stemming_active','','Activar el stemming en la busca\n0 : Desactivar\n1 : Activar\n'),
(1181,'pmb','logs_exclude_robots','','¿Excloure els robots en els logs OPAC? \n0:No \n1:Si \n Posar seguit d\'una coma per a excloure eventualment els logs OPAC provinents de certes direccions IP separades al seu torn per comes (per exemple: 1,127.0.0.1,192.168.0.1)'),
(1182,'pmb','notice_img_pics_max_size','','Grandària màxima de les miniatures carregades de les ressenyes, en longitud o en alçària'),
(1183,'pmb','psexec_cmd','','Paràmetres d\'execució de psexec (planificador davall windows)\n Afegir l\'opció -accepteula a les versions mes recents'),

(1185,'opac','show_bandeau_2','','Mostrar el banner_2?\n 0 : No \n 1 : Si'),
(1186,'opac','param_social_network','','Taula de configuració de l\'API de de gestió de les interconnexions amb xarxes socials.\n			Formato JSON.\n			Ejemplo :\n			{\n			\"token\":\"ra-4d9b1e202c30dea1\",\n			\"version\":\"300\",\n			\"buttons\":[\n			{\n			\"attributes\":{\n			\"class\":\"addthis_button_preferred_1\"\n			}\n			},\n			{\n			\"attributes\":{\n			\"class\":\"addthis_button_preferred_2\"\n			}\n			},\n			{\n			\"attributes\":{\n			\"class\":\"addthis_button_preferred_3\"\n			}\n			},\n			{\n			\"attributes\":{\n			\"class\":\"addthis_button_preferred_4\"\n			}\n			},\n			{\n			\"attributes\":{\n			\"class\":\"addthis_button_compact\"\n			}\n			},\n			{\n			\"attributes\":{\n			\"class\":\"addthis_counter addthis_bubble_style\"\n			}\n			}\n			],\n			\"toolBoxParams\":{\n			\"class\":\"addthis_toolbox addthis_default_style addthis_32x32_style\"\n			},\n			\"addthis_share\":{\n			\n			},\n			\"addthis_config\":{\n			\"data_track_addressbar\":true\n			}\n			}'),
(1187,'opac','default_sort_list','','Afegir un guerxo de selecció a una selecció? \n 0 : No \n 1 : Si \nSepare amb una coma per a l\'addició de noves seleccions d\'esta manera: c_num_6|Etiqueta;d_text_7|Etiqueta 2;c_num_5|Etiqueta 3\n\nc per a creixent, d per a decreixent\nnum o text per a número o text\nidentificación del camp (veure el fitxer xml sort.xml)\netiqueta de selecció (opcional)'),
(1188,'transferts','pret_demande_statut','','Aplicar este estat abans de la validació'),
(1189,'opac','perio_a2z_show_bulletin_notice','','Mostrar la ressenya de butlletí en el navegador de periòdics'),
(1190,'pmb','procs_force_execution','','Permetre l\'execució forçada de procediments'),
(1191,'opac','draggable','','Permet activar arrastar i soltar en la cistella en la visualització de ressenyes en l\'OPAC'),
(1192,'cms','cache_ttl','','Duració de la vida del caixet dels marcs del portal (en segons)'),
(1193,'opac','meta_description','','Contingut de la meta-etiqueta descripció per als motors de busca'),
(1194,'opac','meta_keywords','','Contingut de la meta-etiqueta paraules clau per als motors de busca'),
(1195,'opac','meta_author','','Contingut de la meta-etiqueta autor per als motors de busca'),
(1196,'pmb','html_allow_expl_cote','','Autoritzar el codi HTML en les signatures de les ressenyes? \n 0 : No \n 1 : Si?'),
(1197,'pmb','serialcirc_subst','','Nom del fitxer per a personalitzar la impressió de la llista de circulació de periòdics'),
(1198,'pmb','serial_thumbnail_url_article','','Precàrrega de la url de la vinyeta de recompte amb la url de la vinyeta de la ressenya mare en el catàleg de periòdics? \n 0 : No \n 1 : Si'),
(1199,'pmb','mail_delay','','Temps d\'espera en mili-segons entre cada enviament de correu electrònic en un lot. \n 0 : No esperar'),
(1200,'pmb','curl_timeout','','Timeout cURL (en segons) per a la verificació de vincles'),
(1201,'empr','allow_prolong_members_group','','Autoritzar la prolongació agrupada d\'inscripcions dels membres d\'un grup? \n 0 : No \n 1 : Si'),
(1202,'thesaurus','auto_index_notice_fields','','Llista de camps de ressenya a utilitzar parell a la indexació automàtica.\n\n Sintaxi: nom_camp=pes_indexation;\n\n El nom de camps s\'especifica en el fitxer XML \"pmb/includes/notice/notice.xml\"\n El pes de la indexación és un valor de 0.00 à 1. (Si este no és precisat, el pes és 1)\n\n Exemple :\n\ntit1=1.00;n_resume=0.5;'),
(1203,'thesaurus','auto_index_search_param','','Sobrecarga de paràmetres de busca de la indexació automàtica.\n Sintaxi: parametre=valor;\n\n Llestes de paŕametros:\n\nmax_relevant_words = 20 (nom màxim de paraules i lemes de la ressenya a tindre en compte en el càlcul)\n\nautoindex_deep_ràtio = 0.05 (ràtio de la profunditat de terme en el tesaurus)\nautoindex_stem_ràtio = 0.80 (ràtio de la ponderació dels lemes / paraules)\n\nautoindex_max_up_distance = 2 (distància màxima de busca dins dels terme genèric del tesaurus)\nautoindex_max_up_ràtio = 0.01 (ponderació dels terme genèric)\n\nautoindex_max_down_distance = 2 (distància màxima de busca en el tèrmit específic del tesaurus)\nautoindex_max_down_ràtio = 0.01 (ponderació dels tèrmit específic)\n\nautoindex_see_also_ràtio = 0.01 (sobreponderació dels terme del tesaurus)\n\nautoindex_distance_type = 1 (càlcul de distància d\'1 a 4)\nautoindex_distance_ràtio = 0.50 (ràtio de ponderació de la distància entre els paraules trobades i el terme d\'una expressió del tesaurus)\n\nmax_relevant_terms = 10 (nom màxim de termes tornats)'),
(1204,'empr','abonnement_default_debit','','Triar per defecte la prolongació dels lectors. \n 0 : No carregar la subscripció \n 1 : Carregar la subscripció sense la fiança \n 2 : Carregar la subscripció i la fiança'),
(1184,'pmb','synchro_rdf','','Activar la sincronització rdf. \n 0: No \n 1: Si l\'activació d\'este paràmetre requerix la reindexació )'),
(1172,'opac','websubscribe_num_carte_auto','','Número de carnet de lector automàtic? \n 2,a,b,c: Si amb prefix: a=longitud del prefix, b=nombre de xifres de la part numèrica, c=prefix fix (opcional) \n 3, funció: funció de generació específica anomenat de la mateixa manera per a col·locar en pmb/opac_css/circ/empr'),
(1205,'opac','print_template_default','','En la impressió de cistelles, identificació de la plantilla de ressenya utilitzada per defecte. Si esta buida o a 0, s\'utilitzarà la plantilla clàssica'),
(1206,'pmb','show_permalink','','Mostrar l\'enllaç permanent de l\'OPAC en gestió? \n 0 : No.\n 1 : S'),
(1207,'pmb','expl_show_lastempr','','Mostrar el prestatari precedent en la fitxa de l\'exemplar? \n 0 : No.\n 1 : Si.'),
(1208,'pmb','gestion_financiere_caisses','','Activar la gestió de caixes en gestió financera? \n 0 : No.\n 1 : Si.'),
(1209,'pmb','diarization_docnum','','Activar la segmentació de documents digitals vídeo o àudio 0 : No activat 1 : Activat'),
(1210,'opac','default_sort_display','','Mostrar la descripció de la selecció aplicada per defecte en el resultat de la busca? \n 0 : No \n 1 : Si'),
(1211,'opac','show_bannettes','','Mostrar les bannettes en la pàgina d\'inici de l\'OPAC.\n 0 : No.\n 1 : Si.'),
(1212,'opac','facettes_ajax','','Carregar les facettes en ajax\n0 : No\n1 : Si'),
(1213,'opac','search_all_keep_empty_words','','Conservar les paraules buides per a les autoritats dins de la busca per tots els camps\n0 : No\n1 : Si'),
(1214,'pmb','pret_already_loaned','','Activar la trampa en préstec si el document ja ha sigut prestat al lector. Necessita l\'activació de l\'arxiu dels préstecs\n0 : No\n1 : Si'),
(1215,'opac','nb_notices_similaires','','Nombre de ressenyes semblants a mostrar al desplegar una ressenya.\nValor màx= 6.'),
(1216,'opac','notice_reduit_format_similaire','','Format de visualització reduït de ressenyes semblants :\n 0 = títol+autor principal\n 1 = títol+autor principal+data d\'edició\n 2 = títol+autor principal+data d\'edició + ISBN\n 3 = només títol\n P 1,2,3 = títol+autor+camps personalitzats id 1 2 3\n E 1,2,3 = títol+autor+editor+camps personalitzats id 1 2 3\n T = tit1+tit4\n 4 = títol+títol paral·lel+autor principal\n H 1 = id d\'una plantilla de ressenya'),
(1217,'opac','search_noise_limit_type','','Fixar els resultats de busca en funció de la rellevància. \n0 : No \n1 : Retirar el resultat si esta per davall de la mitja-desviació típica\n2,ratio : Retirar el resultat si esta per davall de la mitja-ràtio de la desviació típica (ex: 2,1.96)\n3,ratio : Retirar el resultat si esta per davall d\'un ràtio de la màxima rellevància (ex: 3,0.25 elimar tot que seguisca inferior a 25% de la màxima rellevància)'),
(1218,'opac','search_relevant_with_frequency','','Utilitzar la freqüència d\'aparició de paraules dins de les ressenyes per al càlcul de la rellevància.\n0 : No \n1 : Si'),
(1219,'empr','prolong_calc_date_adhes_depassee','','Si la data de subscripció esta sobrepassada, el càlcul de la prolongació es farà a partir de :\n 0 : la data de fi de la subscripció\n 1 : la data actual'),
(1171,'opac','bannette_priv_periodicite','','Periocidad de l\'enviament per defecte en la creació de bannette privada (en dies)'),
(1220,'opac','show_subscribed_bannettes','','Mostrar les bannettes a les que esta subscrit el lector en la pàgina d\'inici de l\'OPAC :\n0 : No.\n1 : Si.'),
(1173,'pdfcartelecteur','printer_card_handler','','Gestionar la impressió:\n 1=script \"print.cb.php"\\n 2=applet jzebra \n 3= petició ajax'),
(1221,'opac','show_public_bannettes','','Mostrar les bannettes seleccionades en la pàgina d\'inici OPAC:\n 0:No.\n 1:Si'),
(1223,'pmb','default_style_addon','','Afegir estils CSS als fulls d\'estil ja incloses? \n No pose el codi CSS, exemple:body {background-color: #FF0000;}'),
(1222,'pdfcartelecteur','printer_card_name','','Nom de la impressora'),
(1174,'pdfcartelecteur','printer_card_url','','Direcció de la impressora'),
(1175,'pmb','notice_img_folder_id','','Directori de càrrega de les miniatures de les ressenyes'),
(1176,'pmb','autorites_verif_js','','Script de verificació de l\'entrada d\'autoritats'),
(1177,'opac','resa_cart','','Configuració per a ocultar/mostrar la reserva per cistella \n 0: No \n 1:Si'),
(1178,'pmb','print_expl_default','','En la impressió de cistelles, imprimir els exemplars marcats per defecte: \n 0: No \n 1:Si'),
(1179,'opac','collstate_data','','Columnes  dels estats de les col·leccions, dins de l\'orde donat, separades per comes :location_libelle,emplacement_libelle,cote,type_libelle,statut_opac_libelle,origine,state_collections,archive,lacune,surloc_libelle,note
Els valors possibles són els propis de la classe PHP \"pmb/opac_css/classes/collstate.class.php"\.'),
(1180,'transferts','retour_action_resa','','Generar una transferència per a respondre a una reserva després de la devolució d\'un exemplar. \n 0: No \n 1:Si');

UPDATE parametres INNER JOIN parametres_bak

ON parametres_bak.type_param=parametres.type_param AND parametres_bak.sstype_param = parametres.sstype_param

    SET parametres.comment_param=parametres_bak.comment_param;
     

DROP TABLE IF EXISTS parametres_bak;

SET SQL_SAFE_UPDATES=1;


